/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         CISAparse
#define yylex           CISAlex
#define yyerror         CISAerror
#define yydebug         CISAdebug
#define yynerrs         CISAnerrs
#define yylval          CISAlval
#define yychar          CISAchar

/* First part of user prologue.  */
#line 9 "CISA.y"

#include <stdio.h>
#include <math.h>
#include <string>
#include <vector>

#include "visa_igc_common_header.h"
#include "Common_ISA.h"
#include "Common_ISA_util.h"
#include "Common_ISA_framework.h"
#include "JitterDataStruct.h"
#include "VISAKernel.h"

static int lscCheckExecSize(
    LSC_SFID sfid,
    LSC_OP op,
    LSC_DATA_ORDER data_order,
    int exec_size);

//VISA_Type variable_declaration_and_type_check(char *var, Common_ISA_Var_Class type);
void CISAerror(CISA_IR_Builder* builder, char const* msg);
int yylex(CISA_IR_Builder *pBuilder);
extern int CISAlineno;


static bool ParseAlign(CISA_IR_Builder* pBuilder, const char *sym, VISA_Align &value);
static VISA_Align AlignBytesToVisaAlignment(int bytes);
static int DataTypeSizeOf(VISA_Type type);
static bool ParseEMask(CISA_IR_Builder* pBuilder, const char* sym, VISA_EMask_Ctrl &emask);




//
// check if the cond is true.
// if cond is false, then print errorMessage (syntax error) and YYABORT
#define MUST_HOLD(cond, errorMessage) \
  {if (!(cond)) {pBuilder->RecordParseError(CISAlineno, errorMessage); YYABORT;}}
#define PARSE_ERROR_AT(LINE,...)\
  {pBuilder->RecordParseError(LINE, __VA_ARGS__); YYABORT;}
#define PARSE_ERROR(...)\
    PARSE_ERROR_AT(CISAlineno, __VA_ARGS__)

// Use this to wrap API calls that return false, nullptr, or 0 on failure
// It's assumed that the API call reported the parse error
#define ABORT_ON_FAIL(X) \
    do \
        if (!(X)) \
            YYABORT;\
    while (0)
#define TRACE(S) \
    do { \
      if (CISAout && pBuilder->debugParse()) \
          fprintf(CISAout, "line %d: %s", CISAlineno, S); \
    } while (0)

std::deque<const char*> switchLabels;
char * switch_label_array[32];
std::vector<VISA_opnd*> RTRWOperands;
int num_parameters;

VISA_RawOpnd* rawOperandArray[16];

// global var for non-kernel attribute option.
// The var needs to be cleared before each use.
std::vector<attr_gen_struct*> AttrOptVar;

#ifdef _MSC_VER
#pragma warning(disable:4065; disable:4267)
#endif


#line 151 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "CISA.tab.hpp"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ALIGN_KEYWORD = 3,              /* ALIGN_KEYWORD  */
  YYSYMBOL_ATOMIC_SUB_OP = 4,              /* ATOMIC_SUB_OP  */
  YYSYMBOL_DIRECTIVE_DECL = 5,             /* DIRECTIVE_DECL  */
  YYSYMBOL_DIRECTIVE_FUNC = 6,             /* DIRECTIVE_FUNC  */
  YYSYMBOL_DIRECTIVE_FUNCDECL = 7,         /* DIRECTIVE_FUNCDECL  */
  YYSYMBOL_DIRECTIVE_GLOBAL_FUNC = 8,      /* DIRECTIVE_GLOBAL_FUNC  */
  YYSYMBOL_DIRECTIVE_IMPLICIT = 9,         /* DIRECTIVE_IMPLICIT  */
  YYSYMBOL_DIRECTIVE_INPUT = 10,           /* DIRECTIVE_INPUT  */
  YYSYMBOL_DIRECTIVE_KERNEL = 11,          /* DIRECTIVE_KERNEL  */
  YYSYMBOL_DIRECTIVE_KERNEL_ATTR = 12,     /* DIRECTIVE_KERNEL_ATTR  */
  YYSYMBOL_DIRECTIVE_PARAMETER = 13,       /* DIRECTIVE_PARAMETER  */
  YYSYMBOL_DIRECTIVE_VERSION = 14,         /* DIRECTIVE_VERSION  */
  YYSYMBOL_ALIAS_EQ = 15,                  /* ALIAS_EQ  */
  YYSYMBOL_ALIGN_EQ = 16,                  /* ALIGN_EQ  */
  YYSYMBOL_ATTR_EQ = 17,                   /* ATTR_EQ  */
  YYSYMBOL_OFFSET_EQ = 18,                 /* OFFSET_EQ  */
  YYSYMBOL_NUM_ELTS_EQ = 19,               /* NUM_ELTS_EQ  */
  YYSYMBOL_V_NAME_EQ = 20,                 /* V_NAME_EQ  */
  YYSYMBOL_SIZE_EQ = 21,                   /* SIZE_EQ  */
  YYSYMBOL_V_TYPE_EQ_G = 22,               /* V_TYPE_EQ_G  */
  YYSYMBOL_V_TYPE_EQ_P = 23,               /* V_TYPE_EQ_P  */
  YYSYMBOL_V_TYPE_EQ_A = 24,               /* V_TYPE_EQ_A  */
  YYSYMBOL_V_TYPE_EQ_S = 25,               /* V_TYPE_EQ_S  */
  YYSYMBOL_V_TYPE_EQ_T = 26,               /* V_TYPE_EQ_T  */
  YYSYMBOL_CPS = 27,                       /* CPS  */
  YYSYMBOL_NON_UNIFORM_SAMPLER = 28,       /* NON_UNIFORM_SAMPLER  */
  YYSYMBOL_PIXEL_NULL_MASK = 29,           /* PIXEL_NULL_MASK  */
  YYSYMBOL_RAW_SENDC_STRING = 30,          /* RAW_SENDC_STRING  */
  YYSYMBOL_RAW_SENDSC_EOT_STRING = 31,     /* RAW_SENDSC_EOT_STRING  */
  YYSYMBOL_RAW_SENDSC_STRING = 32,         /* RAW_SENDSC_STRING  */
  YYSYMBOL_RAW_SENDS_EOT_STRING = 33,      /* RAW_SENDS_EOT_STRING  */
  YYSYMBOL_RAW_SENDS_STRING = 34,          /* RAW_SENDS_STRING  */
  YYSYMBOL_RAW_SEND_STRING = 35,           /* RAW_SEND_STRING  */
  YYSYMBOL_SAT = 36,                       /* SAT  */
  YYSYMBOL_SRCMOD_ABS = 37,                /* SRCMOD_ABS  */
  YYSYMBOL_SRCMOD_NEG = 38,                /* SRCMOD_NEG  */
  YYSYMBOL_SRCMOD_NEGABS = 39,             /* SRCMOD_NEGABS  */
  YYSYMBOL_SRCMOD_NOT = 40,                /* SRCMOD_NOT  */
  YYSYMBOL_BFN_OP = 41,                    /* BFN_OP  */
  YYSYMBOL_DPAS_OP = 42,                   /* DPAS_OP  */
  YYSYMBOL_BF_CVT_OP = 43,                 /* BF_CVT_OP  */
  YYSYMBOL_NBARRIER_SIGNAL = 44,           /* NBARRIER_SIGNAL  */
  YYSYMBOL_NBARRIER_WAIT = 45,             /* NBARRIER_WAIT  */
  YYSYMBOL_ITYPE = 46,                     /* ITYPE  */
  YYSYMBOL_DECL_DATA_TYPE = 47,            /* DECL_DATA_TYPE  */
  YYSYMBOL_DFTYPE = 48,                    /* DFTYPE  */
  YYSYMBOL_FTYPE = 49,                     /* FTYPE  */
  YYSYMBOL_HFTYPE = 50,                    /* HFTYPE  */
  YYSYMBOL_VTYPE = 51,                     /* VTYPE  */
  YYSYMBOL_COND_MOD = 52,                  /* COND_MOD  */
  YYSYMBOL_LANGLE = 53,                    /* LANGLE  */
  YYSYMBOL_RANGLE = 54,                    /* RANGLE  */
  YYSYMBOL_LBRACK = 55,                    /* LBRACK  */
  YYSYMBOL_RBRACK = 56,                    /* RBRACK  */
  YYSYMBOL_IND_LBRACK = 57,                /* IND_LBRACK  */
  YYSYMBOL_LPAREN = 58,                    /* LPAREN  */
  YYSYMBOL_RPAREN = 59,                    /* RPAREN  */
  YYSYMBOL_LBRACE = 60,                    /* LBRACE  */
  YYSYMBOL_RBRACE = 61,                    /* RBRACE  */
  YYSYMBOL_DOT = 62,                       /* DOT  */
  YYSYMBOL_COMMA = 63,                     /* COMMA  */
  YYSYMBOL_SEMI = 64,                      /* SEMI  */
  YYSYMBOL_COLON = 65,                     /* COLON  */
  YYSYMBOL_SLASH = 66,                     /* SLASH  */
  YYSYMBOL_PERCENT = 67,                   /* PERCENT  */
  YYSYMBOL_EQUALS = 68,                    /* EQUALS  */
  YYSYMBOL_PLUS = 69,                      /* PLUS  */
  YYSYMBOL_MINUS = 70,                     /* MINUS  */
  YYSYMBOL_TIMES = 71,                     /* TIMES  */
  YYSYMBOL_AMP = 72,                       /* AMP  */
  YYSYMBOL_CIRC = 73,                      /* CIRC  */
  YYSYMBOL_PIPE = 74,                      /* PIPE  */
  YYSYMBOL_TILDE = 75,                     /* TILDE  */
  YYSYMBOL_BANG = 76,                      /* BANG  */
  YYSYMBOL_QUESTION = 77,                  /* QUESTION  */
  YYSYMBOL_LEQ = 78,                       /* LEQ  */
  YYSYMBOL_GEQ = 79,                       /* GEQ  */
  YYSYMBOL_EQ = 80,                        /* EQ  */
  YYSYMBOL_NEQ = 81,                       /* NEQ  */
  YYSYMBOL_SHL = 82,                       /* SHL  */
  YYSYMBOL_SHRS = 83,                      /* SHRS  */
  YYSYMBOL_SHRZ = 84,                      /* SHRZ  */
  YYSYMBOL_LABEL = 85,                     /* LABEL  */
  YYSYMBOL_IDENT = 86,                     /* IDENT  */
  YYSYMBOL_BUILTIN_NULL = 87,              /* BUILTIN_NULL  */
  YYSYMBOL_BUILTIN = 88,                   /* BUILTIN  */
  YYSYMBOL_STRING_LIT = 89,                /* STRING_LIT  */
  YYSYMBOL_NEWLINE = 90,                   /* NEWLINE  */
  YYSYMBOL_RTWRITE_OPTION = 91,            /* RTWRITE_OPTION  */
  YYSYMBOL_MEDIA_MODE = 92,                /* MEDIA_MODE  */
  YYSYMBOL_OWORD_MODIFIER = 93,            /* OWORD_MODIFIER  */
  YYSYMBOL_SAMPLER_CHANNEL = 94,           /* SAMPLER_CHANNEL  */
  YYSYMBOL_CHANNEL_OUTPUT = 95,            /* CHANNEL_OUTPUT  */
  YYSYMBOL_EXECMODE = 96,                  /* EXECMODE  */
  YYSYMBOL_CNTRL = 97,                     /* CNTRL  */
  YYSYMBOL_FENCE_OPTIONS = 98,             /* FENCE_OPTIONS  */
  YYSYMBOL_ADDR_ADD_OP = 99,               /* ADDR_ADD_OP  */
  YYSYMBOL_UNARY_LOGIC_OP = 100,           /* UNARY_LOGIC_OP  */
  YYSYMBOL_BINARY_LOGIC_OP = 101,          /* BINARY_LOGIC_OP  */
  YYSYMBOL_TERNARY_LOGIC_OP = 102,         /* TERNARY_LOGIC_OP  */
  YYSYMBOL_QUATERNARY_LOGIC_OP = 103,      /* QUATERNARY_LOGIC_OP  */
  YYSYMBOL_SEL_OP = 104,                   /* SEL_OP  */
  YYSYMBOL_MIN_OP = 105,                   /* MIN_OP  */
  YYSYMBOL_MAX_OP = 106,                   /* MAX_OP  */
  YYSYMBOL_ANTI_TRIG_OP = 107,             /* ANTI_TRIG_OP  */
  YYSYMBOL_MATH2_OP = 108,                 /* MATH2_OP  */
  YYSYMBOL_MATH3_OP = 109,                 /* MATH3_OP  */
  YYSYMBOL_ARITH2_OP = 110,                /* ARITH2_OP  */
  YYSYMBOL_ARITH3_OP = 111,                /* ARITH3_OP  */
  YYSYMBOL_ARITH4_OP = 112,                /* ARITH4_OP  */
  YYSYMBOL_ARITH4_OP2 = 113,               /* ARITH4_OP2  */
  YYSYMBOL_CMP_OP = 114,                   /* CMP_OP  */
  YYSYMBOL_SVM_OP = 115,                   /* SVM_OP  */
  YYSYMBOL_SVM_SCATTER_OP = 116,           /* SVM_SCATTER_OP  */
  YYSYMBOL_SVM_GATHER4SCALED_OP = 117,     /* SVM_GATHER4SCALED_OP  */
  YYSYMBOL_SVM_SCATTER4SCALED_OP = 118,    /* SVM_SCATTER4SCALED_OP  */
  YYSYMBOL_SVM_ATOMIC_OP = 119,            /* SVM_ATOMIC_OP  */
  YYSYMBOL_OWORD_OP = 120,                 /* OWORD_OP  */
  YYSYMBOL_MEDIA_OP = 121,                 /* MEDIA_OP  */
  YYSYMBOL_SCATTER_OP = 122,               /* SCATTER_OP  */
  YYSYMBOL_SCATTER_TYPED_OP = 123,         /* SCATTER_TYPED_OP  */
  YYSYMBOL_SCATTER_SCALED_OP = 124,        /* SCATTER_SCALED_OP  */
  YYSYMBOL_SCATTER4_SCALED_OP = 125,       /* SCATTER4_SCALED_OP  */
  YYSYMBOL_BARRIER_OP = 126,               /* BARRIER_OP  */
  YYSYMBOL_SBARRIER_SIGNAL = 127,          /* SBARRIER_SIGNAL  */
  YYSYMBOL_SBARRIER_WAIT = 128,            /* SBARRIER_WAIT  */
  YYSYMBOL_DWORD_ATOMIC_OP = 129,          /* DWORD_ATOMIC_OP  */
  YYSYMBOL_TYPED_ATOMIC_OP = 130,          /* TYPED_ATOMIC_OP  */
  YYSYMBOL_SAMPLE_OP = 131,                /* SAMPLE_OP  */
  YYSYMBOL_SAMPLE_UNORM_OP = 132,          /* SAMPLE_UNORM_OP  */
  YYSYMBOL_VME_IME_OP = 133,               /* VME_IME_OP  */
  YYSYMBOL_VME_SIC_OP = 134,               /* VME_SIC_OP  */
  YYSYMBOL_VME_FBR_OP = 135,               /* VME_FBR_OP  */
  YYSYMBOL_BRANCH_OP = 136,                /* BRANCH_OP  */
  YYSYMBOL_RET_OP = 137,                   /* RET_OP  */
  YYSYMBOL_IFCALL = 138,                   /* IFCALL  */
  YYSYMBOL_FCALL = 139,                    /* FCALL  */
  YYSYMBOL_FADDR = 140,                    /* FADDR  */
  YYSYMBOL_SWITCHJMP_OP = 141,             /* SWITCHJMP_OP  */
  YYSYMBOL_MOVS_OP = 142,                  /* MOVS_OP  */
  YYSYMBOL_SETP_OP = 143,                  /* SETP_OP  */
  YYSYMBOL_MOV_OP = 144,                   /* MOV_OP  */
  YYSYMBOL_FILE_OP = 145,                  /* FILE_OP  */
  YYSYMBOL_LOC_OP = 146,                   /* LOC_OP  */
  YYSYMBOL_CACHE_FLUSH_OP = 147,           /* CACHE_FLUSH_OP  */
  YYSYMBOL_WAIT_OP = 148,                  /* WAIT_OP  */
  YYSYMBOL_FENCE_GLOBAL_OP = 149,          /* FENCE_GLOBAL_OP  */
  YYSYMBOL_FENCE_LOCAL_OP = 150,           /* FENCE_LOCAL_OP  */
  YYSYMBOL_FENCE_SW_OP = 151,              /* FENCE_SW_OP  */
  YYSYMBOL_YIELD_OP = 152,                 /* YIELD_OP  */
  YYSYMBOL_SAMPLE_3D_OP = 153,             /* SAMPLE_3D_OP  */
  YYSYMBOL_LOAD_3D_OP = 154,               /* LOAD_3D_OP  */
  YYSYMBOL_SAMPLE4_3D_OP = 155,            /* SAMPLE4_3D_OP  */
  YYSYMBOL_RESINFO_OP_3D = 156,            /* RESINFO_OP_3D  */
  YYSYMBOL_SAMPLEINFO_OP_3D = 157,         /* SAMPLEINFO_OP_3D  */
  YYSYMBOL_RTWRITE_OP_3D = 158,            /* RTWRITE_OP_3D  */
  YYSYMBOL_URBWRITE_OP_3D = 159,           /* URBWRITE_OP_3D  */
  YYSYMBOL_LIFETIME_START_OP = 160,        /* LIFETIME_START_OP  */
  YYSYMBOL_LIFETIME_END_OP = 161,          /* LIFETIME_END_OP  */
  YYSYMBOL_AVS_OP = 162,                   /* AVS_OP  */
  YYSYMBOL_CALL_OP = 163,                  /* CALL_OP  */
  YYSYMBOL_PRED_CNTL = 164,                /* PRED_CNTL  */
  YYSYMBOL_F32_LIT = 165,                  /* F32_LIT  */
  YYSYMBOL_F64_LIT = 166,                  /* F64_LIT  */
  YYSYMBOL_DEC_LIT = 167,                  /* DEC_LIT  */
  YYSYMBOL_HEX_LIT = 168,                  /* HEX_LIT  */
  YYSYMBOL_BUILTIN_SIZEOF = 169,           /* BUILTIN_SIZEOF  */
  YYSYMBOL_BUILTIN_DISPATCH_SIMD_SIZE = 170, /* BUILTIN_DISPATCH_SIMD_SIZE  */
  YYSYMBOL_QW_SCATTER_OP = 171,            /* QW_SCATTER_OP  */
  YYSYMBOL_LSC_CACHING_OPT = 172,          /* LSC_CACHING_OPT  */
  YYSYMBOL_LSC_ADDR_SIZE_TK = 173,         /* LSC_ADDR_SIZE_TK  */
  YYSYMBOL_LSC_DATA_SHAPE_TK = 174,        /* LSC_DATA_SHAPE_TK  */
  YYSYMBOL_LSC_DATA_SHAPE_TK_CHMASK = 175, /* LSC_DATA_SHAPE_TK_CHMASK  */
  YYSYMBOL_LSC_DATA_SHAPE_TK_BLOCK2D = 176, /* LSC_DATA_SHAPE_TK_BLOCK2D  */
  YYSYMBOL_LSC_AM_FLAT = 177,              /* LSC_AM_FLAT  */
  YYSYMBOL_LSC_AM_BTI = 178,               /* LSC_AM_BTI  */
  YYSYMBOL_LSC_AM_BSS = 179,               /* LSC_AM_BSS  */
  YYSYMBOL_LSC_AM_SS = 180,                /* LSC_AM_SS  */
  YYSYMBOL_LSC_FENCE_OP_TYPE = 181,        /* LSC_FENCE_OP_TYPE  */
  YYSYMBOL_LSC_FENCE_SCOPE = 182,          /* LSC_FENCE_SCOPE  */
  YYSYMBOL_LSC_SFID_UNTYPED_TOKEN = 183,   /* LSC_SFID_UNTYPED_TOKEN  */
  YYSYMBOL_LSC_SFID_TYPED_TOKEN = 184,     /* LSC_SFID_TYPED_TOKEN  */
  YYSYMBOL_LSC_LOAD_MNEMONIC = 185,        /* LSC_LOAD_MNEMONIC  */
  YYSYMBOL_LSC_LOAD_STRIDED_MNEMONIC = 186, /* LSC_LOAD_STRIDED_MNEMONIC  */
  YYSYMBOL_LSC_LOAD_BLOCK2D_MNEMONIC = 187, /* LSC_LOAD_BLOCK2D_MNEMONIC  */
  YYSYMBOL_LSC_STORE_MNEMONIC = 188,       /* LSC_STORE_MNEMONIC  */
  YYSYMBOL_LSC_STORE_STRIDED_MNEMONIC = 189, /* LSC_STORE_STRIDED_MNEMONIC  */
  YYSYMBOL_LSC_STORE_BLOCK2D_MNEMONIC = 190, /* LSC_STORE_BLOCK2D_MNEMONIC  */
  YYSYMBOL_LSC_ATOMIC_MNEMONIC = 191,      /* LSC_ATOMIC_MNEMONIC  */
  YYSYMBOL_LSC_READ_STATE_INFO_MNEMONIC = 192, /* LSC_READ_STATE_INFO_MNEMONIC  */
  YYSYMBOL_LSC_FENCE_MNEMONIC = 193,       /* LSC_FENCE_MNEMONIC  */
  YYSYMBOL_FCVT_OP = 194,                  /* FCVT_OP  */
  YYSYMBOL_YYACCEPT = 195,                 /* $accept  */
  YYSYMBOL_Listing = 196,                  /* Listing  */
  YYSYMBOL_ListingHeader = 197,            /* ListingHeader  */
  YYSYMBOL_Statements = 198,               /* Statements  */
  YYSYMBOL_Newlines = 199,                 /* Newlines  */
  YYSYMBOL_NewlinesOpt = 200,              /* NewlinesOpt  */
  YYSYMBOL_Statement = 201,                /* Statement  */
  YYSYMBOL_Scope = 202,                    /* Scope  */
  YYSYMBOL_ScopeStart = 203,               /* ScopeStart  */
  YYSYMBOL_ScopeEnd = 204,                 /* ScopeEnd  */
  YYSYMBOL_IdentOrStringLit = 205,         /* IdentOrStringLit  */
  YYSYMBOL_DirectiveKernel = 206,          /* DirectiveKernel  */
  YYSYMBOL_DirectiveGlobalFunction = 207,  /* DirectiveGlobalFunction  */
  YYSYMBOL_DirectiveVersion = 208,         /* DirectiveVersion  */
  YYSYMBOL_DirectiveDecl = 209,            /* DirectiveDecl  */
  YYSYMBOL_DeclFunction = 210,             /* DeclFunction  */
  YYSYMBOL_DeclVariable = 211,             /* DeclVariable  */
  YYSYMBOL_DeclAddress = 212,              /* DeclAddress  */
  YYSYMBOL_DeclPredicate = 213,            /* DeclPredicate  */
  YYSYMBOL_DeclSampler = 214,              /* DeclSampler  */
  YYSYMBOL_VNameEqOpt = 215,               /* VNameEqOpt  */
  YYSYMBOL_DeclSurface = 216,              /* DeclSurface  */
  YYSYMBOL_DirectiveInput = 217,           /* DirectiveInput  */
  YYSYMBOL_DirectiveImplicitInput = 218,   /* DirectiveImplicitInput  */
  YYSYMBOL_InputOffset = 219,              /* InputOffset  */
  YYSYMBOL_InputSize = 220,                /* InputSize  */
  YYSYMBOL_DirectiveParameter = 221,       /* DirectiveParameter  */
  YYSYMBOL_DirectiveAttr = 222,            /* DirectiveAttr  */
  YYSYMBOL_DirectiveFunc = 223,            /* DirectiveFunc  */
  YYSYMBOL_AlignAttrOpt = 224,             /* AlignAttrOpt  */
  YYSYMBOL_Align = 225,                    /* Align  */
  YYSYMBOL_AliasAttrOpt = 226,             /* AliasAttrOpt  */
  YYSYMBOL_OneAttr = 227,                  /* OneAttr  */
  YYSYMBOL_AttrOpt = 228,                  /* AttrOpt  */
  YYSYMBOL_GenAttrOpt = 229,               /* GenAttrOpt  */
  YYSYMBOL_Instruction = 230,              /* Instruction  */
  YYSYMBOL_Label = 231,                    /* Label  */
  YYSYMBOL_LogicInstruction = 232,         /* LogicInstruction  */
  YYSYMBOL_UnaryLogicInstruction = 233,    /* UnaryLogicInstruction  */
  YYSYMBOL_MathInstruction_2OPND = 234,    /* MathInstruction_2OPND  */
  YYSYMBOL_MathInstruction_3OPND = 235,    /* MathInstruction_3OPND  */
  YYSYMBOL_ArithInstruction_2OPND = 236,   /* ArithInstruction_2OPND  */
  YYSYMBOL_ArithInstruction_3OPND = 237,   /* ArithInstruction_3OPND  */
  YYSYMBOL_ArithInstruction_4OPND = 238,   /* ArithInstruction_4OPND  */
  YYSYMBOL_DpasInstruction = 239,          /* DpasInstruction  */
  YYSYMBOL_BfnInstruction = 240,           /* BfnInstruction  */
  YYSYMBOL_QwScatterInstruction = 241,     /* QwScatterInstruction  */
  YYSYMBOL_BF_CvtInstruction = 242,        /* BF_CvtInstruction  */
  YYSYMBOL_FCvtInstruction = 243,          /* FCvtInstruction  */
  YYSYMBOL_AntiTrigInstruction = 244,      /* AntiTrigInstruction  */
  YYSYMBOL_AddrAddInstruction = 245,       /* AddrAddInstruction  */
  YYSYMBOL_SetpInstruction = 246,          /* SetpInstruction  */
  YYSYMBOL_SelInstruction = 247,           /* SelInstruction  */
  YYSYMBOL_MinInstruction = 248,           /* MinInstruction  */
  YYSYMBOL_MaxInstruction = 249,           /* MaxInstruction  */
  YYSYMBOL_MovInstruction = 250,           /* MovInstruction  */
  YYSYMBOL_MovsInstruction = 251,          /* MovsInstruction  */
  YYSYMBOL_CmpInstruction = 252,           /* CmpInstruction  */
  YYSYMBOL_MediaInstruction = 253,         /* MediaInstruction  */
  YYSYMBOL_MediaInstructionPlaneID = 254,  /* MediaInstructionPlaneID  */
  YYSYMBOL_ScatterInstruction = 255,       /* ScatterInstruction  */
  YYSYMBOL_ScatterTypedInstruction = 256,  /* ScatterTypedInstruction  */
  YYSYMBOL_Scatter4ScaledInstruction = 257, /* Scatter4ScaledInstruction  */
  YYSYMBOL_ScatterScaledInstruction = 258, /* ScatterScaledInstruction  */
  YYSYMBOL_SynchronizationInstruction = 259, /* SynchronizationInstruction  */
  YYSYMBOL_DwordAtomicInstruction = 260,   /* DwordAtomicInstruction  */
  YYSYMBOL_TypedAtomicInstruction = 261,   /* TypedAtomicInstruction  */
  YYSYMBOL_Atomic16Opt = 262,              /* Atomic16Opt  */
  YYSYMBOL_SampleUnormInstruction = 263,   /* SampleUnormInstruction  */
  YYSYMBOL_SampleInstruction = 264,        /* SampleInstruction  */
  YYSYMBOL_Sample3dInstruction = 265,      /* Sample3dInstruction  */
  YYSYMBOL_CPSEnableOpt = 266,             /* CPSEnableOpt  */
  YYSYMBOL_NonUniformSamplerEnableOpt = 267, /* NonUniformSamplerEnableOpt  */
  YYSYMBOL_Load3dInstruction = 268,        /* Load3dInstruction  */
  YYSYMBOL_Gather43dInstruction = 269,     /* Gather43dInstruction  */
  YYSYMBOL_PixelNullMaskEnableOpt = 270,   /* PixelNullMaskEnableOpt  */
  YYSYMBOL_ResInfo3dInstruction = 271,     /* ResInfo3dInstruction  */
  YYSYMBOL_SampleInfo3dInstruction = 272,  /* SampleInfo3dInstruction  */
  YYSYMBOL_RTWriteOperandParse = 273,      /* RTWriteOperandParse  */
  YYSYMBOL_RTWriteInstruction = 274,       /* RTWriteInstruction  */
  YYSYMBOL_RTWriteModeOpt = 275,           /* RTWriteModeOpt  */
  YYSYMBOL_URBWriteInstruction = 276,      /* URBWriteInstruction  */
  YYSYMBOL_AVSInstruction = 277,           /* AVSInstruction  */
  YYSYMBOL_VMEInstruction = 278,           /* VMEInstruction  */
  YYSYMBOL_OwordInstruction = 279,         /* OwordInstruction  */
  YYSYMBOL_SvmInstruction = 280,           /* SvmInstruction  */
  YYSYMBOL_AtomicBitwidthOpt = 281,        /* AtomicBitwidthOpt  */
  YYSYMBOL_LscInstruction = 282,           /* LscInstruction  */
  YYSYMBOL_LscUntypedLoad = 283,           /* LscUntypedLoad  */
  YYSYMBOL_LscUntypedStridedLoad = 284,    /* LscUntypedStridedLoad  */
  YYSYMBOL_LscUntypedBlock2dLoad = 285,    /* LscUntypedBlock2dLoad  */
  YYSYMBOL_LscUntypedStore = 286,          /* LscUntypedStore  */
  YYSYMBOL_LscUntypedStridedStore = 287,   /* LscUntypedStridedStore  */
  YYSYMBOL_LscUntypedBlock2dStore = 288,   /* LscUntypedBlock2dStore  */
  YYSYMBOL_LscUntypedAtomic = 289,         /* LscUntypedAtomic  */
  YYSYMBOL_LscTypedLoad = 290,             /* LscTypedLoad  */
  YYSYMBOL_LscTypedStore = 291,            /* LscTypedStore  */
  YYSYMBOL_LscTypedAtomic = 292,           /* LscTypedAtomic  */
  YYSYMBOL_LscTypedReadStateInfo = 293,    /* LscTypedReadStateInfo  */
  YYSYMBOL_LscFence = 294,                 /* LscFence  */
  YYSYMBOL_LscSfid = 295,                  /* LscSfid  */
  YYSYMBOL_LscCacheOpts = 296,             /* LscCacheOpts  */
  YYSYMBOL_LscUntypedAddrOperand = 297,    /* LscUntypedAddrOperand  */
  YYSYMBOL_LscUntypedStridedAddrOperand = 298, /* LscUntypedStridedAddrOperand  */
  YYSYMBOL_LscUntypedBlock2dAddrOperand = 299, /* LscUntypedBlock2dAddrOperand  */
  YYSYMBOL_LscTypedAddrOperand = 300,      /* LscTypedAddrOperand  */
  YYSYMBOL_LscAddrImmOffsetOpt = 301,      /* LscAddrImmOffsetOpt  */
  YYSYMBOL_LscAddrImmScaleOpt = 302,       /* LscAddrImmScaleOpt  */
  YYSYMBOL_LscAddrModelOpt = 303,          /* LscAddrModelOpt  */
  YYSYMBOL_LscRegAddrModel = 304,          /* LscRegAddrModel  */
  YYSYMBOL_LscRegAddrModelKind = 305,      /* LscRegAddrModelKind  */
  YYSYMBOL_LscVectorOpRegOrImm = 306,      /* LscVectorOpRegOrImm  */
  YYSYMBOL_LscVectorOpImm = 307,           /* LscVectorOpImm  */
  YYSYMBOL_LscVectorOpReg = 308,           /* LscVectorOpReg  */
  YYSYMBOL_LscDataOperand = 309,           /* LscDataOperand  */
  YYSYMBOL_LscDataOperand2D = 310,         /* LscDataOperand2D  */
  YYSYMBOL_LscPayloadReg = 311,            /* LscPayloadReg  */
  YYSYMBOL_LscPayloadNonNullReg = 312,     /* LscPayloadNonNullReg  */
  YYSYMBOL_SwitchLabels = 313,             /* SwitchLabels  */
  YYSYMBOL_BranchInstruction = 314,        /* BranchInstruction  */
  YYSYMBOL_FILE = 315,                     /* FILE  */
  YYSYMBOL_LOC = 316,                      /* LOC  */
  YYSYMBOL_RawSendInstruction = 317,       /* RawSendInstruction  */
  YYSYMBOL_LifetimeStartInst = 318,        /* LifetimeStartInst  */
  YYSYMBOL_LifetimeEndInst = 319,          /* LifetimeEndInst  */
  YYSYMBOL_RawSendsInstruction = 320,      /* RawSendsInstruction  */
  YYSYMBOL_NullaryInstruction = 321,       /* NullaryInstruction  */
  YYSYMBOL_OwordModifier = 322,            /* OwordModifier  */
  YYSYMBOL_Predicate = 323,                /* Predicate  */
  YYSYMBOL_PredSign = 324,                 /* PredSign  */
  YYSYMBOL_PredCtrlOpt = 325,              /* PredCtrlOpt  */
  YYSYMBOL_SatModOpt = 326,                /* SatModOpt  */
  YYSYMBOL_SrcModifier = 327,              /* SrcModifier  */
  YYSYMBOL_ConditionalModifier = 328,      /* ConditionalModifier  */
  YYSYMBOL_VecDstOperand_A = 329,          /* VecDstOperand_A  */
  YYSYMBOL_VecDstOperand_G = 330,          /* VecDstOperand_G  */
  YYSYMBOL_VecDstOperand_G_I = 331,        /* VecDstOperand_G_I  */
  YYSYMBOL_VecSrcOperand_G_I_IMM_A_AO = 332, /* VecSrcOperand_G_I_IMM_A_AO  */
  YYSYMBOL_VecSrcOperand_G_I_IMM_A = 333,  /* VecSrcOperand_G_I_IMM_A  */
  YYSYMBOL_VecSrcOperand_G_I_IMM = 334,    /* VecSrcOperand_G_I_IMM  */
  YYSYMBOL_VecSrcOperand_G_IMM = 335,      /* VecSrcOperand_G_IMM  */
  YYSYMBOL_VecSrcOperand_G_IMM_AO = 336,   /* VecSrcOperand_G_IMM_AO  */
  YYSYMBOL_VecSrcOperand_G_A = 337,        /* VecSrcOperand_G_A  */
  YYSYMBOL_VecSrcOperand_G_A_AO = 338,     /* VecSrcOperand_G_A_AO  */
  YYSYMBOL_VecSrcOperand_G = 339,          /* VecSrcOperand_G  */
  YYSYMBOL_VecSrcOpndSimple = 340,         /* VecSrcOpndSimple  */
  YYSYMBOL_VMEOpndIME = 341,               /* VMEOpndIME  */
  YYSYMBOL_VMEOpndFBR = 342,               /* VMEOpndFBR  */
  YYSYMBOL_SrcStateOperand = 343,          /* SrcStateOperand  */
  YYSYMBOL_DstStateOperand = 344,          /* DstStateOperand  */
  YYSYMBOL_RawOperand = 345,               /* RawOperand  */
  YYSYMBOL_RawOperandNonNull = 346,        /* RawOperandNonNull  */
  YYSYMBOL_RawOperandOffsetSuffix = 347,   /* RawOperandOffsetSuffix  */
  YYSYMBOL_RawOperandArray = 348,          /* RawOperandArray  */
  YYSYMBOL_DstAddrOperand = 349,           /* DstAddrOperand  */
  YYSYMBOL_DstGeneralOperand = 350,        /* DstGeneralOperand  */
  YYSYMBOL_DstIndirectOperand = 351,       /* DstIndirectOperand  */
  YYSYMBOL_SrcAddrOfOperand = 352,         /* SrcAddrOfOperand  */
  YYSYMBOL_AddrOfVar = 353,                /* AddrOfVar  */
  YYSYMBOL_SrcAddrOperand = 354,           /* SrcAddrOperand  */
  YYSYMBOL_SrcGeneralOperand = 355,        /* SrcGeneralOperand  */
  YYSYMBOL_SrcImmOperand = 356,            /* SrcImmOperand  */
  YYSYMBOL_FloatLit = 357,                 /* FloatLit  */
  YYSYMBOL_DoubleFloatLit = 358,           /* DoubleFloatLit  */
  YYSYMBOL_SrcIndirectOperand = 359,       /* SrcIndirectOperand  */
  YYSYMBOL_DstRegion = 360,                /* DstRegion  */
  YYSYMBOL_SrcRegionDirect = 361,          /* SrcRegionDirect  */
  YYSYMBOL_SrcRegionIndirect = 362,        /* SrcRegionIndirect  */
  YYSYMBOL_IndirectVarAccess = 363,        /* IndirectVarAccess  */
  YYSYMBOL_TwoDimOffset = 364,             /* TwoDimOffset  */
  YYSYMBOL_PredVar = 365,                  /* PredVar  */
  YYSYMBOL_AddrVarAccess = 366,            /* AddrVarAccess  */
  YYSYMBOL_AddrVarAccessWithWidth = 367,   /* AddrVarAccessWithWidth  */
  YYSYMBOL_SIMDMode = 368,                 /* SIMDMode  */
  YYSYMBOL_ElemNum = 369,                  /* ElemNum  */
  YYSYMBOL_ExecSize = 370,                 /* ExecSize  */
  YYSYMBOL_ExecSizeInt = 371,              /* ExecSizeInt  */
  YYSYMBOL_Var = 372,                      /* Var  */
  YYSYMBOL_VarNonNull = 373,               /* VarNonNull  */
  YYSYMBOL_IntExp = 374,                   /* IntExp  */
  YYSYMBOL_IntExpCond = 375,               /* IntExpCond  */
  YYSYMBOL_IntExpAND = 376,                /* IntExpAND  */
  YYSYMBOL_IntExpXOR = 377,                /* IntExpXOR  */
  YYSYMBOL_IntExpOR = 378,                 /* IntExpOR  */
  YYSYMBOL_IntExpCmp = 379,                /* IntExpCmp  */
  YYSYMBOL_IntExpRel = 380,                /* IntExpRel  */
  YYSYMBOL_IntExpNRA = 381,                /* IntExpNRA  */
  YYSYMBOL_IntExpShift = 382,              /* IntExpShift  */
  YYSYMBOL_IntExpAdd = 383,                /* IntExpAdd  */
  YYSYMBOL_IntExpMul = 384,                /* IntExpMul  */
  YYSYMBOL_IntExpUnr = 385,                /* IntExpUnr  */
  YYSYMBOL_IntExpPrim = 386,               /* IntExpPrim  */
  YYSYMBOL_DataType = 387,                 /* DataType  */
  YYSYMBOL_DataTypeIntOrVector = 388       /* DataTypeIntOrVector  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3027

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  195
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  194
/* YYNRULES -- Number of rules.  */
#define YYNRULES  434
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1097

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   449


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   622,   622,   627,   629,   629,   631,   631,   632,   632,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   650,   651,   652,   656,   660,   663,   663,   670,   678,
     686,   693,   694,   695,   696,   697,   698,   700,   707,   715,
     723,   730,   734,   734,   737,   745,   750,   762,   769,   777,
     777,   778,   785,   791,   795,   799,   803,   808,   814,   814,
     816,   820,   826,   834,   840,   845,   850,   856,   860,   864,
     870,   875,   881,   885,   895,   896,   897,   898,   899,   900,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
     911,   912,   913,   914,   915,   916,   917,   918,   919,   920,
     921,   922,   923,   924,   925,   926,   927,   928,   929,   930,
     931,   932,   933,   934,   935,   936,   937,   938,   939,   940,
     941,   942,   943,   944,   945,   948,   952,   958,   963,   969,
     977,   983,   990,   997,  1004,  1011,  1023,  1030,  1039,  1049,
    1055,  1062,  1068,  1074,  1083,  1093,  1100,  1107,  1115,  1124,
    1131,  1138,  1144,  1150,  1156,  1174,  1181,  1191,  1199,  1206,
    1213,  1222,  1231,  1240,  1248,  1251,  1254,  1257,  1260,  1265,
    1272,  1280,  1281,  1287,  1296,  1304,  1312,  1324,  1324,  1326,
    1326,  1329,  1342,  1354,  1354,  1357,  1365,  1373,  1376,  1380,
    1385,  1395,  1395,  1399,  1407,  1419,  1435,  1441,  1454,  1462,
    1469,  1475,  1481,  1487,  1494,  1495,  1504,  1505,  1506,  1508,
    1509,  1510,  1512,  1515,  1516,  1517,  1518,  1520,  1542,  1573,
    1602,  1627,  1651,  1678,  1704,  1738,  1778,  1818,  1849,  1884,
    1889,  1889,  1892,  1893,  1894,  1898,  1907,  1913,  1921,  1944,
    1955,  1966,  1977,  1990,  1991,  1992,  1999,  2000,  2003,  2004,
    2005,  2009,  2014,  2015,  2016,  2018,  2018,  2021,  2026,  2034,
    2042,  2056,  2060,  2066,  2071,  2074,  2078,  2081,  2086,  2089,
    2092,  2099,  2103,  2107,  2111,  2117,  2122,  2129,  2134,  2139,
    2145,  2152,  2159,  2165,  2171,  2179,  2187,  2195,  2204,  2209,
    2214,  2219,  2224,  2229,  2234,  2239,  2244,  2244,  2250,  2255,
    2260,  2260,  2262,  2262,  2265,  2265,  2268,  2269,  2270,  2271,
    2273,  2273,  2278,  2279,  2281,  2282,  2286,  2287,  2290,  2291,
    2294,  2295,  2296,  2299,  2300,  2303,  2304,  2305,  2308,  2309,
    2312,  2313,  2315,  2317,  2327,  2334,  2342,  2350,  2369,  2381,
    2388,  2400,  2405,  2412,  2417,  2425,  2433,  2439,  2444,  2466,
    2470,  2476,  2486,  2494,  2501,  2511,  2517,  2524,  2528,  2533,
    2537,  2543,  2544,  2551,  2559,  2560,  2566,  2576,  2584,  2593,
    2611,  2625,  2628,  2639,  2650,  2655,  2660,  2668,  2677,  2689,
    2703,  2705,  2716,  2728,  2734,  2742,  2751,  2751,  2752,  2752,
    2755,  2757,  2758,  2760,  2761,  2763,  2764,  2766,  2767,  2769,
    2770,  2771,  2773,  2774,  2775,  2776,  2777,  2794,  2797,  2798,
    2799,  2800,  2802,  2803,  2804,  2806,  2807,  2812,  2817,  2819,
    2820,  2821,  2822,  2826,  2827,  2829,  2833,  2837,  2843,  2852,
    2853,  2854,  2855,  2857,  2858
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ALIGN_KEYWORD",
  "ATOMIC_SUB_OP", "DIRECTIVE_DECL", "DIRECTIVE_FUNC",
  "DIRECTIVE_FUNCDECL", "DIRECTIVE_GLOBAL_FUNC", "DIRECTIVE_IMPLICIT",
  "DIRECTIVE_INPUT", "DIRECTIVE_KERNEL", "DIRECTIVE_KERNEL_ATTR",
  "DIRECTIVE_PARAMETER", "DIRECTIVE_VERSION", "ALIAS_EQ", "ALIGN_EQ",
  "ATTR_EQ", "OFFSET_EQ", "NUM_ELTS_EQ", "V_NAME_EQ", "SIZE_EQ",
  "V_TYPE_EQ_G", "V_TYPE_EQ_P", "V_TYPE_EQ_A", "V_TYPE_EQ_S",
  "V_TYPE_EQ_T", "CPS", "NON_UNIFORM_SAMPLER", "PIXEL_NULL_MASK",
  "RAW_SENDC_STRING", "RAW_SENDSC_EOT_STRING", "RAW_SENDSC_STRING",
  "RAW_SENDS_EOT_STRING", "RAW_SENDS_STRING", "RAW_SEND_STRING", "SAT",
  "SRCMOD_ABS", "SRCMOD_NEG", "SRCMOD_NEGABS", "SRCMOD_NOT", "BFN_OP",
  "DPAS_OP", "BF_CVT_OP", "NBARRIER_SIGNAL", "NBARRIER_WAIT", "ITYPE",
  "DECL_DATA_TYPE", "DFTYPE", "FTYPE", "HFTYPE", "VTYPE", "COND_MOD",
  "LANGLE", "RANGLE", "LBRACK", "RBRACK", "IND_LBRACK", "LPAREN", "RPAREN",
  "LBRACE", "RBRACE", "DOT", "COMMA", "SEMI", "COLON", "SLASH", "PERCENT",
  "EQUALS", "PLUS", "MINUS", "TIMES", "AMP", "CIRC", "PIPE", "TILDE",
  "BANG", "QUESTION", "LEQ", "GEQ", "EQ", "NEQ", "SHL", "SHRS", "SHRZ",
  "LABEL", "IDENT", "BUILTIN_NULL", "BUILTIN", "STRING_LIT", "NEWLINE",
  "RTWRITE_OPTION", "MEDIA_MODE", "OWORD_MODIFIER", "SAMPLER_CHANNEL",
  "CHANNEL_OUTPUT", "EXECMODE", "CNTRL", "FENCE_OPTIONS", "ADDR_ADD_OP",
  "UNARY_LOGIC_OP", "BINARY_LOGIC_OP", "TERNARY_LOGIC_OP",
  "QUATERNARY_LOGIC_OP", "SEL_OP", "MIN_OP", "MAX_OP", "ANTI_TRIG_OP",
  "MATH2_OP", "MATH3_OP", "ARITH2_OP", "ARITH3_OP", "ARITH4_OP",
  "ARITH4_OP2", "CMP_OP", "SVM_OP", "SVM_SCATTER_OP",
  "SVM_GATHER4SCALED_OP", "SVM_SCATTER4SCALED_OP", "SVM_ATOMIC_OP",
  "OWORD_OP", "MEDIA_OP", "SCATTER_OP", "SCATTER_TYPED_OP",
  "SCATTER_SCALED_OP", "SCATTER4_SCALED_OP", "BARRIER_OP",
  "SBARRIER_SIGNAL", "SBARRIER_WAIT", "DWORD_ATOMIC_OP", "TYPED_ATOMIC_OP",
  "SAMPLE_OP", "SAMPLE_UNORM_OP", "VME_IME_OP", "VME_SIC_OP", "VME_FBR_OP",
  "BRANCH_OP", "RET_OP", "IFCALL", "FCALL", "FADDR", "SWITCHJMP_OP",
  "MOVS_OP", "SETP_OP", "MOV_OP", "FILE_OP", "LOC_OP", "CACHE_FLUSH_OP",
  "WAIT_OP", "FENCE_GLOBAL_OP", "FENCE_LOCAL_OP", "FENCE_SW_OP",
  "YIELD_OP", "SAMPLE_3D_OP", "LOAD_3D_OP", "SAMPLE4_3D_OP",
  "RESINFO_OP_3D", "SAMPLEINFO_OP_3D", "RTWRITE_OP_3D", "URBWRITE_OP_3D",
  "LIFETIME_START_OP", "LIFETIME_END_OP", "AVS_OP", "CALL_OP", "PRED_CNTL",
  "F32_LIT", "F64_LIT", "DEC_LIT", "HEX_LIT", "BUILTIN_SIZEOF",
  "BUILTIN_DISPATCH_SIMD_SIZE", "QW_SCATTER_OP", "LSC_CACHING_OPT",
  "LSC_ADDR_SIZE_TK", "LSC_DATA_SHAPE_TK", "LSC_DATA_SHAPE_TK_CHMASK",
  "LSC_DATA_SHAPE_TK_BLOCK2D", "LSC_AM_FLAT", "LSC_AM_BTI", "LSC_AM_BSS",
  "LSC_AM_SS", "LSC_FENCE_OP_TYPE", "LSC_FENCE_SCOPE",
  "LSC_SFID_UNTYPED_TOKEN", "LSC_SFID_TYPED_TOKEN", "LSC_LOAD_MNEMONIC",
  "LSC_LOAD_STRIDED_MNEMONIC", "LSC_LOAD_BLOCK2D_MNEMONIC",
  "LSC_STORE_MNEMONIC", "LSC_STORE_STRIDED_MNEMONIC",
  "LSC_STORE_BLOCK2D_MNEMONIC", "LSC_ATOMIC_MNEMONIC",
  "LSC_READ_STATE_INFO_MNEMONIC", "LSC_FENCE_MNEMONIC", "FCVT_OP",
  "$accept", "Listing", "ListingHeader", "Statements", "Newlines",
  "NewlinesOpt", "Statement", "Scope", "ScopeStart", "ScopeEnd",
  "IdentOrStringLit", "DirectiveKernel", "DirectiveGlobalFunction",
  "DirectiveVersion", "DirectiveDecl", "DeclFunction", "DeclVariable",
  "DeclAddress", "DeclPredicate", "DeclSampler", "VNameEqOpt",
  "DeclSurface", "DirectiveInput", "DirectiveImplicitInput", "InputOffset",
  "InputSize", "DirectiveParameter", "DirectiveAttr", "DirectiveFunc",
  "AlignAttrOpt", "Align", "AliasAttrOpt", "OneAttr", "AttrOpt",
  "GenAttrOpt", "Instruction", "Label", "LogicInstruction",
  "UnaryLogicInstruction", "MathInstruction_2OPND",
  "MathInstruction_3OPND", "ArithInstruction_2OPND",
  "ArithInstruction_3OPND", "ArithInstruction_4OPND", "DpasInstruction",
  "BfnInstruction", "QwScatterInstruction", "BF_CvtInstruction",
  "FCvtInstruction", "AntiTrigInstruction", "AddrAddInstruction",
  "SetpInstruction", "SelInstruction", "MinInstruction", "MaxInstruction",
  "MovInstruction", "MovsInstruction", "CmpInstruction",
  "MediaInstruction", "MediaInstructionPlaneID", "ScatterInstruction",
  "ScatterTypedInstruction", "Scatter4ScaledInstruction",
  "ScatterScaledInstruction", "SynchronizationInstruction",
  "DwordAtomicInstruction", "TypedAtomicInstruction", "Atomic16Opt",
  "SampleUnormInstruction", "SampleInstruction", "Sample3dInstruction",
  "CPSEnableOpt", "NonUniformSamplerEnableOpt", "Load3dInstruction",
  "Gather43dInstruction", "PixelNullMaskEnableOpt", "ResInfo3dInstruction",
  "SampleInfo3dInstruction", "RTWriteOperandParse", "RTWriteInstruction",
  "RTWriteModeOpt", "URBWriteInstruction", "AVSInstruction",
  "VMEInstruction", "OwordInstruction", "SvmInstruction",
  "AtomicBitwidthOpt", "LscInstruction", "LscUntypedLoad",
  "LscUntypedStridedLoad", "LscUntypedBlock2dLoad", "LscUntypedStore",
  "LscUntypedStridedStore", "LscUntypedBlock2dStore", "LscUntypedAtomic",
  "LscTypedLoad", "LscTypedStore", "LscTypedAtomic",
  "LscTypedReadStateInfo", "LscFence", "LscSfid", "LscCacheOpts",
  "LscUntypedAddrOperand", "LscUntypedStridedAddrOperand",
  "LscUntypedBlock2dAddrOperand", "LscTypedAddrOperand",
  "LscAddrImmOffsetOpt", "LscAddrImmScaleOpt", "LscAddrModelOpt",
  "LscRegAddrModel", "LscRegAddrModelKind", "LscVectorOpRegOrImm",
  "LscVectorOpImm", "LscVectorOpReg", "LscDataOperand", "LscDataOperand2D",
  "LscPayloadReg", "LscPayloadNonNullReg", "SwitchLabels",
  "BranchInstruction", "FILE", "LOC", "RawSendInstruction",
  "LifetimeStartInst", "LifetimeEndInst", "RawSendsInstruction",
  "NullaryInstruction", "OwordModifier", "Predicate", "PredSign",
  "PredCtrlOpt", "SatModOpt", "SrcModifier", "ConditionalModifier",
  "VecDstOperand_A", "VecDstOperand_G", "VecDstOperand_G_I",
  "VecSrcOperand_G_I_IMM_A_AO", "VecSrcOperand_G_I_IMM_A",
  "VecSrcOperand_G_I_IMM", "VecSrcOperand_G_IMM", "VecSrcOperand_G_IMM_AO",
  "VecSrcOperand_G_A", "VecSrcOperand_G_A_AO", "VecSrcOperand_G",
  "VecSrcOpndSimple", "VMEOpndIME", "VMEOpndFBR", "SrcStateOperand",
  "DstStateOperand", "RawOperand", "RawOperandNonNull",
  "RawOperandOffsetSuffix", "RawOperandArray", "DstAddrOperand",
  "DstGeneralOperand", "DstIndirectOperand", "SrcAddrOfOperand",
  "AddrOfVar", "SrcAddrOperand", "SrcGeneralOperand", "SrcImmOperand",
  "FloatLit", "DoubleFloatLit", "SrcIndirectOperand", "DstRegion",
  "SrcRegionDirect", "SrcRegionIndirect", "IndirectVarAccess",
  "TwoDimOffset", "PredVar", "AddrVarAccess", "AddrVarAccessWithWidth",
  "SIMDMode", "ElemNum", "ExecSize", "ExecSizeInt", "Var", "VarNonNull",
  "IntExp", "IntExpCond", "IntExpAND", "IntExpXOR", "IntExpOR",
  "IntExpCmp", "IntExpRel", "IntExpNRA", "IntExpShift", "IntExpAdd",
  "IntExpMul", "IntExpUnr", "IntExpPrim", "DataType",
  "DataTypeIntOrVector", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-1004)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-424)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -33, -1004,    71,    34,   141, -1004, -1004,   -52,   -33, -1004,
     106,  2763,    26,    89,    49,   118,    49,   114,   127,    49,
     130,   136,   161,   161,  1135,  1135,   191, -1004, -1004,   161,
     186,   161,   210,   215,   281, -1004, -1004, -1004,   257,   265,
     326,   246,   336,   327,   161,   161,   161,   330,   251, -1004,
    1289,   322,   324, -1004, -1004,   318,   333,   337,   338,   334,
    -136,   161,   -33, -1004, -1004,  2596, -1004, -1004, -1004, -1004,
   -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004,
   -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004,
   -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004,
   -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004,
   -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004,
   -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004,
   -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004,
   -1004, -1004, -1004, -1004, -1004,  2835, -1004,   314, -1004, -1004,
   -1004, -1004, -1004,   408,   408, -1004,   361,   409,   -53,   276,
     246, -1004, -1004, -1004, -1004,   246,   178,    36,   178,   178,
   -1004, -1004, -1004, -1004, -1004,    56,   323,   -16, -1004,   163,
    1135, -1004, -1004, -1004, -1004, -1004, -1004,   378,   374, -1004,
      29, -1004, -1004, -1004,   246,   246, -1004,   161,  1135, -1004,
     161,   374,   266,   161,   376,   340,   273,   246,   276,  1135,
     246,   163,  1135,   246,   246, -1004, -1004,   246, -1004, -1004,
   -1004, -1004, -1004,   161,   161, -1004, -1004,   246, -1004, -1004,
     260,   246,  1475, -1004, -1004,  2188,   161,   281,   281,   281,
     281,   161,   406,   406,   406,   406,   406,   406,   406,   406,
     406,   406,   406,   406,   406,   406,   161,   381,   350,   352,
     443,   354,   387,   357,   448,   449,   161,   161,   161,   161,
     406,   428,   428,   428,   367,   161,   161,   397,    72,   277,
     278,   101,   279,   280,   142,   282,   417,   446,   450,   452,
     453,   178,   165,   409,    76,   178,   456, -1004,   415,   412,
     414,   276, -1004,   416,  1289, -1004,   131,    -3,   419,   178,
   -1004, -1004,   420, -1004,   162,   411,   407, -1004,   299,    14,
   -1004,   217,   110, -1004,   308, -1004, -1004, -1004, -1004, -1004,
   -1004, -1004, -1004, -1004, -1004,   399, -1004,   378,   374, -1004,
     178, -1004,   177,   178,   433, -1004, -1004, -1004,   331, -1004,
      12, -1004, -1004,   429,   163,   276,   246,   246, -1004,   210,
     321,   246,   246,   434,   276,   276,   435,   276, -1004, -1004,
   -1004,   438,   441,   246,  1135,   199,  1135,   246,   246,   246,
     310,  1289, -1004, -1004,   -33, -1004,   335,   281,   281,   281,
     281,   343, -1004,   161,   161,   161,   161,   161,   161,   161,
     161,   161,   161,   161,   161,   161,   161,   163,   341,   161,
     161,   439,   161,   345,   161,   442,   442,    49, -1004,  1135,
     410,   161, -1004,   473,   424,   425, -1004,   161,   346,    49,
     347,   349,   349,   349,   349,   349,   349,   349,   349,   349,
     349,   288,   486,   178,   178,   178,   178, -1004,   462,   456,
   -1004, -1004, -1004, -1004, -1004, -1004, -1004,   360,   362,   276,
     -14, -1004, -1004,   178, -1004,   438, -1004,   178,   178, -1004,
     178,   178,   178,   178,   178,   178,   178,   178,   178,   178,
     178,   178,   178,   178,   178,   178,   178,   178,   469,   177,
     433,   329,    42, -1004, -1004, -1004, -1004, -1004,   467,   178,
   -1004, -1004,   474,   246, -1004,  1626, -1004, -1004,   477, -1004,
   -1004,   478,   178,  1135,  1135,   131, -1004,  1135,  1403,   246,
     479,   288,   246,   370,   276,   276,  1135,   276,   177,   -22,
   -1004,   481, -1004, -1004,   482,   178, -1004,   276,   276,  1135,
   -1004, -1004,   483,   379,   281,   281,   281,   281,   380,   163,
     163,   163,   163,   163,   163,   163,   163,   163,   163,   163,
     163,   163,   163,   163,   487,  1135,  1135,   383,   161,   246,
     161,   246,   385,   161,   161, -1004,   402,   413,   163, -1004,
     520,   161,   161,   246,   418, -1004,   161,   404,   161,   161,
     161,   161,   161,   161,   161,   161,   161,   161,   414,   209,
   -1004, -1004,   416,   178,   456,   456,   531,   531,   491, -1004,
     519, -1004,   246,   178, -1004,   525, -1004,   527,   522,   411,
      -9,   407, -1004, -1004, -1004, -1004, -1004, -1004, -1004,   110,
     110,   328,   328,   328, -1004, -1004, -1004, -1004, -1004, -1004,
     422,   178,   178,   178,   526, -1004, -1004, -1004, -1004, -1004,
   -1004,   178,   178,   532,  1135,  1135,   276,   269,  1135,  1135,
    1135, -1004,   276,   276,  1135,   537,   276, -1004,   523,   276,
   -1004,   -22,   -22,   538,   178,   178,   205,   276, -1004,  1135,
   -1004,   451,   161,   161,   281,   281,   454,  1135,  1135,   246,
    1135,   246,  1135,  1135,  1135,  1135,  1135,  1135,  1135,  1135,
    1135,  1135,  1135,  1135,   457,   276,   276, -1004,   276,   276,
     246,  1135, -1004,   246,   246,   458,   460,   910,   910,   244,
   -1004,   521,  1135,  1135, -1004,   276,   246, -1004,   288,   288,
     288,   288,   190,   209,   190,   436,   288,   288, -1004, -1004,
   -1004, -1004,   559,   603, -1004, -1004,   534,   456,   456,   560,
   -1004,    25, -1004, -1004,   374,   570, -1004, -1004, -1004,   178,
     578,   574,   580,   577,   245,   588, -1004, -1004, -1004,  1135,
     276,   276,   276,   276,  1135, -1004,   276,  1135, -1004, -1004,
   -1004, -1004,   583,   247, -1004, -1004,  1135,  1289,  1289,  1289,
     161,   161,  1289,  1135, -1004, -1004,  1135,   246,  1135,  1135,
    1135,  1135,  1135, -1004, -1004,  1135, -1004,  1135,  1135,  1135,
     161,   276,   276,   276,   276,  1135,   276,   276,   276, -1004,
   -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004,   478,   161,
     246,   246,  1641,   276,   276,   190,   225,   209,   190,   436,
     468, -1004,   288,   592, -1004,   288,   593, -1004,   288,   594,
     595,   288,   190,   209,   154,    27,   628, -1004, -1004, -1004,
   -1004,    91, -1004,   491, -1004, -1004, -1004, -1004,   178, -1004,
   -1004,   178,   276, -1004,   276,   276,   276,  1135,   276,   597,
   -1004,  1135,   276,  1289,  1289,  1289,  1289,   276,  1135, -1004,
   -1004,  1135,  1135, -1004, -1004, -1004, -1004, -1004,  1135, -1004,
     276, -1004, -1004,   276,   276,   276,   276,   276,   276,  1135,
     276,   246, -1004, -1004,   276,   276, -1004, -1004, -1004, -1004,
   -1004, -1004, -1004, -1004,   178, -1004,   104, -1004,   178,   246,
   -1004,   288,   288,   598, -1004, -1004,   291, -1004, -1004, -1004,
   -1004, -1004,   599,   456, -1004, -1004, -1004,   600,   604, -1004,
   -1004, -1004,   276,  1135,   276, -1004,  1135,   276,   276,   276,
    1289,  1289,   276, -1004, -1004,  1135, -1004,   276,   276,   276,
     276, -1004,   276,   276,   246, -1004,   276,   276, -1004,   104,
     166,    10, -1004,   416,   104,   590,   288,   288, -1004,   178,
     492,   122, -1004, -1004, -1004, -1004,   276, -1004,  1135, -1004,
     276,   276,   276,   276, -1004, -1004, -1004, -1004,   276, -1004,
     276,   276,   246,   276, -1004, -1004,   332,   178,   488,   104,
     332,   154, -1004, -1004,   602, -1004, -1004,   617, -1004,  1135,
     276,   276,   276,   276, -1004, -1004,   276,   276, -1004,   276,
     178,   -39,   606, -1004,    45,    53,   618,   178,   178,   563,
   -1004, -1004,   276,   276,   276, -1004,   328, -1004,   494,   509,
     104,   154,   154,   624,   630,  1135, -1004, -1004,   276,   276,
   -1004, -1004,    69,   632,   623, -1004, -1004,   601, -1004,   528,
     104,   529,   154,  1135, -1004,   638, -1004,   633,   276,   530,
     154, -1004, -1004,   637,   154,   648, -1004
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       8,     7,     0,     9,     0,     1,     6,     0,     8,     3,
       0,   298,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   300,    24,   125,     0,
     310,     0,   296,     0,     0,   164,   165,   166,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   288,
       0,   291,   293,   295,   290,     0,     0,     0,     0,     0,
       0,     0,     8,     5,    20,     0,    11,    12,    10,    36,
      31,    32,    33,    34,    35,    14,    13,    15,    17,    16,
      18,    19,    74,    76,    77,    78,    79,    80,    81,   119,
     120,   121,   122,   124,    82,    83,   104,   101,   102,   103,
     100,    99,    84,    85,    87,    88,    90,    89,    91,    93,
      94,    96,    95,   109,   110,   111,   112,   113,   114,   115,
      98,    97,    86,    75,   123,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,    92,   105,   106,
     107,   116,   117,   108,   118,     0,    30,     0,    26,    27,
      57,    37,    29,    49,    49,    28,    55,     0,     0,     0,
       0,   307,   306,   308,   309,     0,     0,     0,     0,     0,
     388,   387,   389,   361,   364,   423,   424,     0,   428,     0,
       0,   320,   332,   322,   357,   359,   321,     0,     0,   386,
       0,   422,   168,   301,     0,     0,   311,     0,     0,   297,
       0,     0,     0,     0,   380,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   278,   279,     0,   289,   323,
     324,   292,   294,     0,     0,   282,   283,     0,   230,   231,
       0,     0,   298,     2,    23,   298,     0,     0,     0,     0,
       0,     0,   304,   304,   304,   304,   304,   304,   304,   304,
     304,   304,   304,   304,   304,   304,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     304,   183,   183,   183,   191,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    72,    46,    56,     0,    72,   385,     0,     0,
       0,     0,   338,     0,     0,   313,     0,     0,     0,     0,
     423,   424,     0,   390,   392,   394,   396,   398,   401,   406,
     407,   411,   414,   418,   424,   358,   360,   419,   420,   421,
     365,   362,   366,   363,   356,     0,   426,     0,     0,   167,
       0,   371,     0,     0,     0,   433,   434,   355,   302,   377,
       0,   312,   345,     0,     0,     0,     0,     0,   382,   296,
       0,     0,     0,     0,     0,     0,     0,     0,   277,   314,
     315,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     4,    25,     8,    21,     0,     0,     0,     0,
       0,     0,   305,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   204,     0,     0,     0,   171,   171,     0,   273,     0,
       0,     0,   184,   177,     0,     0,   192,     0,     0,     0,
       0,   232,   232,   232,   232,   232,   232,   232,   232,   232,
     232,     0,     0,     0,     0,     0,     0,    50,     0,    72,
      48,    45,    53,    54,    51,    52,   383,     0,     0,     0,
       0,   340,   141,     0,   347,     0,   375,     0,     0,   425,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   406,   430,   431,   432,   367,   429,     0,     0,
     353,   303,     0,     0,   330,     0,   328,   331,   349,   329,
     352,     0,     0,     0,     0,   377,   199,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   268,
     153,     0,   154,   152,     0,     0,   145,     0,     0,     0,
     229,   142,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   271,     0,     0,     0,   178,
     179,     0,     0,     0,     0,   272,     0,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   387,     0,
     264,   265,   386,     0,    72,    72,    42,    42,     0,    47,
       0,   339,     0,     0,   341,     0,   346,     0,     0,   393,
       0,   395,   397,   399,   400,   402,   403,   404,   405,   412,
     413,   408,   409,   410,   416,   417,   415,   427,   368,   354,
       0,     0,   373,     0,     0,   299,   351,   144,   325,   327,
     326,     0,     0,     0,     0,     0,     0,   159,     0,     0,
       0,   381,     0,     0,     0,     0,     0,   196,     0,     0,
     348,   268,   268,     0,     0,     0,     0,     0,   186,     0,
      22,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   205,     0,     0,
       0,     0,   172,     0,     0,     0,     0,     0,     0,     0,
     180,     0,     0,     0,   187,     0,     0,   234,     0,     0,
       0,     0,   248,     0,   248,     0,     0,     0,   254,   252,
     253,   228,     0,    58,    40,    39,     0,    72,    72,    69,
      71,     0,   384,   138,     0,     0,   369,   374,   378,     0,
       0,     0,     0,     0,     0,     0,   156,   155,   198,     0,
       0,     0,     0,     0,     0,   334,     0,     0,   197,   269,
     270,   274,     0,     0,   337,   185,     0,     0,     0,     0,
       0,     0,     0,     0,   130,   131,     0,     0,     0,     0,
       0,     0,     0,   143,   132,     0,   134,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   276,
     275,   150,   316,   318,   317,   319,   149,   151,   377,     0,
       0,     0,   190,     0,     0,   248,     0,     0,   248,     0,
       0,   249,     0,     0,   250,     0,     0,   237,     0,     0,
       0,     0,   248,     0,     0,     0,    64,    59,    43,    41,
      44,     0,    73,     0,   333,   342,   391,   372,     0,   376,
     350,     0,     0,   158,     0,     0,     0,     0,     0,     0,
     336,     0,     0,     0,     0,     0,     0,     0,     0,   126,
     127,     0,     0,   146,   147,   148,   133,   135,     0,   137,
       0,   202,   203,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   188,   189,     0,     0,   218,   261,   262,   225,
     219,   220,   263,   221,   246,   226,     0,   222,   246,     0,
     223,     0,     0,     0,   256,   255,   258,   257,    63,    60,
      61,    62,     0,    72,    68,    67,    70,     0,     0,   157,
     160,   175,     0,     0,     0,   335,     0,     0,     0,     0,
       0,     0,     0,   139,   128,     0,   136,     0,     0,     0,
       0,   162,     0,     0,     0,   343,     0,     0,   140,     0,
       0,     0,   266,   267,     0,     0,     0,     0,   251,     0,
       0,     0,    38,   370,   379,   174,     0,   195,     0,   281,
       0,     0,     0,     0,   280,   129,   200,   201,     0,   163,
       0,     0,     0,   181,   343,   193,   243,   247,     0,     0,
     243,     0,   224,   227,     0,   259,    66,     0,   173,     0,
       0,     0,     0,     0,   161,   169,     0,     0,   344,   182,
       0,     0,     0,   239,     0,     0,     0,     0,     0,     0,
     287,   286,     0,     0,     0,   343,   244,   245,     0,     0,
       0,     0,     0,     0,     0,     0,   285,   284,     0,   176,
     235,   240,     0,     0,     0,   260,    65,     0,   170,     0,
       0,     0,     0,     0,   241,     0,   236,     0,     0,     0,
       0,   194,   242,     0,     0,     0,   238
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1004, -1004, -1004,   470,   -49,     7,   475, -1004, -1004,   164,
       8, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004,
     102, -1004, -1004, -1004,   554,   111, -1004, -1004, -1004, -1004,
   -1004, -1004,  -153, -1004,  -292, -1004, -1004, -1004, -1004, -1004,
   -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004,
   -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004,
   -1004, -1004, -1004, -1004, -1004, -1004, -1004,   296, -1004, -1004,
   -1004, -1004, -1004, -1004, -1004,   133, -1004, -1004, -1004, -1004,
   -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004,
   -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004, -1004,
   -1004,  -144,  -716,  -125,  -123,  -791,  -305,  -208,  -705,  -590,
   -1004, -1003, -1004,  -210,  -698,  -128,  -415,  -902,  -264, -1004,
   -1004, -1004, -1004, -1004, -1004, -1004, -1004,   365, -1004, -1004,
   -1004,   356,     5, -1004,   147,  -170,  -280,     9, -1004,   -24,
    -194, -1004, -1004, -1004,    40, -1004, -1004, -1004,   355, -1004,
     875,  -901, -1004,  -974, -1004,  -124, -1004,  -342, -1004,   386,
   -1004,    15,   561,   564, -1004,  -317,  -330,   389,   585,  -184,
    -209, -1004,  -193, -1004,  -217,  1858,   285,     4,   384,   -29,
     -21,   272,   267,   274,   271,   -65,  -337, -1004,  -472,  -474,
    1506,  -294,  -452,   562
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     2,     8,    62,     3,     4,    63,    64,    65,   385,
     150,    66,    67,     9,    68,    69,    70,    71,    72,    73,
     747,    74,    75,    76,   292,   296,    77,    78,    79,   856,
     857,   943,   750,   751,   450,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   658,
     104,   105,   106,   107,   108,   109,   110,   573,   111,   112,
     113,   580,   721,   114,   115,   423,   116,   117,   832,   118,
     427,   119,   120,   121,   122,   123,   568,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     230,   588,   847,   848,   851,   845,  1042,   979,   843,   844,
     742,   933,   934,   935,   835,   839,   836,   981,   673,   137,
     138,   139,   140,   141,   142,   143,   144,   200,   145,   194,
     502,   393,   179,   197,   350,   304,   368,   821,   822,   823,
     218,   647,   504,   505,   181,   753,   207,   210,   530,   374,
     600,   302,   461,  1013,   351,   369,   370,   824,   508,   825,
     182,   183,   184,   185,   186,   464,   341,   342,   187,   344,
     348,   307,   510,   361,   203,   159,   298,   188,   189,   937,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     190,   191,   496,   497
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     180,   192,   352,   492,   455,   376,   629,   630,   507,   741,
     631,   632,   633,   232,   500,    11,   842,   357,  1046,   166,
     387,   388,   389,   390,   152,   982,   599,   155,   938,   849,
     939,   837,   838,   170,   171,   172,   305,   638,   852,   853,
    1039,   671,   335,   373,   613,   208,   919,   228,   229,   161,
     162,   163,   164,   466,   528,   217,   759,     1,  1073,  1074,
     467,   381,   932,   470,   672,   220,  1018,   476,   477,   233,
     336,     5,   235,  1019,   513,   345,   670,  1016,   982,  1087,
     346,  1069,  1020,   982,   503,   166,   862,  1093,   863,   305,
     219,  1095,   478,   479,   166,   476,   642,   309,   170,   171,
     172,  1059,   168,   169,   330,   331,   309,   305,  1060,  1058,
     462,   168,   169,   940,   297,    10,  1061,  1044,   982,   916,
     478,   479,   465,  1026,     6,  1079,   615,   563,   310,   311,
     177,   178,  1080,   849,   166,   148,   931,   312,   149,   625,
     626,   627,   628,   846,   923,   514,   309,   925,   616,   166,
     927,   168,   169,   614,   490,     7,   339,   609,  1072,   982,
     639,   309,   299,   649,   306,   452,   168,   169,    12,   308,
     544,   545,   546,   547,   355,   147,   485,   486,  1085,   982,
     944,   487,   448,   338,   463,   366,   295,   541,   372,   343,
     170,   465,   172,   146,   310,   311,   177,   178,   349,   353,
     153,   173,   174,   175,   324,   177,   178,   151,   170,   171,
     172,   364,   166,   154,   367,   306,   156,   375,   349,   158,
     165,   338,   157,   345,   309,   493,   494,   495,   346,   168,
     169,   379,   485,   486,   470,   306,   166,  1017,   196,   471,
     170,   171,   172,   310,   311,   177,   178,   846,   309,   170,
     171,   172,   463,   168,   169,   431,   432,   535,   310,   311,
     177,   178,   447,   846,   784,   453,   454,   193,   643,   687,
     688,   690,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   435,   436,   480,   481,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   463,   718,   482,
     483,   484,   652,   199,   765,   626,   880,   201,   643,   217,
     643,   491,   744,   745,   498,  -423,   840,   330,   331,   220,
    -423,   310,   311,   177,   178,   439,   440,   682,   683,   684,
     685,   465,   170,   171,   172,   232,   286,   287,   288,   289,
     290,   689,   691,   202,   219,   310,   311,   177,   178,   989,
     532,   204,   536,   990,   511,   217,   332,   333,   515,   205,
     517,   518,   170,   300,   172,   521,   522,   841,   738,   739,
     740,   332,   333,   334,   170,   598,   172,   531,   534,   474,
     475,   537,   538,   539,   206,   352,   217,   738,   739,   740,
     506,   542,   640,   641,   209,   576,   220,   480,   481,   917,
     918,  1040,  1041,   449,   451,   424,   425,   779,   780,   623,
     624,   306,   223,   211,   604,   605,   606,   607,   216,   215,
     221,   219,   222,   225,   226,   575,   291,   224,   227,   294,
     295,   340,   343,   358,   360,   362,   840,   585,   617,   618,
     363,   380,   392,   408,   409,   601,   410,   411,   412,   413,
     980,   414,   415,   416,   980,   859,   860,   422,   426,   430,
     433,   434,   437,   438,   442,   443,   441,   790,   791,   444,
     644,   445,   446,   448,   456,   457,   458,   468,   460,   469,
     795,   473,   797,   653,   472,   488,   499,   512,   520,   654,
     655,   463,   540,   656,   659,   501,   577,   523,   526,   529,
     579,   567,   668,   543,   572,   603,   676,   646,   564,   827,
     217,   548,   570,   584,   586,   679,   986,   987,   581,   582,
     650,   587,   608,   660,   945,   663,   664,   297,   637,   611,
     643,   947,   651,   645,   948,   465,   652,   665,   661,   674,
     675,   705,   706,   303,   383,   648,   681,   686,   720,   704,
     707,   746,   712,   306,   515,   515,   306,   306,   306,   306,
     306,   306,   306,   306,   306,   306,   306,   306,  1056,   715,
     864,  1022,  1023,   709,   743,   711,   727,   749,   752,   756,
     716,   758,   719,   757,   755,   725,   777,   724,   890,   760,
     641,   765,   303,   882,   883,   884,   775,   781,   887,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   761,   850,   762,   829,   754,   854,   787,   855,
     858,   792,   763,   764,   810,   819,   421,   820,   861,   865,
     766,   767,   867,   870,   769,   770,   771,   868,   912,   869,
     774,   871,   880,   942,   922,   782,   783,   924,   926,   928,
     929,   992,   991,  1021,   993,   786,   955,   988,   994,  1025,
    1065,  1043,  1058,   793,   794,  1047,   796,  1070,   798,   799,
     800,   801,   802,   803,   804,   805,   806,   807,   808,   809,
    1048,  1062,  1071,  1075,  1076,   303,  1082,   816,  1081,   958,
     959,   960,   961,   349,  1089,   349,  1090,  1083,   830,   831,
    1094,  1084,  1086,  1092,  1096,   384,   680,   382,   293,   748,
     946,  1064,   574,   920,   815,  1045,   921,   817,   818,   985,
     984,   511,   828,   930,   519,   717,   489,   826,   325,   533,
     834,   326,   601,   601,   601,   601,   509,   619,   866,   303,
     601,   601,   610,   620,   622,   872,   621,  1057,   303,   303,
     877,   303,   347,   879,     0,     0,     0,     0,     0,     0,
       0,     0,   881,     0,   337,     0,  1002,  1003,     0,   888,
       0,     0,   889,     0,   891,   892,   893,   894,   895,     0,
       0,   896,     0,   897,   898,   899,     0,     0,     0,     0,
       0,   905,   217,   217,   217,     0,   371,   217,     0,     0,
       0,   349,   220,   220,   220,     0,     0,   220,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   602,   941,   219,   219,   219,
       0,     0,   219,     0,   910,   911,     0,   217,     0,     0,
       0,     0,     0,   303,     0,     0,   601,   220,     0,   601,
       0,     0,   601,   953,     0,   601,     0,   956,   936,     0,
       0,     0,     0,     0,   963,     0,     0,   964,   965,     0,
       0,     0,   219,     0,   966,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   974,     0,     0,   217,   217,
     217,   217,     0,     0,     0,     0,     0,     0,   220,   220,
     220,   220,     0,     0,     0,   602,     0,     0,   303,   303,
       0,   303,     0,     0,     0,   976,     0,     0,     0,     0,
       0,   303,   303,   219,   219,   219,   219,     0,     0,   996,
       0,     0,   998,   936,     0,   601,   601,     0,     0,   371,
       0,  1005,     0,     0,     0,     0,     0,   161,   162,   163,
     164,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1024,     0,     0,     0,     0,   217,   217,   165,   166,     0,
       0,     0,     0,     0,  1029,   220,   220,     0,  1012,     0,
     167,     0,   503,     0,     0,   168,   169,     0,     0,     0,
     601,   601,   371,     0,     0,  1027,   170,   171,   172,     0,
     219,   219,     0,     0,     0,  1049,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1037,     0,  1063,     0,
       0,     0,     0,     0,     0,   936,     0,     0,     0,     0,
       0,     0,     0,     0,   301,     0,     0,     0,     0,     0,
     303,  1077,     0,     0,     0,     0,   303,   303,     0,     0,
     303,     0,     0,   303,     0,     0,     0,     0,     0,  1088,
       0,   303,     0,     0,     0,   936,   936,     0,     0,     0,
       0,     0,     0,     0,     0,   173,   174,   175,   176,   177,
     178,     0,     0,   365,     0,     0,   936,     0,     0,   303,
     303,     0,   303,   303,   936,     0,     0,     0,   936,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   303,
       0,     0,   602,   602,   602,   602,     0,     0,     0,     0,
     602,   602,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   371,   371,   371,   371,   371,   371,
     371,   371,   371,   371,   371,   371,   371,   371,   371,     0,
       0,     0,     0,     0,   303,   303,   303,   303,     0,     0,
     303,     0,     0,   371,     0,     0,     0,     0,     0,     0,
       0,     0,   161,   162,   163,   164,   459,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   165,   166,     0,   303,   303,   303,   303,     0,
     303,   303,   303,     0,     0,   167,     0,     0,     0,     0,
     168,   169,     0,     0,     0,     0,   602,   303,   303,     0,
       0,   170,   171,   172,     0,     0,   602,     0,     0,   602,
     516,     0,   602,     0,     0,   602,     0,     0,     0,   524,
     525,     0,   527,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   303,     0,   303,   303,
     303,     0,   303,     0,     0,     0,   303,     0,     0,     0,
       0,   303,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   303,     0,     0,   303,   303,   303,
     303,   303,   303,     0,   303,     0,     0,     0,   303,   303,
     173,   174,   175,   176,   177,   178,     0,     0,     0,     0,
     983,     0,     0,     0,     0,   602,   602,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   161,   162,   163,   164,
       0,     0,     0,     0,   612,     0,   303,     0,   303,     0,
       0,   303,   303,   303,     0,     0,   303,   166,     0,     0,
       0,   303,   303,   303,   303,     0,   303,   303,     0,   167,
     303,   303,     0,   983,   168,   169,     0,     0,   983,     0,
     602,   602,     0,     0,     0,   170,   171,   172,     0,     0,
     303,     0,     0,     0,   303,   303,   303,   303,     0,     0,
       0,     0,   303,     0,   303,   303,   662,   303,     0,   666,
     667,     0,   669,   983,     0,     0,     0,     0,     0,     0,
       0,     0,   677,   678,   303,   303,   303,   303,     0,     0,
     303,   303,     0,   303,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   303,   303,   303,     0,
     161,   162,   163,   164,   983,     0,     0,     0,     0,     0,
       0,     0,   303,   303,   173,   174,   175,   176,   177,   178,
     165,   166,     0,     0,   983,     0,     0,     0,     0,     0,
       0,     0,   303,   167,     0,    -9,     0,     0,   168,   169,
      13,    14,    15,    16,    17,    18,    19,    20,    21,   170,
     171,   172,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    22,    23,    24,
      25,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   768,     0,    26,     0,    27,    -9,   772,   773,     0,
       0,   776,     0,     0,   778,     0,     0,     0,     0,     0,
       0,     0,   785,     0,     0,     0,     0,     0,     0,     0,
      28,     0,     0,     0,     0,     6,     0,     0,   173,   174,
     657,   176,   177,   178,    29,     0,     0,     0,     0,     0,
     811,   812,     0,   813,   814,     0,     0,     0,     0,    30,
      31,     0,     0,     0,     0,    32,    33,    34,     0,     0,
     833,    35,    36,    37,     0,     0,    38,    39,    40,    41,
      42,     0,     0,     0,     0,    43,    44,    45,    46,     0,
      47,    48,    49,    50,    51,    52,    53,    54,     0,     0,
       0,    55,    56,     0,     0,    57,    58,    59,     0,     0,
       0,     0,     0,     0,     0,   873,   874,   875,   876,     0,
       0,   878,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   161,   162,   163,   164,     0,    60,    61,
       0,     0,   323,   327,   328,   329,     0,     0,   161,   162,
     163,   164,     0,     0,   166,     0,   901,   902,   903,   904,
       0,   906,   907,   908,     0,     0,   167,     0,   503,   166,
       0,   168,   169,     0,     0,     0,     0,   913,   914,   915,
       0,   167,   170,   171,   172,     0,   168,   169,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   170,   598,   172,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   949,     0,   950,
     951,   952,     0,   954,     0,     0,     0,   957,     0,     0,
       0,     0,   962,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   967,     0,     0,   968,   969,
     970,   971,   972,   973,     0,   975,     0,     0,     0,   977,
     978,   173,   174,   175,   176,   177,   178,   323,     0,     0,
     323,   323,     0,     0,     0,     0,   173,   174,   175,   176,
     177,   178,     0,     0,     0,   327,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   995,     0,   997,
       0,     0,   999,  1000,  1001,     0,     0,  1004,     0,     0,
       0,     0,  1006,  1007,  1008,  1009,   323,  1010,  1011,   323,
       0,  1014,  1015,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1028,     0,     0,     0,  1030,  1031,  1032,  1033,     0,
       0,   160,     0,  1034,     0,  1035,  1036,   195,  1038,   198,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   212,   213,   214,  1050,  1051,  1052,  1053,     0,
       0,  1054,  1055,     0,  1038,     0,     0,     0,     0,   231,
       0,     0,     0,     0,     0,     0,     0,  1066,  1067,  1068,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1078,  1038,     0,     0,     0,     0,   323,
     323,   323,   323,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1091,     0,     0,     0,     0,     0,   323,
       0,     0,     0,   323,   323,     0,   323,   323,   323,   323,
     323,   323,   323,   323,   323,   323,   323,   323,   323,   323,
     323,   634,   635,   636,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   323,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   323,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   323,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   354,     0,     0,   356,     0,
       0,   359,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   377,   378,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   386,     0,     0,     0,     0,   391,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   323,
       0,     0,     0,     0,   407,     0,     0,     0,     0,   323,
       0,     0,     0,     0,   417,   418,   419,   420,     0,     0,
       0,     0,     0,   428,   429,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   323,   323,   323,
       0,     0,     0,     0,     0,     0,     0,   323,   323,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     323,   323,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    13,    14,    15,    16,    17,    18,    19,
      20,    21,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      22,    23,    24,    25,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    26,     0,    27,   383,
       0,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   323,     0,   565,   566,     0,
     569,     0,   571,    28,     0,     0,     0,     0,     0,   578,
       0,     0,     0,     0,     0,   583,     0,    29,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    30,    31,     0,     0,     0,     0,    32,    33,
      34,     0,     0,     0,    35,    36,    37,     0,     0,    38,
      39,    40,    41,    42,     0,     0,     0,     0,    43,    44,
      45,    46,     0,    47,    48,    49,    50,    51,    52,    53,
      54,     0,     0,     0,    55,    56,     0,     0,    57,    58,
      59,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     323,   323,     0,     0,     0,     0,     0,   323,     0,     0,
       0,     0,     0,     0,   323,     0,     0,   323,     0,     0,
       0,    60,    61,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   708,     0,   710,     0,
     323,   713,   714,     0,   323,     0,     0,     0,     0,   722,
     723,     0,     0,     0,   726,     0,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   323,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   636,     0,     0,     0,   323,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     788,   789,     0,     0,     0,     0,   323,     0,     0,     0,
       0,     0,     0,   323,   323,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   323,   323,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   323,     0,
       0,     0,     0,     0,     0,     0,   323,   234,     0,     0,
     323,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    -8,    -8,    -8,    -8,
      -8,    -8,     0,     0,     0,     0,     0,    -8,    -8,    -8,
      -8,    -8,     0,     0,     0,     0,     0,     0,   885,   886,
       0,     0,     0,     0,    -8,     0,    -8,    -8,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   900,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    -8,     0,     0,     0,     0,     1,   909,     0,     0,
       0,     0,     0,     0,     0,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
       0,     0,     0,     0,     0,     0,     0,    -8,    13,    14,
      15,    16,    17,    18,    19,    20,    21,     0,     0,     0,
       0,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    22,    23,    24,    25,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    26,     0,    27,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    28,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    29,     0,     0,   236,   237,   238,   239,   240,
     241,     0,     0,     0,     0,     0,   242,    30,    31,     0,
       0,     0,     0,    32,    33,    34,     0,     0,     0,    35,
      36,    37,     0,     0,    38,    39,    40,    41,    42,     0,
       0,     0,     0,    43,    44,    45,    46,     0,    47,    48,
      49,    50,    51,    52,    53,    54,     0,     0,     0,    55,
      56,     0,     0,    57,    58,    59,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,     0,
       0,   257,   258,   259,   260,     0,    60,    61,   261,   262,
     263,     0,     0,     0,   264,   265,     0,     0,     0,     0,
       0,   266,   267,   268,   269,     0,     0,     0,     0,   270,
       0,     0,     0,     0,     0,     0,     0,     0,   271,   272,
     273,     0,     0,   274,   275,     0,     0,     0,   276,     0,
       0,     0,     0,     0,     0,     0,   277,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     278,   279,   280,   281,   282,   283,   284,   285
};

static const yytype_int16 yycheck[] =
{
      24,    25,   195,   340,   296,   214,   480,   481,   350,   599,
     482,   483,   484,    62,   344,     8,   732,   201,  1021,    58,
     237,   238,   239,   240,    16,   926,   441,    19,     1,   734,
       3,   729,   730,    86,    87,    88,   160,   489,   736,   737,
    1014,    63,    58,   213,    58,    41,   837,   183,   184,    37,
      38,    39,    40,    56,   371,    50,    65,    90,  1061,  1062,
      63,   231,   853,    72,    86,    50,    56,    53,    54,    62,
      86,     0,    65,    63,   354,    46,   528,   979,   979,  1082,
      51,  1055,   984,   984,    72,    58,    61,  1090,    63,   213,
      50,  1094,    78,    79,    58,    53,    54,    70,    86,    87,
      88,    56,    75,    76,    48,    49,    70,   231,    63,    56,
     304,    75,    76,    86,   167,   167,    63,  1019,  1019,   835,
      78,    79,   306,     1,    90,    56,   463,   407,   167,   168,
     169,   170,    63,   838,    58,    86,   852,   166,    89,   476,
     477,   478,   479,   733,   842,   354,    70,   845,   465,    58,
     848,    75,    76,   167,   338,    14,   180,   449,  1060,  1060,
     490,    70,   158,   505,   160,    89,    75,    76,    62,   165,
     387,   388,   389,   390,   198,    86,    66,    67,  1080,  1080,
      89,    71,    17,   179,    53,   209,    21,   381,   212,    58,
      86,   375,    88,   167,   167,   168,   169,   170,   194,   195,
      86,   165,   166,   167,   168,   169,   170,    89,    86,    87,
      88,   207,    58,    86,   210,   211,    86,   213,   214,    58,
      57,   217,    86,    46,    70,    48,    49,    50,    51,    75,
      76,   227,    66,    67,    72,   231,    58,    71,    52,    77,
      86,    87,    88,   167,   168,   169,   170,   837,    70,    86,
      87,    88,    53,    75,    76,   183,   184,    58,   167,   168,
     169,   170,   291,   853,    59,   294,   295,    76,    63,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   183,   184,    69,    70,   432,   433,
     434,   435,   436,   437,   438,   439,   440,    53,   578,    82,
      83,    84,    58,    93,    59,   642,    59,    92,    63,   304,
      63,   340,   604,   605,   343,    46,   731,    48,    49,   304,
      51,   167,   168,   169,   170,   183,   184,   544,   545,   546,
     547,   515,    86,    87,    88,   384,    22,    23,    24,    25,
      26,   550,   551,    62,   304,   167,   168,   169,   170,    58,
     374,    94,   376,    62,   350,   350,    48,    49,   354,    94,
     356,   357,    86,    87,    88,   361,   362,   177,   178,   179,
     180,    48,    49,    50,    86,    87,    88,   373,   374,    80,
      81,   377,   378,   379,    58,   578,   381,   178,   179,   180,
     350,   384,    63,    64,    58,   419,   381,    69,    70,   174,
     175,    69,    70,   292,   293,   272,   273,   671,   672,   474,
     475,   407,    94,    86,   443,   444,   445,   446,   167,    89,
      98,   381,    98,    86,    86,   417,    18,    94,    94,    68,
      21,    53,    58,   167,    58,    95,   851,   429,   467,   468,
     167,   181,    36,    62,    94,   441,    94,     4,    94,    62,
     924,    94,     4,     4,   928,   747,   748,    29,    91,    62,
     183,   183,   183,   183,    47,    19,   184,   684,   685,    19,
     499,    19,    19,    17,    59,    63,    62,    58,    62,    59,
     689,    74,   691,   512,    73,    86,    53,    58,   167,   513,
     514,    53,   182,   517,   518,   164,    86,    63,    63,    58,
      27,    62,   526,   168,    62,    19,   535,   503,   167,   718,
     505,   168,   167,   167,   167,   539,   931,   932,    94,    94,
     505,   172,    60,   519,   861,   521,   522,   167,    59,   167,
      63,   868,    55,    59,   871,   719,    58,   167,    59,    58,
      58,   565,   566,   159,    61,   505,   167,   167,    28,    62,
     167,    20,   167,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,  1040,   167,
     754,   986,   987,   569,   603,   571,   172,    86,    59,    54,
     167,    59,   578,    56,   613,   167,    63,   583,   797,   167,
      64,    59,   208,   787,   788,   789,    59,    59,   792,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   641,   177,   643,    94,   612,    58,   167,    16,
      86,   167,   651,   652,   167,   167,   270,   167,    68,    59,
     654,   655,    54,    56,   658,   659,   660,    63,   832,    59,
     664,    53,    59,    15,   176,   674,   675,    55,    55,    55,
      55,   943,    53,    63,    54,   679,    59,    59,    54,   167,
      97,   173,    56,   687,   688,    63,   690,   173,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
      63,    63,   173,    59,    54,   301,    63,   711,    56,   883,
     884,   885,   886,   689,    56,   691,    63,    96,   722,   723,
      63,   173,   173,   173,    56,   235,   542,   232,   154,   607,
     863,  1048,   416,   838,   710,  1020,   839,   713,   714,   929,
     928,   717,   718,   851,   359,   578,   337,   718,   167,   374,
     726,   167,   728,   729,   730,   731,   350,   470,   759,   355,
     736,   737,   457,   471,   473,   769,   472,  1041,   364,   365,
     774,   367,   190,   777,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   786,    -1,   179,    -1,   960,   961,    -1,   793,
      -1,    -1,   796,    -1,   798,   799,   800,   801,   802,    -1,
      -1,   805,    -1,   807,   808,   809,    -1,    -1,    -1,    -1,
      -1,   815,   787,   788,   789,    -1,   211,   792,    -1,    -1,
      -1,   797,   787,   788,   789,    -1,    -1,   792,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   441,   855,   787,   788,   789,
      -1,    -1,   792,    -1,   830,   831,    -1,   832,    -1,    -1,
      -1,    -1,    -1,   459,    -1,    -1,   842,   832,    -1,   845,
      -1,    -1,   848,   877,    -1,   851,    -1,   881,   854,    -1,
      -1,    -1,    -1,    -1,   888,    -1,    -1,   891,   892,    -1,
      -1,    -1,   832,    -1,   898,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   909,    -1,    -1,   883,   884,
     885,   886,    -1,    -1,    -1,    -1,    -1,    -1,   883,   884,
     885,   886,    -1,    -1,    -1,   521,    -1,    -1,   524,   525,
      -1,   527,    -1,    -1,    -1,   911,    -1,    -1,    -1,    -1,
      -1,   537,   538,   883,   884,   885,   886,    -1,    -1,   953,
      -1,    -1,   956,   929,    -1,   931,   932,    -1,    -1,   354,
      -1,   965,    -1,    -1,    -1,    -1,    -1,    37,    38,    39,
      40,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     989,    -1,    -1,    -1,    -1,   960,   961,    57,    58,    -1,
      -1,    -1,    -1,    -1,   998,   960,   961,    -1,   974,    -1,
      70,    -1,    72,    -1,    -1,    75,    76,    -1,    -1,    -1,
     986,   987,   407,    -1,    -1,   991,    86,    87,    88,    -1,
     960,   961,    -1,    -1,    -1,  1029,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1012,    -1,  1047,    -1,
      -1,    -1,    -1,    -1,    -1,  1021,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   159,    -1,    -1,    -1,    -1,    -1,
     656,  1065,    -1,    -1,    -1,    -1,   662,   663,    -1,    -1,
     666,    -1,    -1,   669,    -1,    -1,    -1,    -1,    -1,  1083,
      -1,   677,    -1,    -1,    -1,  1061,  1062,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   165,   166,   167,   168,   169,
     170,    -1,    -1,   208,    -1,    -1,  1082,    -1,    -1,   705,
     706,    -1,   708,   709,  1090,    -1,    -1,    -1,  1094,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   725,
      -1,    -1,   728,   729,   730,   731,    -1,    -1,    -1,    -1,
     736,   737,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,    -1,
      -1,    -1,    -1,    -1,   770,   771,   772,   773,    -1,    -1,
     776,    -1,    -1,   578,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    39,    40,   301,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    57,    58,    -1,   811,   812,   813,   814,    -1,
     816,   817,   818,    -1,    -1,    70,    -1,    -1,    -1,    -1,
      75,    76,    -1,    -1,    -1,    -1,   832,   833,   834,    -1,
      -1,    86,    87,    88,    -1,    -1,   842,    -1,    -1,   845,
     355,    -1,   848,    -1,    -1,   851,    -1,    -1,    -1,   364,
     365,    -1,   367,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   872,    -1,   874,   875,
     876,    -1,   878,    -1,    -1,    -1,   882,    -1,    -1,    -1,
      -1,   887,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   900,    -1,    -1,   903,   904,   905,
     906,   907,   908,    -1,   910,    -1,    -1,    -1,   914,   915,
     165,   166,   167,   168,   169,   170,    -1,    -1,    -1,    -1,
     926,    -1,    -1,    -1,    -1,   931,   932,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    39,    40,
      -1,    -1,    -1,    -1,   459,    -1,   952,    -1,   954,    -1,
      -1,   957,   958,   959,    -1,    -1,   962,    58,    -1,    -1,
      -1,   967,   968,   969,   970,    -1,   972,   973,    -1,    70,
     976,   977,    -1,   979,    75,    76,    -1,    -1,   984,    -1,
     986,   987,    -1,    -1,    -1,    86,    87,    88,    -1,    -1,
     996,    -1,    -1,    -1,  1000,  1001,  1002,  1003,    -1,    -1,
      -1,    -1,  1008,    -1,  1010,  1011,   521,  1013,    -1,   524,
     525,    -1,   527,  1019,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   537,   538,  1030,  1031,  1032,  1033,    -1,    -1,
    1036,  1037,    -1,  1039,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1052,  1053,  1054,    -1,
      37,    38,    39,    40,  1060,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1068,  1069,   165,   166,   167,   168,   169,   170,
      57,    58,    -1,    -1,  1080,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1088,    70,    -1,     0,    -1,    -1,    75,    76,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    86,
      87,    88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,    44,
      45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   656,    -1,    58,    -1,    60,    61,   662,   663,    -1,
      -1,   666,    -1,    -1,   669,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   677,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      85,    -1,    -1,    -1,    -1,    90,    -1,    -1,   165,   166,
     167,   168,   169,   170,    99,    -1,    -1,    -1,    -1,    -1,
     705,   706,    -1,   708,   709,    -1,    -1,    -1,    -1,   114,
     115,    -1,    -1,    -1,    -1,   120,   121,   122,    -1,    -1,
     725,   126,   127,   128,    -1,    -1,   131,   132,   133,   134,
     135,    -1,    -1,    -1,    -1,   140,   141,   142,   143,    -1,
     145,   146,   147,   148,   149,   150,   151,   152,    -1,    -1,
      -1,   156,   157,    -1,    -1,   160,   161,   162,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   770,   771,   772,   773,    -1,
      -1,   776,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    39,    40,    -1,   193,   194,
      -1,    -1,   166,   167,   168,   169,    -1,    -1,    37,    38,
      39,    40,    -1,    -1,    58,    -1,   811,   812,   813,   814,
      -1,   816,   817,   818,    -1,    -1,    70,    -1,    72,    58,
      -1,    75,    76,    -1,    -1,    -1,    -1,   832,   833,   834,
      -1,    70,    86,    87,    88,    -1,    75,    76,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    86,    87,    88,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   872,    -1,   874,
     875,   876,    -1,   878,    -1,    -1,    -1,   882,    -1,    -1,
      -1,    -1,   887,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   900,    -1,    -1,   903,   904,
     905,   906,   907,   908,    -1,   910,    -1,    -1,    -1,   914,
     915,   165,   166,   167,   168,   169,   170,   291,    -1,    -1,
     294,   295,    -1,    -1,    -1,    -1,   165,   166,   167,   168,
     169,   170,    -1,    -1,    -1,   309,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   952,    -1,   954,
      -1,    -1,   957,   958,   959,    -1,    -1,   962,    -1,    -1,
      -1,    -1,   967,   968,   969,   970,   340,   972,   973,   343,
      -1,   976,   977,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   996,    -1,    -1,    -1,  1000,  1001,  1002,  1003,    -1,
      -1,    23,    -1,  1008,    -1,  1010,  1011,    29,  1013,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    44,    45,    46,  1030,  1031,  1032,  1033,    -1,
      -1,  1036,  1037,    -1,  1039,    -1,    -1,    -1,    -1,    61,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1052,  1053,  1054,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1068,  1069,    -1,    -1,    -1,    -1,   443,
     444,   445,   446,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1088,    -1,    -1,    -1,    -1,    -1,   463,
      -1,    -1,    -1,   467,   468,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   499,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   512,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   535,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   197,    -1,    -1,   200,    -1,
      -1,   203,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   223,   224,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   236,    -1,    -1,    -1,    -1,   241,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   603,
      -1,    -1,    -1,    -1,   256,    -1,    -1,    -1,    -1,   613,
      -1,    -1,    -1,    -1,   266,   267,   268,   269,    -1,    -1,
      -1,    -1,    -1,   275,   276,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   641,   642,   643,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   651,   652,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     674,   675,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      42,    43,    44,    45,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    58,    -1,    60,    61,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   759,    -1,   409,   410,    -1,
     412,    -1,   414,    85,    -1,    -1,    -1,    -1,    -1,   421,
      -1,    -1,    -1,    -1,    -1,   427,    -1,    99,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,    -1,    -1,    -1,    -1,   120,   121,
     122,    -1,    -1,    -1,   126,   127,   128,    -1,    -1,   131,
     132,   133,   134,   135,    -1,    -1,    -1,    -1,   140,   141,
     142,   143,    -1,   145,   146,   147,   148,   149,   150,   151,
     152,    -1,    -1,    -1,   156,   157,    -1,    -1,   160,   161,
     162,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     854,   855,    -1,    -1,    -1,    -1,    -1,   861,    -1,    -1,
      -1,    -1,    -1,    -1,   868,    -1,    -1,   871,    -1,    -1,
      -1,   193,   194,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   568,    -1,   570,    -1,
     924,   573,   574,    -1,   928,    -1,    -1,    -1,    -1,   581,
     582,    -1,    -1,    -1,   586,    -1,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   989,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1017,    -1,    -1,    -1,  1021,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     682,   683,    -1,    -1,    -1,    -1,  1040,    -1,    -1,    -1,
      -1,    -1,    -1,  1047,  1048,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1061,  1062,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1082,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1090,     1,    -1,    -1,
    1094,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,    33,
      34,    35,    -1,    -1,    -1,    -1,    -1,    41,    42,    43,
      44,    45,    -1,    -1,    -1,    -1,    -1,    -1,   790,   791,
      -1,    -1,    -1,    -1,    58,    -1,    60,    61,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   810,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    85,    -1,    -1,    -1,    -1,    90,   829,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   171,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    -1,    -1,
      -1,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    42,    43,    44,    45,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    58,    -1,    60,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    85,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    99,    -1,    -1,    30,    31,    32,    33,    34,
      35,    -1,    -1,    -1,    -1,    -1,    41,   114,   115,    -1,
      -1,    -1,    -1,   120,   121,   122,    -1,    -1,    -1,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
      -1,    -1,    -1,   140,   141,   142,   143,    -1,   145,   146,
     147,   148,   149,   150,   151,   152,    -1,    -1,    -1,   156,
     157,    -1,    -1,   160,   161,   162,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
      -1,   116,   117,   118,   119,    -1,   193,   194,   123,   124,
     125,    -1,    -1,    -1,   129,   130,    -1,    -1,    -1,    -1,
      -1,   136,   137,   138,   139,    -1,    -1,    -1,    -1,   144,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   153,   154,
     155,    -1,    -1,   158,   159,    -1,    -1,    -1,   163,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   171,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     185,   186,   187,   188,   189,   190,   191,   192
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,    90,   196,   199,   200,     0,    90,    14,   197,   208,
     167,   200,    62,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    42,    43,    44,    45,    58,    60,    85,    99,
     114,   115,   120,   121,   122,   126,   127,   128,   131,   132,
     133,   134,   135,   140,   141,   142,   143,   145,   146,   147,
     148,   149,   150,   151,   152,   156,   157,   160,   161,   162,
     193,   194,   198,   201,   202,   203,   206,   207,   209,   210,
     211,   212,   213,   214,   216,   217,   218,   221,   222,   223,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   255,   256,   257,   258,   259,   260,
     261,   263,   264,   265,   268,   269,   271,   272,   274,   276,
     277,   278,   279,   280,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   314,   315,   316,
     317,   318,   319,   320,   321,   323,   167,    86,    86,    89,
     205,    89,   205,    86,    86,   205,    86,    86,    58,   370,
     370,    37,    38,    39,    40,    57,    58,    70,    75,    76,
      86,    87,    88,   165,   166,   167,   168,   169,   170,   327,
     334,   339,   355,   356,   357,   358,   359,   363,   372,   373,
     385,   386,   334,    76,   324,   370,    52,   328,   370,    93,
     322,    92,    62,   369,    94,    94,    58,   341,   372,    58,
     342,    86,   370,   370,   370,    89,   167,   327,   335,   339,
     356,    98,    98,    94,    94,    86,    86,    94,   183,   184,
     295,   370,   199,   200,     1,   200,    30,    31,    32,    33,
      34,    35,    41,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   116,   117,   118,
     119,   123,   124,   125,   129,   130,   136,   137,   138,   139,
     144,   153,   154,   155,   158,   159,   163,   171,   185,   186,
     187,   188,   189,   190,   191,   192,    22,    23,    24,    25,
      26,    18,   219,   219,    68,    21,   220,   167,   371,   372,
      87,   345,   346,   373,   330,   350,   372,   366,   372,    70,
     167,   168,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   168,   357,   358,   385,   385,   385,
      48,    49,    48,    49,    50,    58,    86,   363,   372,   334,
      53,   361,   362,    58,   364,    46,    51,   388,   365,   372,
     329,   349,   367,   372,   370,   334,   370,   364,   167,   370,
      58,   368,    95,   167,   372,   345,   334,   372,   331,   350,
     351,   363,   334,   330,   344,   372,   365,   370,   370,   372,
     181,   330,   201,    61,   198,   204,   370,   369,   369,   369,
     369,   370,    36,   326,   326,   326,   326,   326,   326,   326,
     326,   326,   326,   326,   326,   326,   326,   370,    62,    94,
      94,     4,    94,    62,    94,     4,     4,   370,   370,   370,
     370,   326,    29,   270,   270,   270,    91,   275,   370,   370,
      62,   183,   184,   183,   183,   183,   184,   183,   183,   183,
     184,   184,    47,    19,    19,    19,    19,   374,    17,   220,
     229,   220,    89,   374,   374,   229,    59,    63,    62,   345,
      62,   347,   335,    53,   360,   364,    56,    63,    58,    59,
      72,    77,    73,    74,    80,    81,    53,    54,    78,    79,
      69,    70,    82,    83,    84,    66,    67,    71,    86,   362,
     364,   374,   381,    48,    49,    50,   387,   388,   374,    53,
     361,   164,   325,    72,   337,   338,   339,   352,   353,   354,
     367,   372,    58,   331,   365,   372,   345,   372,   372,   322,
     167,   372,   372,    63,   345,   345,    63,   345,   360,    58,
     343,   372,   334,   343,   372,    58,   334,   372,   372,   372,
     182,   335,   200,   168,   369,   369,   369,   369,   168,   370,
     370,   370,   370,   370,   370,   370,   370,   370,   370,   370,
     370,   370,   370,   331,   167,   370,   370,    62,   281,   370,
     167,   370,    62,   262,   262,   205,   334,    86,   370,    27,
     266,    94,    94,   370,   167,   205,   167,   172,   296,   296,
     296,   296,   296,   296,   296,   296,   296,   296,    87,   311,
     345,   372,   373,    19,   374,   374,   374,   374,    60,   229,
     371,   167,   345,    58,   167,   381,   360,   374,   374,   377,
     376,   378,   379,   380,   380,   381,   381,   381,   381,   384,
     384,   383,   383,   383,   385,   385,   385,    59,   387,   361,
      63,    64,    54,    63,   374,    59,   372,   336,   339,   352,
     356,    55,    58,   374,   334,   334,   334,   167,   254,   334,
     372,    59,   345,   372,   372,   167,   345,   345,   334,   345,
     387,    63,    86,   313,    58,    58,   374,   345,   345,   334,
     204,   167,   369,   369,   369,   369,   167,   331,   331,   365,
     331,   365,   331,   331,   331,   331,   331,   331,   331,   331,
     331,   331,   331,   331,    62,   334,   334,   167,   370,   372,
     370,   372,   167,   370,   370,   167,   167,   329,   331,   372,
      28,   267,   370,   370,   372,   167,   370,   172,   370,   370,
     370,   370,   370,   370,   370,   370,   370,   370,   178,   179,
     180,   304,   305,   374,   229,   229,    20,   215,   215,    86,
     227,   228,    59,   340,   372,   374,    54,    56,    59,    65,
     167,   374,   374,   374,   374,    59,   334,   334,   345,   334,
     334,   334,   345,   345,   334,    59,   345,    63,   345,   313,
     313,    59,   374,   374,    59,   345,   334,   167,   370,   370,
     369,   369,   167,   334,   334,   365,   334,   365,   334,   334,
     334,   334,   334,   334,   334,   334,   334,   334,   334,   334,
     167,   345,   345,   345,   345,   372,   334,   372,   372,   167,
     167,   332,   333,   334,   352,   354,   332,   365,   372,    94,
     334,   334,   273,   345,   372,   309,   311,   309,   309,   310,
     311,   177,   297,   303,   304,   300,   304,   297,   298,   303,
     177,   299,   309,   309,    58,    16,   224,   225,    86,   229,
     229,    68,    61,    63,   364,    59,   375,    54,    63,    59,
      56,    53,   334,   345,   345,   345,   345,   334,   345,   334,
      59,   334,   335,   335,   335,   370,   370,   335,   334,   334,
     365,   334,   334,   334,   334,   334,   334,   334,   334,   334,
     370,   345,   345,   345,   345,   334,   345,   345,   345,   370,
     372,   372,   335,   345,   345,   345,   297,   174,   175,   300,
     298,   299,   176,   309,    55,   309,    55,   309,    55,    55,
     310,   297,   300,   306,   307,   308,   372,   374,     1,     3,
      86,   374,    15,   226,    89,   381,   227,   381,   381,   345,
     345,   345,   345,   334,   345,    59,   334,   345,   335,   335,
     335,   335,   345,   334,   334,   334,   334,   345,   345,   345,
     345,   345,   345,   345,   334,   345,   372,   345,   345,   302,
     384,   312,   346,   373,   302,   308,   311,   311,    59,    58,
      62,    53,   229,    54,    54,   345,   334,   345,   334,   345,
     345,   345,   335,   335,   345,   334,   345,   345,   345,   345,
     345,   345,   372,   348,   345,   345,   312,    71,    56,    63,
     312,    63,   311,   311,   374,   167,     1,   372,   345,   334,
     345,   345,   345,   345,   345,   345,   345,   372,   345,   348,
      69,    70,   301,   173,   312,   301,   306,    63,    63,   334,
     345,   345,   345,   345,   345,   345,   383,   386,    56,    56,
      63,    63,    63,   374,   381,    97,   345,   345,   345,   348,
     173,   173,   312,   306,   306,    59,    54,   334,   345,    56,
      63,    56,    63,    96,   173,   312,   173,   306,   334,    56,
      63,   345,   173,   306,    63,   306,    56
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   195,   196,   197,   198,   198,   199,   199,   200,   200,
     201,   201,   201,   201,   201,   201,   201,   201,   201,   201,
     201,   202,   202,   202,   203,   204,   205,   205,   206,   207,
     208,   209,   209,   209,   209,   209,   209,   210,   211,   212,
     213,   214,   215,   215,   216,   217,   217,   218,   218,   219,
     219,   220,   221,   222,   222,   222,   222,   223,   224,   224,
     225,   225,   225,   225,   226,   226,   226,   227,   227,   227,
     228,   228,   229,   229,   230,   230,   230,   230,   230,   230,
     230,   230,   230,   230,   230,   230,   230,   230,   230,   230,
     230,   230,   230,   230,   230,   230,   230,   230,   230,   230,
     230,   230,   230,   230,   230,   230,   230,   230,   230,   230,
     230,   230,   230,   230,   230,   230,   230,   230,   230,   230,
     230,   230,   230,   230,   230,   231,   232,   232,   232,   232,
     233,   233,   234,   235,   236,   237,   238,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     250,   250,   251,   251,   251,   252,   252,   253,   253,   254,
     255,   256,   257,   258,   259,   259,   259,   259,   259,   260,
     261,   262,   262,   263,   264,   264,   265,   266,   266,   267,
     267,   268,   269,   270,   270,   271,   272,   273,   273,   273,
     274,   275,   275,   276,   277,   278,   278,   278,   279,   280,
     280,   280,   280,   280,   281,   281,   282,   282,   282,   282,
     282,   282,   282,   282,   282,   282,   282,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   295,   296,   296,   296,   297,   298,   298,   299,   300,
     300,   300,   300,   301,   301,   301,   302,   302,   303,   303,
     303,   304,   305,   305,   305,   306,   306,   307,   308,   308,
     308,   309,   309,   310,   311,   311,   312,   312,   313,   313,
     313,   314,   314,   314,   314,   314,   314,   314,   315,   316,
     317,   317,   318,   319,   320,   320,   320,   320,   321,   321,
     321,   321,   321,   321,   321,   321,   322,   322,   323,   323,
     324,   324,   325,   325,   326,   326,   327,   327,   327,   327,
     328,   328,   329,   330,   331,   331,   332,   332,   333,   333,
     334,   334,   334,   335,   335,   336,   336,   336,   337,   337,
     338,   338,   339,   340,   341,   342,   343,   344,   345,   345,
     346,   347,   347,   348,   348,   349,   350,   350,   351,   352,
     352,   353,   354,   355,   355,   356,   356,   356,   356,   356,
     356,   357,   357,   357,   358,   358,   358,   359,   359,   360,
     361,   362,   362,   362,   363,   363,   364,   365,   366,   367,
     368,   368,   369,   370,   370,   371,   372,   372,   373,   373,
     374,   375,   375,   376,   376,   377,   377,   378,   378,   379,
     379,   379,   380,   380,   380,   380,   380,   381,   382,   382,
     382,   382,   383,   383,   383,   384,   384,   384,   384,   385,
     385,   385,   385,   386,   386,   386,   386,   386,   386,   387,
     387,   387,   387,   388,   388
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     5,     1,     3,     1,     2,     1,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     5,     2,     1,     1,     1,     1,     2,     2,
       4,     1,     1,     1,     1,     1,     1,     2,     9,     6,
       6,     7,     0,     2,     7,     4,     3,     5,     4,     0,
       2,     2,     4,     4,     4,     2,     3,     2,     0,     1,
       2,     2,     2,     2,     0,     6,     3,     3,     3,     1,
       3,     1,     0,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     7,     7,     8,     9,
       6,     6,     6,     7,     6,     7,     8,     7,     6,     8,
       8,     4,     4,     6,     5,     4,     7,     7,     7,     6,
       6,     6,     4,     4,     4,     6,     6,     8,     7,     1,
       8,    10,     8,     9,     1,     1,     1,     3,     2,    10,
      13,     0,     2,    10,     9,     8,    12,     0,     1,     0,
       1,     9,    10,     0,     1,     6,     5,     0,     2,     2,
       6,     0,     1,     9,    16,     9,     5,     6,     6,     4,
       9,     9,     7,     7,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     7,     7,
       7,     7,     7,     7,     9,     7,     7,     9,     5,     4,
       1,     1,     0,     1,     2,     7,     9,     1,    14,     5,
       7,     9,    11,     0,     2,     2,     0,     2,     0,     1,
       1,     4,     1,     1,     1,     1,     1,     1,     1,     3,
       6,     2,     2,     2,     1,     1,     1,     1,     0,     2,
       2,     4,     4,     3,     6,     6,     6,     3,     2,     2,
       9,     9,     2,     2,    12,    12,    11,    11,     1,     2,
       1,     1,     2,     1,     2,     1,     0,     1,     0,     5,
       0,     1,     0,     1,     0,     1,     1,     1,     1,     1,
       0,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     5,     7,     4,     4,     1,     3,
       2,     2,     4,     0,     2,     1,     3,     2,     3,     1,
       4,     2,     1,     3,     4,     2,     2,     1,     2,     1,
       2,     1,     2,     2,     1,     2,     2,     3,     4,     3,
       7,     1,     5,     3,     5,     3,     5,     1,     4,     7,
       0,     3,     2,     3,     5,     1,     1,     1,     1,     1,
       1,     5,     1,     3,     1,     3,     1,     3,     1,     3,
       3,     1,     3,     3,     3,     3,     1,     1,     3,     3,
       3,     1,     3,     3,     1,     3,     3,     3,     1,     2,
       2,     2,     1,     1,     1,     3,     2,     4,     1,     1,
       1,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (pBuilder, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, pBuilder); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, CISA_IR_Builder* pBuilder)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (pBuilder);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, CISA_IR_Builder* pBuilder)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, pBuilder);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, CISA_IR_Builder* pBuilder)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], pBuilder);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, pBuilder); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, CISA_IR_Builder* pBuilder)
{
  YY_USE (yyvaluep);
  YY_USE (pBuilder);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (CISA_IR_Builder* pBuilder)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (pBuilder);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* Listing: NewlinesOpt ListingHeader NewlinesOpt Statements NewlinesOpt  */
#line 622 "CISA.y"
                                                                      {
        TRACE("** Listing Complete\n");
        pBuilder->CISA_post_file_parse();
    }
#line 3005 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 23: /* Scope: ScopeStart error  */
#line 652 "CISA.y"
                       {
        PARSE_ERROR_AT((int)(yyvsp[-1].intval), "unclosed scope");
    }
#line 3013 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 24: /* ScopeStart: LBRACE  */
#line 656 "CISA.y"
           {
        pBuilder->CISA_push_decl_scope();
        (yyval.intval) = CISAlineno;
    }
#line 3022 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 25: /* ScopeEnd: RBRACE  */
#line 660 "CISA.y"
                 {pBuilder->CISA_pop_decl_scope();}
#line 3028 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 28: /* DirectiveKernel: DIRECTIVE_KERNEL IdentOrStringLit  */
#line 671 "CISA.y"
    {
        VISAKernel *cisa_kernel = NULL;
        pBuilder->AddKernel(cisa_kernel, (yyvsp[0].string));
    }
#line 3037 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 29: /* DirectiveGlobalFunction: DIRECTIVE_GLOBAL_FUNC IdentOrStringLit  */
#line 679 "CISA.y"
  {
      VISAFunction *cisa_kernel = NULL;
      pBuilder->AddFunction(cisa_kernel, (yyvsp[0].string));
  }
#line 3046 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 30: /* DirectiveVersion: DIRECTIVE_VERSION DEC_LIT DOT DEC_LIT  */
#line 687 "CISA.y"
   {
       pBuilder->CISA_IR_setVersion((unsigned char)(yyvsp[-2].intval), (unsigned char)(yyvsp[0].intval));
   }
#line 3054 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 37: /* DeclFunction: DIRECTIVE_FUNCDECL STRING_LIT  */
#line 701 "CISA.y"
    {
        // do nothing as it's informational only
    }
#line 3062 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 38: /* DeclVariable: DIRECTIVE_DECL IDENT V_TYPE_EQ_G DECL_DATA_TYPE NUM_ELTS_EQ IntExp AlignAttrOpt AliasAttrOpt GenAttrOpt  */
#line 708 "CISA.y"
    {
       ABORT_ON_FAIL(pBuilder->CISA_general_variable_decl(
           (yyvsp[-7].string), (unsigned int)(yyvsp[-3].intval), (yyvsp[-5].type), (yyvsp[-2].align), (yyvsp[-1].alias).aliasname, (yyvsp[-1].alias).offset, AttrOptVar, CISAlineno));
       AttrOptVar.clear();
    }
#line 3072 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 39: /* DeclAddress: DIRECTIVE_DECL IDENT V_TYPE_EQ_A NUM_ELTS_EQ IntExp GenAttrOpt  */
#line 716 "CISA.y"
   {
       ABORT_ON_FAIL(
           pBuilder->CISA_addr_variable_decl((yyvsp[-4].string), (unsigned int)(yyvsp[-1].intval), ISA_TYPE_UW, AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 3082 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 40: /* DeclPredicate: DIRECTIVE_DECL IDENT V_TYPE_EQ_P NUM_ELTS_EQ IntExp GenAttrOpt  */
#line 724 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_predicate_variable_decl((yyvsp[-4].string), (unsigned int)(yyvsp[-1].intval), AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 3091 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 41: /* DeclSampler: DIRECTIVE_DECL IDENT V_TYPE_EQ_S NUM_ELTS_EQ IntExp VNameEqOpt GenAttrOpt  */
#line 731 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_sampler_variable_decl((yyvsp[-5].string), (int)(yyvsp[-2].intval), (yyvsp[-1].string), CISAlineno));
   }
#line 3099 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 42: /* VNameEqOpt: %empty  */
#line 734 "CISA.y"
                    {(yyval.string) = "";}
#line 3105 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 43: /* VNameEqOpt: V_NAME_EQ IDENT  */
#line 734 "CISA.y"
                                                 {(yyval.string) = (yyvsp[0].string);}
#line 3111 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 44: /* DeclSurface: DIRECTIVE_DECL IDENT V_TYPE_EQ_T NUM_ELTS_EQ IntExp VNameEqOpt GenAttrOpt  */
#line 738 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_surface_variable_decl((yyvsp[-5].string), (int)(yyvsp[-2].intval), (yyvsp[-1].string), AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 3120 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 45: /* DirectiveInput: DIRECTIVE_INPUT IDENT InputOffset InputSize  */
#line 746 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), (short)(yyvsp[-1].intval), (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 3128 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 46: /* DirectiveInput: DIRECTIVE_INPUT IDENT InputOffset  */
#line 751 "CISA.y"
    {
        int64_t size = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-1].string), size));
        MUST_HOLD(size < 0x10000, "declaration size is too large");
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-1].string), (short)(yyvsp[0].intval), (unsigned short)size, CISAlineno));
    }
#line 3139 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 47: /* DirectiveImplicitInput: DIRECTIVE_IMPLICIT IDENT InputOffset InputSize GenAttrOpt  */
#line 763 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_implicit_input_directive(
            (yyvsp[-4].string), (yyvsp[-3].string), (short)(yyvsp[-2].intval), (unsigned short)(yyvsp[-1].intval), CISAlineno));
    }
#line 3148 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 48: /* DirectiveImplicitInput: DIRECTIVE_IMPLICIT IDENT InputOffset GenAttrOpt  */
#line 770 "CISA.y"
    {
        int64_t size = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-2].string), size));
        MUST_HOLD(size < 0x10000, "declaration size is too large");
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), (short)(yyvsp[-1].intval), (unsigned short)size, CISAlineno));
    }
#line 3159 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 49: /* InputOffset: %empty  */
#line 777 "CISA.y"
                    {(yyval.intval) = 0;}
#line 3165 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 50: /* InputOffset: OFFSET_EQ IntExp  */
#line 777 "CISA.y"
                                                 {(yyval.intval) = (yyvsp[0].intval);}
#line 3171 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 51: /* InputSize: SIZE_EQ IntExp  */
#line 778 "CISA.y"
                          {(yyval.intval) = (yyvsp[0].intval);}
#line 3177 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 52: /* DirectiveParameter: DIRECTIVE_PARAMETER IDENT InputSize GenAttrOpt  */
#line 785 "CISA.y"
                                                   {
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), 0, (unsigned short)(yyvsp[-1].intval), CISAlineno));
    }
#line 3185 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 53: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS STRING_LIT  */
#line 791 "CISA.y"
                                                  {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[-2].string), (yyvsp[0].string), CISAlineno));
    }
#line 3193 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 54: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS IntExp  */
#line 795 "CISA.y"
                                              {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directiveNum((yyvsp[-2].string), (uint32_t)(yyvsp[0].intval), CISAlineno));
    }
#line 3201 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 55: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT  */
#line 799 "CISA.y"
                                {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[0].string), nullptr, CISAlineno));
    }
#line 3209 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 56: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS  */
#line 803 "CISA.y"
                                       {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[-1].string), nullptr, CISAlineno));
    }
#line 3217 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 57: /* DirectiveFunc: DIRECTIVE_FUNC IdentOrStringLit  */
#line 809 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_function_directive((yyvsp[0].string), CISAlineno));
    }
#line 3225 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 58: /* AlignAttrOpt: %empty  */
#line 814 "CISA.y"
                     {(yyval.align) = ALIGN_BYTE;}
#line 3231 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 60: /* Align: ALIGN_EQ ALIGN_KEYWORD  */
#line 816 "CISA.y"
                           { // 2GRF, 32word, ...
        (yyval.align) = (yyvsp[0].align);
    }
#line 3239 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 61: /* Align: ALIGN_EQ IDENT  */
#line 820 "CISA.y"
                   { // e.g. byte, word, dword, qword, GRF, GRFx2
       if (!ParseAlign(pBuilder, (yyvsp[0].string), (yyval.align))) {
           PARSE_ERROR((yyvsp[0].string), ": invalid align value");
       }
    }
#line 3249 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 62: /* Align: ALIGN_EQ IntExp  */
#line 826 "CISA.y"
                    {
        // e.g. %sizeof(GRF) or %sizeof(DECL)
        (yyval.align) = AlignBytesToVisaAlignment((int)(yyvsp[0].intval));
        if ((yyval.align) == ALIGN_UNDEF) {
            PARSE_ERROR("invalid align size (must be 1, 2, 4, 8, ..., 128)");
        }
    }
#line 3261 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 63: /* Align: ALIGN_EQ error  */
#line 834 "CISA.y"
                   {
        PARSE_ERROR("syntax error in align attribute");
    }
#line 3269 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 64: /* AliasAttrOpt: %empty  */
#line 841 "CISA.y"
    {
       (yyval.alias).aliasname = NULL;
       (yyval.alias).offset = 0;
    }
#line 3278 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 65: /* AliasAttrOpt: ALIAS_EQ LANGLE Var COMMA IntExpNRA RANGLE  */
#line 846 "CISA.y"
    {
       (yyval.alias).aliasname = (yyvsp[-3].string);
       (yyval.alias).offset = (int)(yyvsp[-1].intval);
    }
#line 3287 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 66: /* AliasAttrOpt: ALIAS_EQ LANGLE error  */
#line 851 "CISA.y"
    {
       PARSE_ERROR("syntax error in alias attribute");
    }
#line 3295 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 67: /* OneAttr: IDENT EQUALS IntExpNRA  */
#line 857 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[-2].string), (yyvsp[0].intval), nullptr);
    }
#line 3303 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 68: /* OneAttr: IDENT EQUALS STRING_LIT  */
#line 861 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[-2].string), 0, (yyvsp[0].string));
    }
#line 3311 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 69: /* OneAttr: IDENT  */
#line 865 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[0].string), 0, nullptr);
    }
#line 3319 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 70: /* AttrOpt: AttrOpt COMMA OneAttr  */
#line 871 "CISA.y"
    {
      AttrOptVar.push_back((yyvsp[0].pattr_gen));
    }
#line 3327 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 71: /* AttrOpt: OneAttr  */
#line 876 "CISA.y"
    {
      AttrOptVar.push_back((yyvsp[0].pattr_gen));
    }
#line 3335 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 72: /* GenAttrOpt: %empty  */
#line 882 "CISA.y"
    {
        (yyval.intval) = 0;
    }
#line 3343 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 73: /* GenAttrOpt: ATTR_EQ LBRACE AttrOpt RBRACE  */
#line 886 "CISA.y"
    {
        (yyval.intval) = 1;
    }
#line 3351 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 125: /* Label: LABEL  */
#line 948 "CISA.y"
             {pBuilder->CISA_create_label((yyvsp[0].string), CISAlineno);}
#line 3357 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 126: /* LogicInstruction: Predicate BINARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 953 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, CISAlineno);
    }
#line 3366 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 127: /* LogicInstruction: Predicate BINARY_LOGIC_OP SatModOpt ExecSize PredVar PredVar PredVar  */
#line 959 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-5].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].vISADecl), (yyvsp[-1].vISADecl), (yyvsp[0].vISADecl), CISAlineno);
    }
#line 3374 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 128: /* LogicInstruction: Predicate TERNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 964 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].opcode), (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3383 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 129: /* LogicInstruction: Predicate QUATERNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 970 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-8].pred_reg), (yyvsp[-7].opcode), (yyvsp[-6].sat), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size,
            (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3392 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 130: /* UnaryLogicInstruction: Predicate UNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 978 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, NULL, CISAlineno);
    }
#line 3401 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 131: /* UnaryLogicInstruction: Predicate UNARY_LOGIC_OP SatModOpt ExecSize PredVar PredVar  */
#line 984 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].vISADecl), (yyvsp[0].vISADecl), NULL, CISAlineno);
    }
#line 3410 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 132: /* MathInstruction_2OPND: Predicate MATH2_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 991 "CISA.y"
    {
        pBuilder->CISA_create_math_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3419 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 133: /* MathInstruction_3OPND: Predicate MATH3_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 998 "CISA.y"
    {
        pBuilder->CISA_create_math_instruction((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3428 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 134: /* ArithInstruction_2OPND: Predicate ARITH2_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 1005 "CISA.y"
    {
        pBuilder->CISA_create_arith_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, CISAlineno);
    }
#line 3437 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 135: /* ArithInstruction_3OPND: Predicate ARITH3_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1012 "CISA.y"
    {
        MUST_HOLD(!(((yyvsp[-5].opcode) == ISA_LINE) && ((yyvsp[-1].genOperand).type == OPERAND_IMMEDIATE || (yyvsp[-1].genOperand).type == OPERAND_INDIRECT)),
            "wrong type of src0 operand");
        pBuilder->CISA_create_arith_instruction(
            (yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3449 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 136: /* ArithInstruction_4OPND: Predicate ARITH4_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1024 "CISA.y"
     {
         pBuilder->CISA_create_arith_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].opcode), (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
     }
#line 3458 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 137: /* ArithInstruction_4OPND: Predicate ARITH4_OP2 ExecSize VecDstOperand_G_I VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1031 "CISA.y"
     {
        pBuilder->CISA_create_arith_instruction2((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
     }
#line 3467 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 138: /* DpasInstruction: DPAS_OP ExecSize RawOperand RawOperand RawOperand VecSrcOpndSimple  */
#line 1040 "CISA.y"
    {
        pBuilder->CISA_create_dpas_instruction(
            (yyvsp[-5].dpas_info).opcode, (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].genOperand).cisa_gen_opnd,
            (yyvsp[-5].dpas_info).src2Precision, (yyvsp[-5].dpas_info).src1Precision, (yyvsp[-5].dpas_info).depth, (yyvsp[-5].dpas_info).count, CISAlineno);
    }
#line 3478 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 139: /* BfnInstruction: Predicate BFN_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1050 "CISA.y"
    {
        pBuilder->CISA_create_bfn_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].bfn_info).func_ctrl , (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3487 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 140: /* QwScatterInstruction: Predicate QW_SCATTER_OP DOT DEC_LIT ExecSize Var RawOperand RawOperand  */
#line 1056 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_qword_scatter_instruction(
            (yyvsp[-6].opcode), (yyvsp[-7].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (uint32_t)(yyvsp[-4].intval), (yyvsp[-2].string), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3496 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 141: /* BF_CvtInstruction: BF_CVT_OP ExecSize VecDstOperand_G VecSrcOperand_G_IMM  */
#line 1063 "CISA.y"
    {
        pBuilder->CISA_create_bf_cvt_instruction((yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3504 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 142: /* FCvtInstruction: FCVT_OP ExecSize VecDstOperand_G VecSrcOperand_G_IMM  */
#line 1069 "CISA.y"
    {
        pBuilder->CISA_create_fcvt_instruction((yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3512 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 143: /* AntiTrigInstruction: Predicate ANTI_TRIG_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 1075 "CISA.y"
    {
        pBuilder->CISA_create_invtri_inst((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3521 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 144: /* AddrAddInstruction: ADDR_ADD_OP ExecSize VecDstOperand_A VecSrcOperand_G_A_AO VecSrcOperand_G_IMM_AO  */
#line 1084 "CISA.y"
    {
        // a grammatically problematic instruction
        //   addr_add (M1_NM, 1) A0(0)<1> &V127 - 0x10...
        //                                        ^^^^ next operand or V127 offset
        pBuilder->CISA_create_address_instruction((yyvsp[-4].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3533 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 145: /* SetpInstruction: SETP_OP ExecSize PredVar VecSrcOperand_G_I_IMM  */
#line 1094 "CISA.y"
    {
        pBuilder->CISA_create_setp_instruction(
            (yyvsp[-3].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].vISADecl), (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3542 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 146: /* SelInstruction: Predicate SEL_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1101 "CISA.y"
    {
        pBuilder->CISA_create_sel_instruction((yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3551 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 147: /* MinInstruction: Predicate MIN_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1108 "CISA.y"
    {
        pBuilder->CISA_create_fminmax_instruction(0, ISA_FMINMAX, (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3560 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 148: /* MaxInstruction: Predicate MAX_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1116 "CISA.y"
    {
        pBuilder->CISA_create_fminmax_instruction(
            1, ISA_FMINMAX, (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3570 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 149: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM_A_AO  */
#line 1125 "CISA.y"
    {
        pBuilder->CISA_create_mov_instruction(
            (yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-3].sat),
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3580 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 150: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_A VecSrcOperand_G_I_IMM_A_AO  */
#line 1132 "CISA.y"
    {
        pBuilder->CISA_create_mov_instruction(
            (yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-3].sat), 
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3590 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 151: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_G_I PredVar  */
#line 1139 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_mov_instruction((yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].vISADecl), CISAlineno));
    }
#line 3598 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 152: /* MovsInstruction: MOVS_OP ExecSize DstStateOperand SrcStateOperand  */
#line 1145 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].StateVar).cisa_gen_opnd, (yyvsp[0].StateVar).cisa_gen_opnd, CISAlineno);
    }
#line 3607 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 153: /* MovsInstruction: MOVS_OP ExecSize VecDstOperand_G SrcStateOperand  */
#line 1151 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].StateVar).cisa_gen_opnd, CISAlineno);
    }
#line 3616 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 154: /* MovsInstruction: MOVS_OP ExecSize DstStateOperand VecSrcOperand_G_I_IMM  */
#line 1157 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].StateVar).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3625 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 155: /* CmpInstruction: CMP_OP ConditionalModifier ExecSize PredVar VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1175 "CISA.y"
    {
        pBuilder->CISA_create_cmp_instruction((yyvsp[-4].cond_mod), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].vISADecl), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3634 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 156: /* CmpInstruction: CMP_OP ConditionalModifier ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1182 "CISA.y"
    {
        // NOTE: predication not permitted.  Apparently the vISA API doesn't allow for predicated compares
        pBuilder->CISA_create_cmp_instruction(
            (yyvsp[-4].cond_mod), ISA_CMP, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3645 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 157: /* MediaInstruction: MEDIA_OP MEDIA_MODE TwoDimOffset Var MediaInstructionPlaneID VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1192 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_media_instruction(
            (yyvsp[-7].opcode), (yyvsp[-6].media_mode), (yyvsp[-5].offset).row, (yyvsp[-5].offset).elem, (int)(yyvsp[-3].intval), (yyvsp[-4].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3655 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 158: /* MediaInstruction: MEDIA_OP MEDIA_MODE TwoDimOffset Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1200 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_media_instruction(
            (yyvsp[-6].opcode), (yyvsp[-5].media_mode), (yyvsp[-4].offset).row, (yyvsp[-4].offset).elem, (int)0, (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3665 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 159: /* MediaInstructionPlaneID: DEC_LIT  */
#line 1206 "CISA.y"
                                 {
        MUST_HOLD((yyvsp[0].intval) <= 0xF, "PlaneID must less than 0xF");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 3674 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 160: /* ScatterInstruction: SCATTER_OP ElemNum ExecSize OwordModifier Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1214 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter_instruction(
            (yyvsp[-7].opcode), (int)(yyvsp[-6].intval), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].oword_mod), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3684 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 161: /* ScatterTypedInstruction: Predicate SCATTER_TYPED_OP SAMPLER_CHANNEL ExecSize Var RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1223 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter4_typed_instruction(
            (yyvsp[-8].opcode), (yyvsp[-9].pred_reg), ChannelMask::createFromAPI((yyvsp[-7].s_channel)), (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-5].string),
            (yyvsp[-4].RawVar), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3694 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 162: /* Scatter4ScaledInstruction: Predicate SCATTER4_SCALED_OP SAMPLER_CHANNEL ExecSize Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1232 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter4_scaled_instruction(
            (yyvsp[-6].opcode), (yyvsp[-7].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-5].s_channel)), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3704 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 163: /* ScatterScaledInstruction: Predicate SCATTER_SCALED_OP DOT DEC_LIT ExecSize Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1241 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter_scaled_instruction(
            (yyvsp[-7].opcode), (yyvsp[-8].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (uint32_t) (yyvsp[-5].intval), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3714 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 164: /* SynchronizationInstruction: BARRIER_OP  */
#line 1248 "CISA.y"
               {
        pBuilder->CISA_create_sync_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 3722 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 165: /* SynchronizationInstruction: SBARRIER_SIGNAL  */
#line 1251 "CISA.y"
                      {
        pBuilder->CISA_create_sbarrier_instruction(true, CISAlineno);
    }
#line 3730 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 166: /* SynchronizationInstruction: SBARRIER_WAIT  */
#line 1254 "CISA.y"
                    {
        pBuilder->CISA_create_sbarrier_instruction(false, CISAlineno);
    }
#line 3738 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 167: /* SynchronizationInstruction: NBARRIER_SIGNAL VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1257 "CISA.y"
                                                                  {
        pBuilder->CISA_create_nbarrier(false, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3746 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 168: /* SynchronizationInstruction: NBARRIER_WAIT VecSrcOperand_G_I_IMM  */
#line 1260 "CISA.y"
                                          {
        pBuilder->CISA_create_nbarrier(true, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3754 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 169: /* DwordAtomicInstruction: Predicate DWORD_ATOMIC_OP ATOMIC_SUB_OP Atomic16Opt ExecSize Var RawOperand RawOperand RawOperand RawOperand  */
#line 1266 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_dword_atomic_instruction(
            (yyvsp[-9].pred_reg), (yyvsp[-7].atomic_op), (yyvsp[-6].flag), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].string), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3763 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 170: /* TypedAtomicInstruction: Predicate TYPED_ATOMIC_OP ATOMIC_SUB_OP Atomic16Opt ExecSize Var RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1273 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_typed_atomic_instruction(
            (yyvsp[-12].pred_reg), (yyvsp[-10].atomic_op), (yyvsp[-9].flag), (yyvsp[-8].emask_exec_size).emask, (yyvsp[-8].emask_exec_size).exec_size, (yyvsp[-7].string),
            (yyvsp[-6].RawVar), (yyvsp[-5].RawVar), (yyvsp[-4].RawVar), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3773 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 171: /* Atomic16Opt: %empty  */
#line 1280 "CISA.y"
             {(yyval.flag) = false;}
#line 3779 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 172: /* Atomic16Opt: DOT DEC_LIT  */
#line 1281 "CISA.y"
                  { // .16
        MUST_HOLD(((yyvsp[0].intval) == 16), "only supports 16");
        (yyval.flag) = true;
    }
#line 3788 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 173: /* SampleUnormInstruction: SAMPLE_UNORM_OP SAMPLER_CHANNEL CHANNEL_OUTPUT Var Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1288 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_sampleunorm_instruction(
            (yyvsp[-9].opcode), ChannelMask::createFromAPI((yyvsp[-8].s_channel)), (yyvsp[-7].s_channel_output), (yyvsp[-6].string), (yyvsp[-5].string),
            (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3798 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 174: /* SampleInstruction: SAMPLE_OP SAMPLER_CHANNEL SIMDMode Var Var RawOperand RawOperand RawOperand RawOperand  */
#line 1297 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_sample_instruction(
            (yyvsp[-8].opcode), ChannelMask::createFromAPI((yyvsp[-7].s_channel)), (int)(yyvsp[-6].intval), (yyvsp[-5].string), (yyvsp[-4].string),
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3808 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 175: /* SampleInstruction: SAMPLE_OP SAMPLER_CHANNEL SIMDMode Var RawOperand RawOperand RawOperand RawOperand  */
#line 1305 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_create_sample_instruction(
           (yyvsp[-7].opcode), ChannelMask::createFromAPI((yyvsp[-6].s_channel)), (int)(yyvsp[-5].intval), "", (yyvsp[-4].string),
           (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 3818 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 176: /* Sample3dInstruction: Predicate SAMPLE_3D_OP PixelNullMaskEnableOpt CPSEnableOpt NonUniformSamplerEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM Var Var RawOperand RawOperandArray  */
#line 1315 "CISA.y"
   {
       const bool success = pBuilder->create3DSampleInstruction(
           (yyvsp[-11].pred_reg), (yyvsp[-10].sample3DOp), (yyvsp[-9].pixel_null_mask), (yyvsp[-8].cps), (yyvsp[-7].non_uniform_sampler), ChannelMask::createFromAPI((yyvsp[-6].s_channel)),
           (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].string), (yyvsp[-2].string),
           (yyvsp[-1].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 3831 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 177: /* CPSEnableOpt: %empty  */
#line 1324 "CISA.y"
                     {(yyval.cps) = false;}
#line 3837 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 178: /* CPSEnableOpt: CPS  */
#line 1324 "CISA.y"
                                          {(yyval.cps) = true;}
#line 3843 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 179: /* NonUniformSamplerEnableOpt: %empty  */
#line 1326 "CISA.y"
                                   {(yyval.non_uniform_sampler) = false;}
#line 3849 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 180: /* NonUniformSamplerEnableOpt: NON_UNIFORM_SAMPLER  */
#line 1326 "CISA.y"
                                                                       {(yyval.non_uniform_sampler) = true;}
#line 3855 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 181: /* Load3dInstruction: Predicate LOAD_3D_OP PixelNullMaskEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM Var RawOperand RawOperandArray  */
#line 1332 "CISA.y"
   {
       const bool success = pBuilder->create3DLoadInstruction(
           (yyvsp[-8].pred_reg), (yyvsp[-7].sample3DOp), (yyvsp[-6].pixel_null_mask), ChannelMask::createFromAPI((yyvsp[-5].s_channel)),
           (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].string),
           (yyvsp[-1].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 3868 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 182: /* Gather43dInstruction: Predicate SAMPLE4_3D_OP PixelNullMaskEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM Var Var RawOperand RawOperandArray  */
#line 1345 "CISA.y"
   {
       const bool success = pBuilder->createSample4Instruction(
          (yyvsp[-9].pred_reg), (yyvsp[-8].sample3DOp), (yyvsp[-7].pixel_null_mask), ChannelMask::createFromAPI((yyvsp[-6].s_channel)), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size,
          (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].string), (yyvsp[-2].string),
          (yyvsp[-1].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 3881 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 183: /* PixelNullMaskEnableOpt: %empty  */
#line 1354 "CISA.y"
                               {(yyval.pixel_null_mask) = false;}
#line 3887 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 184: /* PixelNullMaskEnableOpt: PIXEL_NULL_MASK  */
#line 1354 "CISA.y"
                                                               {(yyval.pixel_null_mask) = true;}
#line 3893 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 185: /* ResInfo3dInstruction: RESINFO_OP_3D SAMPLER_CHANNEL ExecSize Var RawOperand RawOperand  */
#line 1358 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_info_3d_instruction(
            VISA_3D_RESINFO, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            ChannelMask::createFromAPI((yyvsp[-4].s_channel)), (yyvsp[-2].string), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 3903 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 186: /* SampleInfo3dInstruction: SAMPLEINFO_OP_3D SAMPLER_CHANNEL ExecSize Var RawOperand  */
#line 1366 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_info_3d_instruction(
            VISA_3D_SAMPLEINFO, (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            ChannelMask::createFromAPI((yyvsp[-3].s_channel)), (yyvsp[-1].string), NULL, (yyvsp[0].RawVar), CISAlineno));
   }
#line 3913 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 187: /* RTWriteOperandParse: %empty  */
#line 1374 "CISA.y"
    {
    }
#line 3920 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 188: /* RTWriteOperandParse: RTWriteOperandParse VecSrcOperand_G_IMM  */
#line 1377 "CISA.y"
    {
        RTRWOperands.push_back((yyvsp[0].genOperand).cisa_gen_opnd);
    }
#line 3928 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 189: /* RTWriteOperandParse: RTWriteOperandParse RawOperand  */
#line 1381 "CISA.y"
    {
        RTRWOperands.push_back((yyvsp[0].RawVar));
    }
#line 3936 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 190: /* RTWriteInstruction: Predicate RTWRITE_OP_3D RTWriteModeOpt ExecSize Var RTWriteOperandParse  */
#line 1386 "CISA.y"
   {
       bool result = pBuilder->CISA_create_rtwrite_3d_instruction(
           (yyvsp[-5].pred_reg), (yyvsp[-3].string), (yyvsp[-2].emask_exec_size).emask, (unsigned int)(yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].string),
           RTRWOperands, CISAlineno);
       RTRWOperands.clear();
       if (!result)
           YYABORT; // already reported
   }
#line 3949 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 191: /* RTWriteModeOpt: %empty  */
#line 1395 "CISA.y"
                       {(yyval.string) = 0;}
#line 3955 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 193: /* URBWriteInstruction: Predicate URBWRITE_OP_3D ExecSize DEC_LIT DEC_LIT RawOperand RawOperand RawOperand RawOperand  */
#line 1400 "CISA.y"
    {
        pBuilder->CISA_create_urb_write_3d_instruction(
            (yyvsp[-8].pred_reg), (yyvsp[-6].emask_exec_size).emask, (unsigned int)(yyvsp[-6].emask_exec_size).exec_size, (unsigned int)(yyvsp[-5].intval), (unsigned int)(yyvsp[-4].intval),
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 3965 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 194: /* AVSInstruction: AVS_OP SAMPLER_CHANNEL Var Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM CNTRL VecSrcOperand_G_I_IMM EXECMODE VecSrcOperand_G_I_IMM RawOperand  */
#line 1408 "CISA.y"
    {
        pBuilder->CISA_create_avs_instruction(
            ChannelMask::createFromAPI((yyvsp[-14].s_channel)), (yyvsp[-13].string), (yyvsp[-12].string),
            (yyvsp[-11].genOperand).cisa_gen_opnd, (yyvsp[-10].genOperand).cisa_gen_opnd, (yyvsp[-9].genOperand).cisa_gen_opnd, (yyvsp[-8].genOperand).cisa_gen_opnd,
            (yyvsp[-7].genOperand).cisa_gen_opnd, (yyvsp[-6].genOperand).cisa_gen_opnd, (yyvsp[-5].genOperand).cisa_gen_opnd, (yyvsp[-4].cntrl), (yyvsp[-3].genOperand).cisa_gen_opnd,
            (yyvsp[-2].execMode), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 3977 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 195: /* VMEInstruction: VME_IME_OP VMEOpndIME Var RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1420 "CISA.y"
   {
       //     1 - OP
       //     2 - StreamMode, SearchCtrl
       //     3 - Surface
       //     4 - UNIInput
       //     5 - IMEInput
       //     6 - ref0
       //     7 - ref1
       //     8 - CostCenter
       //     9 - Output
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_ime_instruction(
            (yyvsp[-8].opcode), (yyvsp[-7].vmeOpndIvb).streamMode, (yyvsp[-7].vmeOpndIvb).searchCtrl, (yyvsp[-5].RawVar), (yyvsp[-4].RawVar), (yyvsp[-6].string), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 3995 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 196: /* VMEInstruction: VME_SIC_OP Var RawOperand RawOperand RawOperand  */
#line 1436 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_sic_instruction((yyvsp[-4].opcode), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[-3].string), (yyvsp[0].RawVar), CISAlineno));
   }
#line 4003 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 197: /* VMEInstruction: VME_FBR_OP VMEOpndFBR Var RawOperand RawOperand RawOperand  */
#line 1442 "CISA.y"
   {
        //    1 - OP
        //    2 - FBRMdMode, FBRSubMbShape, FBRSubPredMode
        //    3 - surface
        //    4 - UNIInput
        //    5 - FBRInput
        //    6 - output
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_fbr_instruction((yyvsp[-5].opcode), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[-3].string),
            (yyvsp[-4].vmeOpndFbr).cisa_fbrMbMode_opnd, (yyvsp[-4].vmeOpndFbr).cisa_fbrSubMbShape_opnd, (yyvsp[-4].vmeOpndFbr).cisa_fbrSubPredMode_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 4018 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 198: /* OwordInstruction: OWORD_OP OwordModifier ExecSize Var VecSrcOperand_G_I_IMM RawOperand  */
#line 1455 "CISA.y"
    {
        ABORT_ON_FAIL(
            pBuilder->CISA_create_oword_instruction((yyvsp[-5].opcode), (yyvsp[-4].oword_mod), (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].string), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 4027 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 199: /* SvmInstruction: SVM_OP ExecSize VecSrcOperand_G_I_IMM RawOperand  */
#line 1463 "CISA.y"
    {
        bool aligned = false;
        pBuilder->CISA_create_svm_block_instruction((SVMSubOpcode)(yyvsp[-3].opcode), (yyvsp[-2].emask_exec_size).exec_size, aligned,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 4037 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 200: /* SvmInstruction: Predicate SVM_SCATTER_OP DOT DEC_LIT DOT DEC_LIT ExecSize RawOperand RawOperand  */
#line 1470 "CISA.y"
    {
        pBuilder->CISA_create_svm_scatter_instruction((yyvsp[-8].pred_reg), (SVMSubOpcode)(yyvsp[-7].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (unsigned int)(yyvsp[-5].intval), (unsigned int)(yyvsp[-3].intval), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4046 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 201: /* SvmInstruction: Predicate SVM_ATOMIC_OP ATOMIC_SUB_OP AtomicBitwidthOpt ExecSize RawOperand RawOperand RawOperand RawOperand  */
#line 1476 "CISA.y"
    {
        pBuilder->CISA_create_svm_atomic_instruction((yyvsp[-8].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-6].atomic_op), (unsigned short)(yyvsp[-5].intval),
            (yyvsp[-3].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), (yyvsp[-2].RawVar), CISAlineno);
    }
#line 4055 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 202: /* SvmInstruction: Predicate SVM_GATHER4SCALED_OP SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1482 "CISA.y"
    {
        pBuilder->CISA_create_svm_gather4_scaled((yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-4].s_channel)),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4064 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 203: /* SvmInstruction: Predicate SVM_SCATTER4SCALED_OP SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1488 "CISA.y"
    {
        pBuilder->CISA_create_svm_scatter4_scaled((yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-4].s_channel)),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4073 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 204: /* AtomicBitwidthOpt: %empty  */
#line 1494 "CISA.y"
             {(yyval.intval) = 32;}
#line 4079 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 205: /* AtomicBitwidthOpt: DOT DEC_LIT  */
#line 1495 "CISA.y"
                  {
        MUST_HOLD((yyvsp[0].intval) == 16 || (yyvsp[0].intval) == 32 || (yyvsp[0].intval) == 64, "only supports 16 or 64");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 4088 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 218: /* LscUntypedLoad: Predicate LSC_LOAD_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscUntypedAddrOperand  */
#line 1545 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize((yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_addr_operand).addr,     // address
            (yyvsp[-1].lsc_data_operand).shape,    // data
            (yyvsp[0].lsc_addr_operand).surface,  // surface
            (yyvsp[-1].lsc_data_operand).reg,      // dst
            (yyvsp[0].lsc_addr_operand).regs[0],  // src0
            nullptr,     // src1
            nullptr,     // src2
            CISAlineno);
    }
#line 4112 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 219: /* LscUntypedStridedLoad: Predicate LSC_LOAD_STRIDED_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscUntypedStridedAddrOperand  */
#line 1576 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize((yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_strided_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_addr_operand).addr,     // address
            (yyvsp[-1].lsc_data_operand).shape,    // data
            (yyvsp[0].lsc_addr_operand).surface,  // surface
            (yyvsp[-1].lsc_data_operand).reg,      // dst
            (yyvsp[0].lsc_addr_operand).regs[0],  // src0 base
            (yyvsp[0].lsc_addr_operand).regs[1],  // src0 stride
            nullptr,     // src1
            CISAlineno);
    }
#line 4136 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 220: /* LscUntypedBlock2dLoad: Predicate LSC_LOAD_BLOCK2D_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand2D LscUntypedBlock2dAddrOperand  */
#line 1605 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize((yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand2d).shape2D.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_block2d_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_data_operand2d).shape2D,  // data shape
            (yyvsp[-1].lsc_data_operand2d).reg,      // dst
            (yyvsp[0].lsc_addr_operand).regs,     // src0 surface info / addrs
            nullptr,     // src1
            CISAlineno);
    }
#line 4157 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 221: /* LscUntypedStore: Predicate LSC_STORE_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscUntypedAddrOperand LscDataOperand  */
#line 1630 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize((yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // SFID
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_addr_operand).addr,     // address
            (yyvsp[0].lsc_data_operand).shape,    // data
            (yyvsp[-1].lsc_addr_operand).surface,  // surface
            nullptr,     // dst
            (yyvsp[-1].lsc_addr_operand).regs[0],  // src0
            (yyvsp[0].lsc_data_operand).reg,      // src1
            nullptr,     // src2
            CISAlineno);
    }
#line 4181 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 222: /* LscUntypedStridedStore: Predicate LSC_STORE_STRIDED_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscUntypedStridedAddrOperand LscDataOperand  */
#line 1654 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize((yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_strided_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // SFID
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_addr_operand).addr,     // address
            (yyvsp[0].lsc_data_operand).shape,    // data
            (yyvsp[-1].lsc_addr_operand).surface,  // surface
            nullptr,     // dst
            (yyvsp[-1].lsc_addr_operand).regs[0],  // src0 base
            (yyvsp[-1].lsc_addr_operand).regs[1],  // src0 stride
            (yyvsp[0].lsc_data_operand).reg,      // src1
            CISAlineno);
    }
#line 4205 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 223: /* LscUntypedBlock2dStore: Predicate LSC_STORE_BLOCK2D_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscUntypedBlock2dAddrOperand LscDataOperand2D  */
#line 1681 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize((yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand2d).shape2D.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_block2d_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_data_operand2d).shape2D,  // data2d
            nullptr,     // dst
            (yyvsp[-1].lsc_addr_operand).regs,     // src0 addrs
            (yyvsp[0].lsc_data_operand2d).reg,      // src1
            CISAlineno);
    }
#line 4226 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 224: /* LscUntypedAtomic: Predicate LSC_ATOMIC_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscUntypedAddrOperand LscPayloadReg LscPayloadReg  */
#line 1707 "CISA.y"
    {
        (yyvsp[-4].emask_exec_size).exec_size =
            lscCheckExecSize((yyvsp[-6].lsc_sfid), (yyvsp[-7].lsc_subOpcode), (yyvsp[-3].lsc_data_operand).shape.order, (yyvsp[-4].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_inst(
            (yyvsp[-8].pred_reg),  // predicate
            (yyvsp[-7].lsc_subOpcode),                // op
            (yyvsp[-6].lsc_sfid),                // sfid
            (yyvsp[-5].lsc_caching_opts),                // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-4].emask_exec_size).exec_size),
            (yyvsp[-4].emask_exec_size).emask,
            (yyvsp[-2].lsc_addr_operand).addr,     // address info
            (yyvsp[-3].lsc_data_operand).shape,    // data type
            (yyvsp[-2].lsc_addr_operand).surface,  // surface
            (yyvsp[-3].lsc_data_operand).reg,      // dst data
            (yyvsp[-2].lsc_addr_operand).regs[0],  // src0 addr
            (yyvsp[-1].RawVar),          // src1 data
            (yyvsp[0].RawVar),          // src2 data (for icas/fcas)
            CISAlineno);
    }
#line 4250 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 225: /* LscTypedLoad: Predicate LSC_LOAD_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscTypedAddrOperand  */
#line 1741 "CISA.y"
    {
        if ((yyvsp[-5].lsc_subOpcode) != LSC_LOAD_QUAD) {
            PARSE_ERROR("unsupported load operation for .tgm");
        }
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize((yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_addr_operand).addr.type,  // address model
            (yyvsp[0].lsc_addr_operand).addr.size,  // address size
            (yyvsp[-1].lsc_data_operand).shape,    // data type
            (yyvsp[0].lsc_addr_operand).surface,  // surface
            (yyvsp[-1].lsc_data_operand).reg,      // dst data
            (yyvsp[0].lsc_addr_operand).regs[0],  // src0_u
            (yyvsp[0].lsc_addr_operand).regs[1],  // src0_v
            (yyvsp[0].lsc_addr_operand).regs[2],  // src0_r
            (yyvsp[0].lsc_addr_operand).regs[3],  // src0_lod
            nullptr,     // src1 data
            nullptr,     // src2 data
            CISAlineno);
    }
#line 4281 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 226: /* LscTypedStore: Predicate LSC_STORE_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscTypedAddrOperand LscDataOperand  */
#line 1781 "CISA.y"
    {
        if ((yyvsp[-5].lsc_subOpcode) != LSC_STORE_QUAD) {
            PARSE_ERROR("unsupported store operation for .tgm");
        }
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize((yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_addr_operand).addr.type,  // address model
            (yyvsp[-1].lsc_addr_operand).addr.size,  // address size
            (yyvsp[0].lsc_data_operand).shape,    // data type
            (yyvsp[-1].lsc_addr_operand).surface,  // surface
            nullptr,     // dst
            (yyvsp[-1].lsc_addr_operand).regs[0],  // src0_u
            (yyvsp[-1].lsc_addr_operand).regs[1],  // src0_v
            (yyvsp[-1].lsc_addr_operand).regs[2],  // src0_r
            (yyvsp[-1].lsc_addr_operand).regs[3],  // src0_lod
            (yyvsp[0].lsc_data_operand).reg,      // src1 data
            nullptr,     // src2 data
            CISAlineno);
    }
#line 4312 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 227: /* LscTypedAtomic: Predicate LSC_ATOMIC_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscTypedAddrOperand LscPayloadReg LscPayloadReg  */
#line 1821 "CISA.y"
    {
        (yyvsp[-4].emask_exec_size).exec_size =
            lscCheckExecSize((yyvsp[-6].lsc_sfid), (yyvsp[-7].lsc_subOpcode), (yyvsp[-3].lsc_data_operand).shape.order, (yyvsp[-4].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-8].pred_reg),  // predicate
            (yyvsp[-7].lsc_subOpcode),  // subop
            (yyvsp[-6].lsc_sfid),  // sfid
            (yyvsp[-5].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-4].emask_exec_size).exec_size),
            (yyvsp[-4].emask_exec_size).emask,
            (yyvsp[-2].lsc_addr_operand).addr.type, // address model
            (yyvsp[-2].lsc_addr_operand).addr.size,  // address size
            (yyvsp[-3].lsc_data_operand).shape,    // data type
            (yyvsp[-2].lsc_addr_operand).surface,  // surface
            (yyvsp[-3].lsc_data_operand).reg,      // dst data
            (yyvsp[-2].lsc_addr_operand).regs[0],  // src0 addrs u
            (yyvsp[-2].lsc_addr_operand).regs[1],  // src0 addrs v
            (yyvsp[-2].lsc_addr_operand).regs[2],  // src0 addrs r
            (yyvsp[-2].lsc_addr_operand).regs[3],  // src0 addrs lod
            (yyvsp[-1].RawVar),          // src1 data
            (yyvsp[0].RawVar),          // src2 data
            CISAlineno);
    }
#line 4340 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 228: /* LscTypedReadStateInfo: Predicate LSC_READ_STATE_INFO_MNEMONIC LSC_SFID_TYPED_TOKEN LscPayloadReg LscRegAddrModel  */
#line 1852 "CISA.y"
   {
        LSC_CACHE_OPTS caching{LSC_CACHING_DEFAULT,LSC_CACHING_DEFAULT};
        LSC_DATA_SHAPE dataShape{LSC_DATA_SIZE_32b,LSC_DATA_ORDER_NONTRANSPOSE};
        dataShape.elems = LSC_DATA_ELEMS_1;
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-4].pred_reg),              // predicate
            (yyvsp[-3].lsc_subOpcode),              // subop
            (yyvsp[-2].lsc_sfid),              // sfid
            caching,         // caching settings
            EXEC_SIZE_1,
            vISA_EMASK_M1_NM,
            (yyvsp[0].lsc_addr_model).type,           // address model
            LSC_ADDR_SIZE_32b, // address size
            dataShape,         // data type
            (yyvsp[0].lsc_addr_model).surface,        // surface
            (yyvsp[-1].RawVar),                // dst data
            nullptr,           // src0 addrs u
            nullptr,           // src0 addrs v
            nullptr,           // src0 addrs r
            nullptr,           // src0 addrs lod
            nullptr,           // src1 data
            nullptr,           // src2 data
            CISAlineno);
   }
#line 4369 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 229: /* LscFence: LSC_FENCE_MNEMONIC LscSfid LSC_FENCE_OP_TYPE LSC_FENCE_SCOPE  */
#line 1885 "CISA.y"
    {
        pBuilder->CISA_create_lsc_fence((yyvsp[-2].lsc_sfid), (yyvsp[-1].lsc_fence_op), (yyvsp[0].lsc_scope), CISAlineno);
    }
#line 4377 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 232: /* LscCacheOpts: %empty  */
#line 1892 "CISA.y"
                                    {(yyval.lsc_caching_opts) = {LSC_CACHING_DEFAULT,LSC_CACHING_DEFAULT};}
#line 4383 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 233: /* LscCacheOpts: LSC_CACHING_OPT  */
#line 1893 "CISA.y"
                                    {(yyval.lsc_caching_opts) = {(yyvsp[0].lsc_caching_opt),LSC_CACHING_DEFAULT};}
#line 4389 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 234: /* LscCacheOpts: LSC_CACHING_OPT LSC_CACHING_OPT  */
#line 1894 "CISA.y"
                                    {(yyval.lsc_caching_opts) = {(yyvsp[-1].lsc_caching_opt),(yyvsp[0].lsc_caching_opt)};}
#line 4395 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 235: /* LscUntypedAddrOperand: LscAddrModelOpt LBRACK LscAddrImmScaleOpt LscPayloadNonNullReg LscAddrImmOffsetOpt RBRACK LSC_ADDR_SIZE_TK  */
#line 1901 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-6].lsc_addr_model).surface,{(yyvsp[-3].RawVar)},{(yyvsp[-6].lsc_addr_model).type,(int)(yyvsp[-4].intval),(int)(yyvsp[-2].intval),(yyvsp[0].lsc_addr_size)}};
    }
#line 4403 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 236: /* LscUntypedStridedAddrOperand: LscAddrModelOpt LBRACK LscAddrImmScaleOpt LscPayloadNonNullReg LscAddrImmOffsetOpt COMMA LscVectorOpRegOrImm RBRACK LSC_ADDR_SIZE_TK  */
#line 1910 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-8].lsc_addr_model).surface,{(yyvsp[-5].RawVar),(yyvsp[-2].lsc_addr_surface_ident)},{(yyvsp[-8].lsc_addr_model).type,(int)(yyvsp[-6].intval),(int)(yyvsp[-4].intval),(yyvsp[0].lsc_addr_size)}};
    }
#line 4411 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 237: /* LscUntypedStridedAddrOperand: LscUntypedAddrOperand  */
#line 1913 "CISA.y"
                            {
        (yyval.lsc_addr_operand) = (yyvsp[0].lsc_addr_operand);
        (yyval.lsc_addr_operand).regs[1] = nullptr;
    }
#line 4420 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 238: /* LscUntypedBlock2dAddrOperand: LSC_AM_FLAT LBRACK LscVectorOpReg COMMA LscVectorOpRegOrImm COMMA LscVectorOpRegOrImm COMMA LscVectorOpRegOrImm COMMA LscVectorOpRegOrImm COMMA LscVectorOpRegOrImm RBRACK  */
#line 1936 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {nullptr,{(yyvsp[-11].lsc_addr_surface_ident),(yyvsp[-9].lsc_addr_surface_ident),(yyvsp[-7].lsc_addr_surface_ident),(yyvsp[-5].lsc_addr_surface_ident),(yyvsp[-3].lsc_addr_surface_ident),(yyvsp[-1].lsc_addr_surface_ident)},{LSC_ADDR_TYPE_FLAT,1,0,LSC_ADDR_SIZE_64b}};
    }
#line 4428 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 239: /* LscTypedAddrOperand: LscRegAddrModel LBRACK LscPayloadNonNullReg RBRACK LSC_ADDR_SIZE_TK  */
#line 1949 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-4].lsc_addr_model).surface,{(yyvsp[-2].RawVar)},{(yyvsp[-4].lsc_addr_model).type,1,0,(yyvsp[0].lsc_addr_size)}};
    }
#line 4436 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 240: /* LscTypedAddrOperand: LscRegAddrModel LBRACK LscPayloadNonNullReg COMMA LscPayloadNonNullReg RBRACK LSC_ADDR_SIZE_TK  */
#line 1960 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-6].lsc_addr_model).surface,{(yyvsp[-4].RawVar),(yyvsp[-2].RawVar)},{(yyvsp[-6].lsc_addr_model).type,1,0,(yyvsp[0].lsc_addr_size)}};
    }
#line 4444 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 241: /* LscTypedAddrOperand: LscRegAddrModel LBRACK LscPayloadNonNullReg COMMA LscPayloadNonNullReg COMMA LscPayloadNonNullReg RBRACK LSC_ADDR_SIZE_TK  */
#line 1971 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-8].lsc_addr_model).surface,{(yyvsp[-6].RawVar),(yyvsp[-4].RawVar),(yyvsp[-2].RawVar)},{(yyvsp[-8].lsc_addr_model).type,1,0,(yyvsp[0].lsc_addr_size)}};
    }
#line 4452 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 242: /* LscTypedAddrOperand: LscRegAddrModel LBRACK LscPayloadNonNullReg COMMA LscPayloadNonNullReg COMMA LscPayloadNonNullReg COMMA LscPayloadNonNullReg RBRACK LSC_ADDR_SIZE_TK  */
#line 1982 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-10].lsc_addr_model).surface,{(yyvsp[-8].RawVar),(yyvsp[-6].RawVar),(yyvsp[-4].RawVar),(yyvsp[-2].RawVar)},{(yyvsp[-10].lsc_addr_model).type,1,0,(yyvsp[0].lsc_addr_size)}};
    }
#line 4460 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 243: /* LscAddrImmOffsetOpt: %empty  */
#line 1990 "CISA.y"
                     {(yyval.intval) =   0;}
#line 4466 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 244: /* LscAddrImmOffsetOpt: PLUS IntExpAdd  */
#line 1991 "CISA.y"
                     {(yyval.intval) =  (yyvsp[0].intval);}
#line 4472 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 245: /* LscAddrImmOffsetOpt: MINUS IntExpPrim  */
#line 1992 "CISA.y"
                     {(yyval.intval) = -(yyvsp[0].intval);}
#line 4478 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 246: /* LscAddrImmScaleOpt: %empty  */
#line 1999 "CISA.y"
                      {(yyval.intval) = 1;}
#line 4484 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 247: /* LscAddrImmScaleOpt: IntExpMul TIMES  */
#line 2000 "CISA.y"
                      {(yyval.intval) = (yyvsp[-1].intval);}
#line 4490 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 248: /* LscAddrModelOpt: %empty  */
#line 2003 "CISA.y"
                 {(yyval.lsc_addr_model) = {LSC_ADDR_TYPE_FLAT,nullptr};}
#line 4496 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 249: /* LscAddrModelOpt: LSC_AM_FLAT  */
#line 2004 "CISA.y"
                 {(yyval.lsc_addr_model) = {LSC_ADDR_TYPE_FLAT,nullptr};}
#line 4502 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 251: /* LscRegAddrModel: LscRegAddrModelKind LPAREN LscVectorOpRegOrImm RPAREN  */
#line 2009 "CISA.y"
                                                             {
        (yyval.lsc_addr_model) = {(yyvsp[-3].lsc_addr_type),(yyvsp[-1].lsc_addr_surface_ident)};
    }
#line 4510 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 252: /* LscRegAddrModelKind: LSC_AM_BSS  */
#line 2014 "CISA.y"
               {(yyval.lsc_addr_type) = LSC_ADDR_TYPE_BSS;}
#line 4516 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 253: /* LscRegAddrModelKind: LSC_AM_SS  */
#line 2015 "CISA.y"
               {(yyval.lsc_addr_type) = LSC_ADDR_TYPE_SS;}
#line 4522 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 254: /* LscRegAddrModelKind: LSC_AM_BTI  */
#line 2016 "CISA.y"
               {(yyval.lsc_addr_type) = LSC_ADDR_TYPE_BTI;}
#line 4528 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 257: /* LscVectorOpImm: IntExp  */
#line 2021 "CISA.y"
           {
        (yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_immed((yyvsp[0].intval),ISA_TYPE_UD, CISAlineno);
    }
#line 4536 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 258: /* LscVectorOpReg: Var  */
#line 2026 "CISA.y"
        {
        ABORT_ON_FAIL((yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[0].string),
            0, 1, 0, // region
            0, 0, // row and col offset
            MODIFIER_NONE, CISAlineno));
    }
#line 4548 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 259: /* LscVectorOpReg: Var DOT DEC_LIT  */
#line 2034 "CISA.y"
                    {
        ABORT_ON_FAIL((yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-2].string),
            0, 1, 0, // region
            0, (unsigned char)(yyvsp[0].intval), // row and col offset
            MODIFIER_NONE, CISAlineno));
    }
#line 4560 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 260: /* LscVectorOpReg: Var LPAREN IntExp COMMA IntExp RPAREN  */
#line 2042 "CISA.y"
                                          {
        MUST_HOLD((yyvsp[-3].intval) <= 255 || (yyvsp[-3].intval) >= 0, "row is out of bounds");
        MUST_HOLD((yyvsp[-1].intval) <= 255 || (yyvsp[-1].intval) >= 0, "col is out of bounds");
        (yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-5].string),
            0, 1, 0,
            (unsigned char)(yyvsp[-3].intval), (unsigned char)(yyvsp[-1].intval), // row and col offset
            MODIFIER_NONE, CISAlineno);
        if ((yyval.lsc_addr_surface_ident) == nullptr) {
            PARSE_ERROR("cannot find surface variable");
        }
    }
#line 4577 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 261: /* LscDataOperand: LscPayloadReg LSC_DATA_SHAPE_TK  */
#line 2056 "CISA.y"
                                     {
        (yyval.lsc_data_operand) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape)};
    }
#line 4585 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 262: /* LscDataOperand: LscPayloadReg LSC_DATA_SHAPE_TK_CHMASK  */
#line 2060 "CISA.y"
                                            {
        (yyval.lsc_data_operand) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape)};
    }
#line 4593 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 263: /* LscDataOperand2D: LscPayloadReg LSC_DATA_SHAPE_TK_BLOCK2D  */
#line 2066 "CISA.y"
                                            {
        (yyval.lsc_data_operand2d) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape2d)};
    }
#line 4601 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 265: /* LscPayloadReg: Var  */
#line 2074 "CISA.y"
        {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[0].string), 0, CISAlineno));
    }
#line 4609 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 267: /* LscPayloadNonNullReg: VarNonNull  */
#line 2081 "CISA.y"
               {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[0].string), 0, CISAlineno));
    }
#line 4617 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 268: /* SwitchLabels: %empty  */
#line 2087 "CISA.y"
    {
    }
#line 4624 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 269: /* SwitchLabels: COMMA SwitchLabels  */
#line 2090 "CISA.y"
    {
    }
#line 4631 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 270: /* SwitchLabels: IDENT SwitchLabels  */
#line 2093 "CISA.y"
    {
        // parse rule means we see last label first
        switchLabels.push_front((yyvsp[-1].string));
    }
#line 4640 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 271: /* BranchInstruction: Predicate BRANCH_OP ExecSize IdentOrStringLit  */
#line 2100 "CISA.y"
    {
        pBuilder->CISA_create_branch_instruction((yyvsp[-3].pred_reg), (yyvsp[-2].opcode), (yyvsp[-1].emask_exec_size).emask, (yyvsp[-1].emask_exec_size).exec_size, (yyvsp[0].string), false, CISAlineno);
    }
#line 4648 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 272: /* BranchInstruction: Predicate CALL_OP ExecSize IdentOrStringLit  */
#line 2104 "CISA.y"
    {
        pBuilder->CISA_create_branch_instruction((yyvsp[-3].pred_reg), (yyvsp[-2].cisa_call).opcode, (yyvsp[-1].emask_exec_size).emask, (yyvsp[-1].emask_exec_size).exec_size, (yyvsp[0].string), (yyvsp[-2].cisa_call).is_fccall, CISAlineno);
    }
#line 4656 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 273: /* BranchInstruction: Predicate RET_OP ExecSize  */
#line 2108 "CISA.y"
    {
        pBuilder->CISA_Create_Ret((yyvsp[-2].pred_reg), (yyvsp[-1].opcode), (yyvsp[0].emask_exec_size).emask, (yyvsp[0].emask_exec_size).exec_size, CISAlineno);
    }
#line 4664 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 274: /* BranchInstruction: SWITCHJMP_OP ExecSize VecSrcOperand_G_I_IMM LPAREN SwitchLabels RPAREN  */
#line 2112 "CISA.y"
    {
        pBuilder->CISA_create_switch_instruction((yyvsp[-5].opcode), (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-3].genOperand).cisa_gen_opnd, switchLabels, CISAlineno);
        switchLabels.clear();
    }
#line 4673 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 275: /* BranchInstruction: Predicate FCALL ExecSize IDENT DEC_LIT DEC_LIT  */
#line 2118 "CISA.y"
    {
        pBuilder->CISA_create_fcall_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].string), (unsigned)(yyvsp[-1].intval), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 4681 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 276: /* BranchInstruction: Predicate IFCALL ExecSize VecSrcOperand_G_I_IMM DEC_LIT DEC_LIT  */
#line 2123 "CISA.y"
    {
        pBuilder->CISA_create_ifcall_instruction(
        (yyvsp[-5].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
        (yyvsp[-2].genOperand).cisa_gen_opnd, (unsigned)(yyvsp[-1].intval), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 4691 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 277: /* BranchInstruction: FADDR IDENT VecDstOperand_G_I  */
#line 2130 "CISA.y"
    {
        pBuilder->CISA_create_faddr_instruction((yyvsp[-1].string), (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 4699 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 278: /* FILE: FILE_OP STRING_LIT  */
#line 2135 "CISA.y"
    {
        pBuilder->CISA_create_FILE_instruction((yyvsp[-1].opcode), (yyvsp[0].string), CISAlineno);
    }
#line 4707 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 279: /* LOC: LOC_OP DEC_LIT  */
#line 2140 "CISA.y"
    {
        pBuilder->CISA_create_LOC_instruction((yyvsp[-1].opcode), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 4715 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 280: /* RawSendInstruction: Predicate RAW_SEND_STRING ExecSize HEX_LIT DEC_LIT DEC_LIT VecSrcOperand_G_IMM RawOperand RawOperand  */
#line 2146 "CISA.y"
    {
        pBuilder->CISA_create_raw_send_instruction(ISA_RAW_SEND, false, (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-8].pred_reg),
            (unsigned)(yyvsp[-5].intval), (unsigned char)(yyvsp[-4].intval), (unsigned char)(yyvsp[-3].intval), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4724 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 281: /* RawSendInstruction: Predicate RAW_SENDC_STRING ExecSize HEX_LIT DEC_LIT DEC_LIT VecSrcOperand_G_IMM RawOperand RawOperand  */
#line 2153 "CISA.y"
    {
        pBuilder->CISA_create_raw_send_instruction(ISA_RAW_SEND, true, (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-8].pred_reg),
            (unsigned)(yyvsp[-5].intval), (unsigned char)(yyvsp[-4].intval), (unsigned char)(yyvsp[-3].intval), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4733 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 282: /* LifetimeStartInst: LIFETIME_START_OP IDENT  */
#line 2160 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_lifetime_inst((unsigned char)0, (yyvsp[0].string), CISAlineno));
    }
#line 4741 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 283: /* LifetimeEndInst: LIFETIME_END_OP IDENT  */
#line 2166 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_lifetime_inst((unsigned char)1, (yyvsp[0].string), CISAlineno));
    }
#line 4749 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 284: /* RawSendsInstruction: Predicate RAW_SENDS_STRING ElemNum ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2172 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, false, false, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-11].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            (unsigned char)(yyvsp[-9].intval), (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4760 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 285: /* RawSendsInstruction: Predicate RAW_SENDS_EOT_STRING ElemNum ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2180 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, false, true, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-11].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            (unsigned char)(yyvsp[-9].intval), (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4771 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 286: /* RawSendsInstruction: Predicate RAW_SENDSC_STRING ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2188 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, true, false, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-10].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            0, (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4782 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 287: /* RawSendsInstruction: Predicate RAW_SENDSC_EOT_STRING ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2196 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, true, true, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-10].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            0, (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4793 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 288: /* NullaryInstruction: CACHE_FLUSH_OP  */
#line 2205 "CISA.y"
    {
        pBuilder->CISA_create_NO_OPND_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 4801 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 289: /* NullaryInstruction: WAIT_OP VecSrcOperand_G_IMM  */
#line 2210 "CISA.y"
    {
        pBuilder->CISA_create_wait_instruction((yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 4809 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 290: /* NullaryInstruction: YIELD_OP  */
#line 2215 "CISA.y"
    {
        pBuilder->CISA_create_yield_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 4817 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 291: /* NullaryInstruction: FENCE_GLOBAL_OP  */
#line 2220 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x0, CISAlineno);
    }
#line 4825 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 292: /* NullaryInstruction: FENCE_GLOBAL_OP FENCE_OPTIONS  */
#line 2225 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[-1].opcode), (yyvsp[0].fence_options), CISAlineno);
    }
#line 4833 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 293: /* NullaryInstruction: FENCE_LOCAL_OP  */
#line 2230 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x20, CISAlineno);
    }
#line 4841 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 294: /* NullaryInstruction: FENCE_LOCAL_OP FENCE_OPTIONS  */
#line 2235 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[-1].opcode), (yyvsp[0].fence_options) | 0x20, CISAlineno);
    }
#line 4849 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 295: /* NullaryInstruction: FENCE_SW_OP  */
#line 2240 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x80, CISAlineno);
    }
#line 4857 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 296: /* OwordModifier: %empty  */
#line 2244 "CISA.y"
                      {(yyval.oword_mod) = false;}
#line 4863 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 298: /* Predicate: %empty  */
#line 2251 "CISA.y"
    {
        (yyval.pred_reg) = NULL;
    }
#line 4871 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 299: /* Predicate: LPAREN PredSign PredVar PredCtrlOpt RPAREN  */
#line 2256 "CISA.y"
    {
        (yyval.pred_reg) = pBuilder->CISA_create_predicate_operand((yyvsp[-2].vISADecl), (yyvsp[-3].pred_sign), (yyvsp[-1].pred_ctrl), CISAlineno);
    }
#line 4879 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 300: /* PredSign: %empty  */
#line 2260 "CISA.y"
                 {(yyval.pred_sign) = PredState_NO_INVERSE;}
#line 4885 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 301: /* PredSign: BANG  */
#line 2260 "CISA.y"
                                                     {(yyval.pred_sign) = PredState_INVERSE;}
#line 4891 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 302: /* PredCtrlOpt: %empty  */
#line 2262 "CISA.y"
                    {(yyval.pred_ctrl) = PRED_CTRL_NON;}
#line 4897 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 304: /* SatModOpt: %empty  */
#line 2265 "CISA.y"
                  {(yyval.sat) = false;}
#line 4903 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 305: /* SatModOpt: SAT  */
#line 2265 "CISA.y"
                                      {(yyval.sat) = true;}
#line 4909 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 306: /* SrcModifier: SRCMOD_NEG  */
#line 2268 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NEG;}
#line 4915 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 307: /* SrcModifier: SRCMOD_ABS  */
#line 2269 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_ABS;}
#line 4921 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 308: /* SrcModifier: SRCMOD_NEGABS  */
#line 2270 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NEG_ABS;}
#line 4927 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 309: /* SrcModifier: SRCMOD_NOT  */
#line 2271 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NOT;}
#line 4933 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 310: /* ConditionalModifier: %empty  */
#line 2273 "CISA.y"
                            {(yyval.cond_mod) = ISA_CMP_UNDEF;}
#line 4939 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 312: /* VecDstOperand_A: DstAddrOperand  */
#line 2278 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 4945 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 313: /* VecDstOperand_G: DstGeneralOperand  */
#line 2279 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 4951 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 314: /* VecDstOperand_G_I: DstGeneralOperand  */
#line 2281 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 4957 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 315: /* VecDstOperand_G_I: DstIndirectOperand  */
#line 2282 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_INDIRECT;}
#line 4963 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 317: /* VecSrcOperand_G_I_IMM_A_AO: SrcAddrOfOperand  */
#line 2287 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESSOF;}
#line 4969 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 319: /* VecSrcOperand_G_I_IMM_A: SrcAddrOperand  */
#line 2291 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 4975 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 321: /* VecSrcOperand_G_I_IMM: SrcIndirectOperand  */
#line 2295 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_INDIRECT;}
#line 4981 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 322: /* VecSrcOperand_G_I_IMM: SrcImmOperand  */
#line 2296 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 4987 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 324: /* VecSrcOperand_G_IMM: SrcImmOperand  */
#line 2300 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 4993 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 326: /* VecSrcOperand_G_IMM_AO: SrcImmOperand  */
#line 2304 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 4999 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 327: /* VecSrcOperand_G_IMM_AO: SrcAddrOfOperand  */
#line 2305 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESSOF;}
#line 5005 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 329: /* VecSrcOperand_G_A: SrcAddrOperand  */
#line 2309 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5011 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 331: /* VecSrcOperand_G_A_AO: SrcAddrOfOperand  */
#line 2313 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5017 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 332: /* VecSrcOperand_G: SrcGeneralOperand  */
#line 2315 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 5023 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 333: /* VecSrcOpndSimple: Var TwoDimOffset  */
#line 2318 "CISA.y"
    {
        // simple vector operand with no modifier that has an
        // implicit src region = <1,1,0>
        (yyval.genOperand).type = OPERAND_GENERAL;
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-1].string), 1, 1, 0, (yyvsp[0].offset).row, (yyvsp[0].offset).elem, MODIFIER_NONE, CISAlineno));
    }
#line 5035 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 334: /* VMEOpndIME: LPAREN DEC_LIT COMMA DEC_LIT RPAREN  */
#line 2328 "CISA.y"
    {
        (yyval.vmeOpndIvb).streamMode = (unsigned char)(yyvsp[-3].intval);
        (yyval.vmeOpndIvb).searchCtrl = (unsigned char)(yyvsp[-1].intval);
    }
#line 5044 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 335: /* VMEOpndFBR: LPAREN VecSrcOperand_G_I_IMM COMMA VecSrcOperand_G_I_IMM COMMA VecSrcOperand_G_I_IMM RPAREN  */
#line 2335 "CISA.y"
    {
        (yyval.vmeOpndFbr).cisa_fbrMbMode_opnd = (yyvsp[-5].genOperand).cisa_gen_opnd;
        (yyval.vmeOpndFbr).cisa_fbrSubMbShape_opnd = (yyvsp[-3].genOperand).cisa_gen_opnd;
        (yyval.vmeOpndFbr).cisa_fbrSubPredMode_opnd = (yyvsp[-1].genOperand).cisa_gen_opnd;
    }
#line 5054 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 336: /* SrcStateOperand: Var LPAREN IntExp RPAREN  */
#line 2343 "CISA.y"
    {
        MUST_HOLD((yyvsp[-1].intval) < 0x100, "offset out of bounds");
        (yyval.StateVar).offset = (unsigned char)(yyvsp[-1].intval);
        ABORT_ON_FAIL((yyval.StateVar).cisa_gen_opnd = pBuilder->CISA_create_state_operand((yyvsp[-3].string), (unsigned char)(yyvsp[-1].intval), CISAlineno, false));
    }
#line 5064 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 337: /* DstStateOperand: Var LPAREN IntExp RPAREN  */
#line 2351 "CISA.y"
    {
        MUST_HOLD((yyvsp[-1].intval) < 0x100, "offset out of bounds");
        (yyval.StateVar).offset = (unsigned char)(yyvsp[-1].intval);
        ABORT_ON_FAIL((yyval.StateVar).cisa_gen_opnd = pBuilder->CISA_create_state_operand((yyvsp[-3].string), (unsigned char)(yyvsp[-1].intval), CISAlineno, true));
    }
#line 5074 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 339: /* RawOperand: BUILTIN_NULL DOT DEC_LIT  */
#line 2382 "CISA.y"
    {
        MUST_HOLD((yyvsp[0].intval) == 0, "%null must have 0 as offset");
        (yyval.RawVar) = pBuilder->CISA_create_RAW_NULL_operand(CISAlineno); // can't fail
    }
#line 5083 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 340: /* RawOperandNonNull: VarNonNull RawOperandOffsetSuffix  */
#line 2389 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[-1].string), (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 5091 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 341: /* RawOperandOffsetSuffix: DOT DEC_LIT  */
#line 2400 "CISA.y"
                {
        MUST_HOLD((yyvsp[0].intval) <= 0x10000, "offset out of bounds");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 5100 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 342: /* RawOperandOffsetSuffix: DOT LPAREN IntExp RPAREN  */
#line 2405 "CISA.y"
                             {
        MUST_HOLD((yyvsp[-1].intval) <= 0x10000, "offset out of bounds");
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5109 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 343: /* RawOperandArray: %empty  */
#line 2413 "CISA.y"
    {
        (yyval.intval) = 0;
    }
#line 5117 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 344: /* RawOperandArray: RawOperandArray RawOperand  */
#line 2418 "CISA.y"
    {
        rawOperandArray[(yyvsp[-1].intval)++] = (VISA_RawOpnd*)(yyvsp[0].RawVar);
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5126 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 345: /* DstAddrOperand: AddrVarAccessWithWidth  */
#line 2426 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
          pBuilder->CISA_set_address_operand(
            (yyvsp[0].regAccess).cisa_decl, (yyvsp[0].regAccess).elem, (yyvsp[0].regAccess).row, true, CISAlineno));
    }
#line 5136 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 346: /* DstGeneralOperand: Var TwoDimOffset DstRegion  */
#line 2434 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_dst_general_operand(
            (yyvsp[-2].string), (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 5145 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 347: /* DstGeneralOperand: Var DstRegion  */
#line 2439 "CISA.y"
                  {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_dst_general_operand(
            (yyvsp[-1].string), 0, 0, (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 5154 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 348: /* DstIndirectOperand: IndirectVarAccess DstRegion DataType  */
#line 2445 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_indirect_dst(
            (yyvsp[-2].regAccess).cisa_decl, MODIFIER_NONE, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff, (unsigned short)(yyvsp[-1].intval), (yyvsp[0].type), CISAlineno));
    }
#line 5163 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 349: /* SrcAddrOfOperand: AddrOfVar  */
#line 2466 "CISA.y"
              {
         (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_set_address_expression((yyvsp[0].regAccess).cisa_decl, 0, CISAlineno);
    }
#line 5171 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 350: /* SrcAddrOfOperand: AddrOfVar LBRACK IntExp RBRACK  */
#line 2470 "CISA.y"
                                   {
         MUST_HOLD((short)(yyvsp[-1].intval) == (yyvsp[-1].intval), "variable address offset is too large");
         (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_set_address_expression((yyvsp[-3].regAccess).cisa_decl, (short)(yyvsp[-1].intval), CISAlineno);
    }
#line 5180 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 351: /* AddrOfVar: AMP Var  */
#line 2476 "CISA.y"
            {
        // Both GENERAL_VAR and SURFACE_VAR are addressable
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[0].string));
        if ((yyval.regAccess).cisa_decl == nullptr)
            PARSE_ERROR("unbound variable");
        (yyval.regAccess).row = 0;
        (yyval.regAccess).elem = 0;
    }
#line 5193 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 352: /* SrcAddrOperand: AddrVarAccessWithWidth  */
#line 2487 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_set_address_operand(
                (yyvsp[0].regAccess).cisa_decl, (yyvsp[0].regAccess).elem, (yyvsp[0].regAccess).row, false, CISAlineno));
    }
#line 5203 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 353: /* SrcGeneralOperand: Var TwoDimOffset SrcRegionDirect  */
#line 2495 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_gen_src_operand(
                (yyvsp[-2].string), (yyvsp[0].cisa_region).v_stride, (yyvsp[0].cisa_region).width, (yyvsp[0].cisa_region).h_stride, (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, MODIFIER_NONE, CISAlineno));
    }
#line 5213 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 354: /* SrcGeneralOperand: SrcModifier Var TwoDimOffset SrcRegionDirect  */
#line 2502 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_gen_src_operand(
                (yyvsp[-2].string), (yyvsp[0].cisa_region).v_stride, (yyvsp[0].cisa_region).width, (yyvsp[0].cisa_region).h_stride, (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, (yyvsp[-3].src_mod).mod, CISAlineno));
    }
#line 5223 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 355: /* SrcImmOperand: IntExpUnr DataTypeIntOrVector  */
#line 2512 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_immed((yyvsp[-1].intval), (yyvsp[0].type), CISAlineno);
    }
#line 5231 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 356: /* SrcImmOperand: HEX_LIT HFTYPE  */
#line 2517 "CISA.y"
                     {
        MUST_HOLD((yyvsp[-1].intval) < 0x10000, "literal too large for half float");
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_immed(
            (unsigned short)(yyvsp[-1].intval), ISA_TYPE_HF, CISAlineno);
    }
#line 5241 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 357: /* SrcImmOperand: FloatLit  */
#line 2525 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed((yyvsp[0].fltval), ISA_TYPE_F, CISAlineno);
    }
#line 5249 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 358: /* SrcImmOperand: MINUS FloatLit  */
#line 2528 "CISA.y"
                     {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed(-(yyvsp[0].fltval), ISA_TYPE_F, CISAlineno);
    }
#line 5257 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 359: /* SrcImmOperand: DoubleFloatLit  */
#line 2534 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed((yyvsp[0].fltval), ISA_TYPE_DF, CISAlineno);
    }
#line 5265 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 360: /* SrcImmOperand: MINUS DoubleFloatLit  */
#line 2538 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed(-(yyvsp[0].fltval), ISA_TYPE_DF, CISAlineno);
    }
#line 5273 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 362: /* FloatLit: DEC_LIT FTYPE  */
#line 2545 "CISA.y"
   {
        // "1:f" means 1.4e-45
        int number = (int)(yyvsp[-1].intval);
        float *fp = (float *)&number;
        (yyval.fltval) = *fp;
   }
#line 5284 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 363: /* FloatLit: HEX_LIT FTYPE  */
#line 2552 "CISA.y"
   {
        int number = (int)(yyvsp[-1].intval);
        float *fp = (float *)&number;
        (yyval.fltval) = *fp;
   }
#line 5294 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 365: /* DoubleFloatLit: DEC_LIT DFTYPE  */
#line 2560 "CISA.y"
                    {
        // "1:df" means 5e-324
        int64_t number = (yyvsp[-1].intval);
        double *fp = (double *)&number;
        (yyval.fltval) = *fp;
   }
#line 5305 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 366: /* DoubleFloatLit: HEX_LIT DFTYPE  */
#line 2566 "CISA.y"
                    {
        // to support 0x7ff0000000000000:df
        int64_t number = (yyvsp[-1].intval);
        double *fp = (double *)&number;
        (yyval.fltval) = *fp;
   }
#line 5316 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 367: /* SrcIndirectOperand: IndirectVarAccess SrcRegionIndirect DataType  */
#line 2577 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_indirect(
                (yyvsp[-2].regAccess).cisa_decl, MODIFIER_NONE, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff,
                (yyvsp[-1].cisa_region).v_stride, (yyvsp[-1].cisa_region).width, (yyvsp[-1].cisa_region).h_stride, (yyvsp[0].type), CISAlineno));
    }
#line 5327 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 368: /* SrcIndirectOperand: SrcModifier IndirectVarAccess SrcRegionIndirect DataType  */
#line 2585 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_indirect(
                (yyvsp[-2].regAccess).cisa_decl, (yyvsp[-3].src_mod).mod, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff,
                (yyvsp[-1].cisa_region).v_stride, (yyvsp[-1].cisa_region).width, (yyvsp[-1].cisa_region).h_stride, (yyvsp[0].type), CISAlineno));
    }
#line 5338 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 369: /* DstRegion: LANGLE IntExpNRA RANGLE  */
#line 2594 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
             "Dst HorzStride must be 0, 1, 2, or 4");
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5348 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 370: /* SrcRegionDirect: LANGLE IntExp SEMI IntExp COMMA IntExpNRA RANGLE  */
#line 2612 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-5].intval) == 0 || (yyvsp[-5].intval) == 1 || (yyvsp[-5].intval) == 2 || (yyvsp[-5].intval) == 4 || (yyvsp[-5].intval) == 8 || (yyvsp[-5].intval) == 16 || (yyvsp[-5].intval) == 32),
                 "Src Region VertStride must be 0, 1, 2, 4, 8, 16, or 32");
        MUST_HOLD(((yyvsp[-3].intval) == 0 || (yyvsp[-3].intval) == 1 || (yyvsp[-3].intval) == 2 || (yyvsp[-3].intval) == 4 || (yyvsp[-3].intval) == 8 || (yyvsp[-3].intval) == 16),
                 "Src Region Width must be 0, 1, 2, 4, 8 or 16");
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
                 "Src Region HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = (unsigned)(yyvsp[-5].intval);
        (yyval.cisa_region).width = (unsigned)(yyvsp[-3].intval);
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 5364 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 372: /* SrcRegionIndirect: LANGLE IntExp COMMA DEC_LIT RANGLE  */
#line 2629 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-3].intval) == 0 || (yyvsp[-3].intval) == 1 || (yyvsp[-3].intval) == 2 || (yyvsp[-3].intval) == 4 || (yyvsp[-3].intval) == 8 || (yyvsp[-3].intval) == 16),
                 "Width must be 0, 1, 2, 4, 8 or 16");
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
                 "HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = -1;
        (yyval.cisa_region).width = (unsigned)(yyvsp[-3].intval);
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 5378 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 373: /* SrcRegionIndirect: LANGLE IntExpNRA RANGLE  */
#line 2640 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
             "HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = -1;
        (yyval.cisa_region).width = -1;
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 5390 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 374: /* IndirectVarAccess: IND_LBRACK AddrVarAccess COMMA IntExp RBRACK  */
#line 2650 "CISA.y"
                                                 {
        (yyval.regAccess) = (yyvsp[-3].regAccess);
        (yyval.regAccess).immOff = (int)(yyvsp[-1].intval);
    }
#line 5399 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 375: /* IndirectVarAccess: IND_LBRACK AddrVarAccess RBRACK  */
#line 2655 "CISA.y"
                                                 {
          (yyval.regAccess) = (yyvsp[-1].regAccess);
          (yyval.regAccess).immOff = 0;
    }
#line 5408 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 376: /* TwoDimOffset: LPAREN IntExp COMMA IntExp RPAREN  */
#line 2660 "CISA.y"
                                                {
        MUST_HOLD((yyvsp[-3].intval) >= 0, "row (register) offset must be positive");
        (yyval.offset).row = (int)(yyvsp[-3].intval);
        MUST_HOLD((yyvsp[-1].intval) >= 0 && (yyvsp[-1].intval) <= 0xFFFF, "sub-register offset out of bounds");
        (yyval.offset).elem = (int)(yyvsp[-1].intval);
    }
#line 5419 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 377: /* PredVar: Var  */
#line 2668 "CISA.y"
        {
        (yyval.vISADecl) = pBuilder->CISA_find_decl((yyvsp[0].string));
        if ((yyval.vISADecl) == nullptr)
            PARSE_ERROR((yyvsp[0].string), ": undefined predicate variable");
        if ((yyval.vISADecl)->type != PREDICATE_VAR)
            PARSE_ERROR((yyvsp[0].string), ": not a predicate variable");
    }
#line 5431 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 378: /* AddrVarAccess: Var LPAREN IntExp RPAREN  */
#line 2677 "CISA.y"
                             {
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[-3].string));
        if ((yyval.regAccess).cisa_decl == nullptr) {
            PARSE_ERROR((yyvsp[-3].string), ": unbound variable");
        } else if ((yyval.regAccess).cisa_decl->type != ADDRESS_VAR) {
            PARSE_ERROR((yyvsp[-3].string), ": not an address variable");
        }
        (yyval.regAccess).row = 1;
        (yyval.regAccess).elem = (int)(yyvsp[-1].intval);
    }
#line 5446 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 379: /* AddrVarAccessWithWidth: Var LPAREN IntExp RPAREN LANGLE IntExpNRA RANGLE  */
#line 2689 "CISA.y"
                                                     {
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[-6].string));
        if ((yyval.regAccess).cisa_decl == nullptr) {
            PARSE_ERROR((yyvsp[-6].string), ": unbound variable");
        } else if ((yyval.regAccess).cisa_decl->type != ADDRESS_VAR) {
            PARSE_ERROR((yyvsp[-6].string), ": not an address variable");
        }
        (yyval.regAccess).row = (int)(yyvsp[-1].intval);
        (yyval.regAccess).elem = (int)(yyvsp[-4].intval);
    }
#line 5461 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 380: /* SIMDMode: %empty  */
#line 2703 "CISA.y"
           {(yyval.intval) = 0;}
#line 5467 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 381: /* SIMDMode: LPAREN DEC_LIT RPAREN  */
#line 2706 "CISA.y"
    {
       MUST_HOLD(((yyvsp[-1].intval) == 8 || (yyvsp[-1].intval) == 16 || (yyvsp[-1].intval) == 32),
                 "SIMD mode can only be 8, 16, or 32");
       (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5477 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 382: /* ElemNum: DOT DEC_LIT  */
#line 2717 "CISA.y"
    {
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 5485 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 383: /* ExecSize: LPAREN ExecSizeInt RPAREN  */
#line 2729 "CISA.y"
    {
        (yyval.emask_exec_size).emask = vISA_EMASK_M1;
        (yyval.emask_exec_size).exec_size = (int)(yyvsp[-1].intval);
    }
#line 5494 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 384: /* ExecSize: LPAREN Var COMMA ExecSizeInt RPAREN  */
#line 2735 "CISA.y"
    {
        if (!ParseEMask(pBuilder, (yyvsp[-3].string), (yyval.emask_exec_size).emask)) {
            PARSE_ERROR("invalid execution offset info");
        }
        (yyval.emask_exec_size).exec_size = (int)(yyvsp[-1].intval);
    }
#line 5505 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 385: /* ExecSizeInt: DEC_LIT  */
#line 2743 "CISA.y"
    {
        if ((yyvsp[0].intval) != 1 && (yyvsp[0].intval) != 2 && (yyvsp[0].intval) != 4 && (yyvsp[0].intval) != 8 && (yyvsp[0].intval) != 16 && (yyvsp[0].intval) != 32) {
            PARSE_ERROR("invalid execution size");
        }
        (yyval.intval) = (unsigned short)(yyvsp[0].intval);
    }
#line 5516 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 391: /* IntExpCond: IntExpAND QUESTION IntExpAND COLON IntExpCond  */
#line 2757 "CISA.y"
                                                    {(yyval.intval) = (yyvsp[-4].intval) ? (yyvsp[-2].intval) : (yyvsp[0].intval);}
#line 5522 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 393: /* IntExpAND: IntExpAND AMP IntExpXOR  */
#line 2760 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) & (yyvsp[0].intval);}
#line 5528 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 395: /* IntExpXOR: IntExpXOR CIRC IntExpOR  */
#line 2763 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) ^ (yyvsp[0].intval);}
#line 5534 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 397: /* IntExpOR: IntExpOR PIPE IntExpCmp  */
#line 2766 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) | (yyvsp[0].intval);}
#line 5540 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 399: /* IntExpCmp: IntExpRel EQ IntExpRel  */
#line 2769 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) == (yyvsp[0].intval);}
#line 5546 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 400: /* IntExpCmp: IntExpRel NEQ IntExpRel  */
#line 2770 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) != (yyvsp[0].intval);}
#line 5552 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 402: /* IntExpRel: IntExpNRA LANGLE IntExpNRA  */
#line 2773 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) < (yyvsp[0].intval);}
#line 5558 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 403: /* IntExpRel: IntExpNRA RANGLE IntExpNRA  */
#line 2774 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) > (yyvsp[0].intval);}
#line 5564 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 404: /* IntExpRel: IntExpNRA LEQ IntExpNRA  */
#line 2775 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) <= (yyvsp[0].intval);}
#line 5570 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 405: /* IntExpRel: IntExpNRA GEQ IntExpNRA  */
#line 2776 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) >= (yyvsp[0].intval);}
#line 5576 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 408: /* IntExpShift: IntExpAdd SHL IntExpAdd  */
#line 2797 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) << (yyvsp[0].intval);}
#line 5582 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 409: /* IntExpShift: IntExpAdd SHRS IntExpAdd  */
#line 2798 "CISA.y"
                               {(yyval.intval) = (int64_t)(yyvsp[-2].intval) >> (int)(yyvsp[0].intval);}
#line 5588 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 410: /* IntExpShift: IntExpAdd SHRZ IntExpAdd  */
#line 2799 "CISA.y"
                               {(yyval.intval) = (int64_t)((uint64_t)(yyvsp[-2].intval) >> (uint64_t)(yyvsp[0].intval));}
#line 5594 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 412: /* IntExpAdd: IntExpAdd PLUS IntExpMul  */
#line 2802 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) + (yyvsp[0].intval);}
#line 5600 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 413: /* IntExpAdd: IntExpAdd MINUS IntExpMul  */
#line 2803 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) - (yyvsp[0].intval);}
#line 5606 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 415: /* IntExpMul: IntExpMul TIMES IntExpUnr  */
#line 2806 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) * (yyvsp[0].intval);}
#line 5612 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 416: /* IntExpMul: IntExpMul SLASH IntExpUnr  */
#line 2807 "CISA.y"
                                {
            if ((yyvsp[0].intval) == 0)
                PARSE_ERROR("division by 0");
            (yyval.intval) = (yyvsp[-2].intval) / (yyvsp[0].intval);
        }
#line 5622 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 417: /* IntExpMul: IntExpMul PERCENT IntExpUnr  */
#line 2812 "CISA.y"
                                  {
            if ((yyvsp[0].intval) == 0)
                PARSE_ERROR("division by 0");
            (yyval.intval) = (yyvsp[-2].intval) % (yyvsp[0].intval);
        }
#line 5632 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 419: /* IntExpUnr: MINUS IntExpUnr  */
#line 2819 "CISA.y"
                      {(yyval.intval) = -(yyvsp[0].intval);}
#line 5638 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 420: /* IntExpUnr: TILDE IntExpUnr  */
#line 2820 "CISA.y"
                      {(yyval.intval) = ~(yyvsp[0].intval);}
#line 5644 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 421: /* IntExpUnr: BANG IntExpUnr  */
#line 2821 "CISA.y"
                      {(yyval.intval) = !((yyvsp[0].intval));}
#line 5650 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 425: /* IntExpPrim: LPAREN IntExp RPAREN  */
#line 2829 "CISA.y"
                           {(yyval.intval) = (yyvsp[-1].intval);}
#line 5656 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 426: /* IntExpPrim: BUILTIN_SIZEOF IDENT  */
#line 2833 "CISA.y"
                           {
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[0].string), (yyval.intval)));
    }
#line 5665 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 427: /* IntExpPrim: BUILTIN_SIZEOF LPAREN IDENT RPAREN  */
#line 2837 "CISA.y"
                                         {
        // TODO: %AlignOf(...), %Max(..)
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-1].string), (yyval.intval)));
    }
#line 5675 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 428: /* IntExpPrim: BUILTIN_DISPATCH_SIMD_SIZE  */
#line 2843 "CISA.y"
                                 {
        // e.g. %DispatchSimdSize
        // N.B. %sizeof happens above
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_lookup_builtin_constant(CISAlineno, "%DispatchSimd", (yyval.intval)));
    }
#line 5686 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;


#line 5690 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.9933/redhat-linux-build/IGC/visa/CISA.tab.cpp"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (pBuilder, yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, pBuilder);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, pBuilder);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (pBuilder, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, pBuilder);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, pBuilder);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 2861 "CISA.y"

///////////////////////////////////////////////////////////////////////////////
//                                                                           //
//                        Utility Functions                                  //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////

void CISAerror(CISA_IR_Builder* pBuilder, char const *s)
{
    pBuilder->RecordParseError(CISAlineno, s);
}

static bool ParseAlign(CISA_IR_Builder* pBuilder, const char *sym, VISA_Align &value)
{
    if (strcmp(sym, "byte") == 0) {
        value = ALIGN_BYTE;
    } else if (strcmp(sym, "word") == 0) {
        value = ALIGN_WORD;
    } else if (strcmp(sym, "dword") == 0) {
        value = ALIGN_DWORD;
    } else if (strcmp(sym, "qword") == 0) {
        value = ALIGN_QWORD;
    } else if (strcmp(sym, "oword") == 0) {
        value = ALIGN_OWORD;
    } else if (strcmp(sym, "GRF") == 0) {
        value = ALIGN_GRF;
    } else if (strcmp(sym, "GRFx2") == 0 || strcmp(sym, "2GRF") == 0) {
        value = ALIGN_2_GRF;
    } else if (strcmp(sym, "hword") == 0) {
        value = ALIGN_HWORD;
    } else if (strcmp(sym, "wordx32") == 0) {
        value = ALIGN_32WORD;
    } else if (strcmp(sym, "wordx64") == 0) {
        value = ALIGN_64WORD;
    } else {
        value = ALIGN_UNDEF;
        return false;
    }
    return true;
}


static VISA_Align AlignBytesToVisaAlignment(int bytes)
{
    VISA_Align val = ALIGN_UNDEF;
    switch (bytes) {
    case 1:   val = ALIGN_BYTE; break;
    case 2:   val = ALIGN_WORD; break;
    case 4:   val = ALIGN_DWORD; break;
    case 8:   val = ALIGN_QWORD; break;
    case 16:  val = ALIGN_OWORD; break;
    case 32:  val = ALIGN_HWORD; break;
    case 64:  val = ALIGN_32WORD; break;
    case 128: val = ALIGN_64WORD; break;
    default:  val = ALIGN_UNDEF; break;
    }
    return val;
}



static bool ParseEMask(
    CISA_IR_Builder* pBuilder,
    const char* sym,
    VISA_EMask_Ctrl &emask)
{
    if (strcmp(sym, "NoMask") == 0) {
        emask = vISA_EMASK_M1_NM;
        return true;
    }
    for (int i = 0; i < vISA_NUM_EMASK +1; i++)
    {
        if (!strcmp(emask_str[i], sym))
        {
            emask = (VISA_EMask_Ctrl)i;
            return true;
        }
    }

    emask = vISA_NUM_EMASK;
    return false;
}

static int lscCheckExecSize(
    LSC_SFID sfid,
    LSC_OP op,
    LSC_DATA_ORDER data_order,
    int exec_size)
{
    int is_vector_op =
        op != LSC_LOAD_BLOCK2D &&
        op != LSC_STORE_BLOCK2D;
        // other ops like LSC_LOAD_SURFACE_INFO may be SIMD1
    if (op == LSC_READ_STATE_INFO) {
        exec_size = 1;
    } else if (data_order == LSC_DATA_ORDER_NONTRANSPOSE && is_vector_op) {
        if (exec_size == UNDEFINED_EXEC_SIZE) {
            if (getGenxPlatform() == Xe_DG2) // for DG2 typed is 8, untyped is 16
                exec_size = sfid == LSC_TGM ? 8 : 16;
            else if (getGenxPlatform() >= Xe_PVC) // on PVC typed is 16, untyped is 32
                exec_size = sfid == LSC_TGM ? 16 : 32;
            else
                exec_size = 32; // the world is finally sane
        }
    } else {
        // block and transpose get SIMD by default
        if (exec_size == UNDEFINED_EXEC_SIZE) {
           exec_size = 1; // transpose is implicitly 1 if needed
        }
    }
    return exec_size;
}
